Package: tkWidgets
Version: 1.90.0
Title: R based tk widgets
Author: J. Zhang <jzhang@jimmy.harvard.edu>
Maintainer: J. Zhang <jzhang@jimmy.harvard.edu>
Depends: R (>= 2.0.0), methods, widgetTools (>= 1.1.7), DynDoc (>=
        1.3.0), tools
Suggests: Biobase, hgu95av2
Description: Widgets to provide user interfaces. tcltk should have
        been installed for the widgets to run.
LazyLoad: yes
biocViews: Infrastructure
Keyword: graphics
License: Artistic-2.0
git_url: https://git.bioconductor.org/packages/tkWidgets
git_branch: RELEASE_3_23
git_last_commit: 82dbb93
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 01:11:31 UTC; biocbuild

# This function prints the values for the Name, Value, canEdit, and
# buttonText of a value containing widget element on the widget
# created by using the function widgetRender.
#
# Copyright J. Zhang 2002, all rights reserved.
#
print.pWidget <- function (x, ...){
    print(paste("Name = ", WName(x), ";", sep = ""))
    print(paste("Value = ", WValue(x), ";", sep = ""))
    print(paste("canEdit = ", WcanEdit(x), ";", sep = ""))
    if(!is.null(WbuttonFun(x)))
       print(paste("buttonText = ", WbuttonText(x), ";", sep = ""))
    # For now we just print the other prameters as a vector. Will do
    # more later.
    if(length(unlist(list(...))) > 0)
        unlist(list(...))
}

tkphenoData <- function(sampleNames){
  eerieEnv <- new.env()

  sample.length <- length(sampleNames)

#############################################
#hierarchy of widgets
#############################################

  NumWidgets <- 5 #number of widgets
  hierarchy <- list()
  for(i in 1:NumWidgets){
    hierarchy[[i]] <-function(){}
  }


#############################################
###third widget -- Main widget
#############################################
  hierarchy[[3]] <- function(){



    tt3 <- tktoplevel(width = 30)
    tkconfigure(tt3, background = "white")
    tktitle(tt3) <- "Pheno Data"

    tbar.fr <- tkframe(tt3,relief="sunken",borderwidth=5,width="5i")
    win.fr <- tkframe(tt3,relief="sunken",borderwidth=5,width="5i",height="7i")
    tkconfigure(win.fr, background = "white")
    tkpack(tbar.fr,side="top",fill="x")
    tkpack(win.fr,side="top", fill="both")

    assign("NumSamples", sample.length,eerieEnv)
    assign("NumCovar",get("NumCovariates",eerieEnv),eerieEnv)
    assign("NewNumCovariates",as.numeric(tclvalue(get("NewNumCovariates.var",eerieEnv))),eerieEnv)
    assign("OldNumCovariates1",as.numeric(tclvalue(get("OldNumCovariates1.var",eerieEnv))),eerieEnv)

    array.name.lst <-list()
    array.entry.lst <- list()

    cb.lst <- list()
    if(!is.na(match("var.lst",ls(eerieEnv)))){
      assign("var.lst", get("var.lst",eerieEnv),eerieEnv)}
    else{
      assign("var.lst", list(),eerieEnv)
      for(i in 1:get("NumSamples",eerieEnv)) {
        assign("var",tclVar(sampleNames[i]),eerieEnv)
        assign("var.lst",c(get("var.lst",eerieEnv),list(get("var",eerieEnv))),eerieEnv)
        ## assign(tclvalue(get("var.lst",eerieEnv)[[i]]),sampleNames[i],eerieEnv)
      }}
    if(get("OldNumCovariates1",eerieEnv) != get("NumCovariates",eerieEnv)){
      assign("cov.lst",list(),eerieEnv)

      for(i in 1:get("NumSamples",eerieEnv)){
        assign("dummy.lst",list(),eerieEnv)
        for(j in 1:get("NumCovar",eerieEnv)){
          assign("dummy.var",tclVar(),eerieEnv)
          assign("dummy.lst",c(get("dummy.lst",eerieEnv),list(get("dummy.var",eerieEnv))),eerieEnv)}
        assign("cov.lst",c(get("cov.lst",eerieEnv),list(get("dummy.lst",eerieEnv))),eerieEnv)
      }


      ##for(i in 1:get("NumSamples",eerieEnv)){
      ##  assign(get("cov.lst",eerieEnv)[[i]],list(),eerieEnv)
      ##  for(j in 1:get("NumCovar",eerieEnv)){
      ##       assign("array.cov",tclVar(),eerieEnv)
      ##       assign(get("cov.lst",eerieEnv)[[i]],c(get("cov.lst",eerieEnv)[[i]],list(get("array.cov",eerieEnv))),eerieEnv)
      ##     }
    }
    else{
      if(!is.na(match("cov.lst",ls(eerieEnv)))){
        assign("cov.lst","cov.lst",eerieEnv)}
      else{
        assign("cov.lst",list(),eerieEnv)

        for(i in 1:get("NumSamples",eerieEnv)){
          assign("dummy.lst",list(),eerieEnv)
          for(j in 1:get("NumCovar",eerieEnv)){
            assign("dummy.var",tclVar(),eerieEnv)
            assign("dummy.lst",c(get("dummy.lst",eerieEnv),list(get("dummy.var",eerieEnv))),eerieEnv)}
          assign("cov.lst",c(get("cov.lst",eerieEnv),list(get("dummy.lst",eerieEnv))),eerieEnv)
        }


        ##for(i in 1:get("NumSamples",eerieEnv)){
        ##  assign(get("cov.lst",eerieEnv)[[i]],list(),eerieEnv)
        ##  for(j in 1:get("NumCovar",eerieEnv)){
        ##       assign("array.cov",tclVar(),eerieEnv)
        ##       assign(get("cov.lst",eerieEnv)[[i]],c(get("cov.lst",eerieEnv)[[i]],list(get("array.cov",eerieEnv))),eerieEnv)
        ##q()

      }}
    ##array.var <<- list()

    space.label1 <- tklabel(win.fr, text = "")
    tkconfigure(space.label1, background = "white")
    space.label2 <- tklabel(win.fr, text = "")
    tkconfigure(space.label2, background = "white")
    space.label3 <- tklabel(win.fr, text = "")
    tkconfigure(space.label3, background = "white")
    space.label4 <- tklabel(win.fr, text = "")
    tkconfigure(space.label4, background = "white")
    space.label5 <- tklabel(win.fr, text = "")
    tkconfigure(space.label5, background = "white")
    tkgrid(space.label1,row = 1)

    array.entry.lst <- tklabel(win.fr, text="Sample Names")
    tkconfigure(array.entry.lst, background = "white")
    tkgrid(array.entry.lst, row = 2, column = 2)


    for(j in 1:get("NumCovar",eerieEnv)) {
      cb.lst <- tklabel(win.fr, text = tclvalue(get("cov.name.lst",eerieEnv)[[j]]))
      tkconfigure(cb.lst, background = "white")
      tkgrid(cb.lst, row = 2, column = (j+3))
    }

    for(i in 1:get("NumSamples",eerieEnv)){
      array.name.lst <-tklabel(win.fr, text=paste("Array",i))
      tkconfigure(array.name.lst, background = "white")
      tkgrid(array.name.lst, row = (i+2), column = 1)


      array.entry.lst [[i]]<- tkentry(win.fr, width = 30, textvariable
      = get("var.lst",eerieEnv)[[i]], state = "disabled")
      tkconfigure(array.entry.lst[[i]], background = "white")
      tkgrid(array.entry.lst[[i]], row = (i+2), column = 2)
      tkgrid.configure(array.entry.lst[[i]], sticky = "e")

      for(j in 1:get("NumCovar",eerieEnv)){
        cb.lst[[j]] <- tkentry(win.fr, width=6,textvariable = get("cov.lst",eerieEnv)[[i]][[j]])
        tkconfigure(cb.lst[[j]], background = "white")
        tkgrid(cb.lst[[j]], row = (i+2), column =(j+3))
      }
    }
    tkgrid(space.label3)
#    tkgrid(space.label4)
#    tkgrid(space.label5)

#    tkgrid(space.label3,row=(get("NumSamples",eerieEnv)+3))
#    tkgrid(space.label4,row=(get("NumSamples",eerieEnv)+4))
#    tkgrid(space.label5,row=(get("NumSamples",eerieEnv)+5))

    ###### JZ add this to save the AnnotatedDataFrame object to .Global Env
    saveFrame <- tkframe(win.fr, background = "white")
    tkpack(tklabel(saveFrame, text = "Save AnnotatedDataFrame as", background = "white"),
           side = "left", expand = FALSE)
    pdName <- tclVar("")
    pdNameEntry <- tkentry(saveFrame, width = 40, textvariable = pdName,
                           background = "white")
    tkpack(pdNameEntry, side = "left", expand = TRUE, fill = "x")
    tkgrid(saveFrame, pady = 5, columnspan = j + 4)
    ######

    ## JZ modified the layout a little bit
    butFrame <- tkframe(win.fr)
    back.but <- tkbutton(butFrame, width = 8, text ="Back", command = function(){
      tkdestroy(tt3)
      hierarchy[[2]]()})
    tkconfigure(back.but, background = "white")
    finish.but <- tkbutton(butFrame, text = "Continue", command = function(){

      for(i in 1:get("NumSamples",eerieEnv)){
        for(j in 1:get("NumCovar",eerieEnv)){
          if(tclvalue(get("cov.lst",eerieEnv)[[i]][[j]])==""){
            assign("error", "Missing Entry",eerieEnv)
          }
        }
      }

      if(get("error",eerieEnv)=="Missing Entry"){
        assign("error","just for a change!!",eerieEnv)
        error.fr <-tkframe(tt3, borderwidth = 5, width = "5i", height = "2i")
        tkconfigure(error.fr, background = "yellow")
        tkpack(error.fr,side="top", fill="both")
        error.lbl <- tklabel(error.fr, text = "Error! Missing Entry in Phenodata")
        tkconfigure(error.lbl, background = "yellow")
        tkpack(error.lbl)
        error.but <- tkbutton(error.fr,text="OK",command = function(){tkdestroy(error.fr)})
        tkconfigure(error.but, background = "yellow")
        tkpack(error.but)
      }

      else{
        tkdestroy(tt3)
        tkdestroy(win.fr)
      }

    })

    tkconfigure(finish.but, background = "white")
    tkpack(back.but, side = "left", expand = FALSE)
    tkpack(finish.but, side = "left", expand = FALSE)

#    tkgrid(back.but, row = (get("NumSamples",eerieEnv) + 7),column = 2)
#    tkgrid(finish.but, row = (get("NumSamples",eerieEnv) + 7), column = 3)
#    tkgrid.configure(back.but, sticky = "e")
#    tkgrid.configure(finish.but, sticky = "w")
    tkgrid(butFrame, columnspan = j + 4)


    tkwait.window(tt3)

    pd.matrix <- matrix(NA,nrow=length(sampleNames),ncol=get("NumCovar",eerieEnv))
    rownames(pd.matrix) <- sampleNames

    c.names <- array("",get("NumCovar",eerieEnv))
    for(j in 1:get("NumCovar",eerieEnv)){
      c.names[j] <- tclvalue(get("cov.name.lst",eerieEnv)[[j]])}
    colnames(pd.matrix) <- c.names
    for(i in 1:length(sampleNames)){
      for(j in 1:get("NumCovar",eerieEnv)){
        pd.matrix[i,j] <- tclvalue(get("cov.lst",eerieEnv)[[i]][[j]])}}

    desc.matrix <- matrix("",nrow=get("NumCovar",eerieEnv),ncol=1)
    rownames(desc.matrix) <- c.names
    colnames(desc.matrix) <- "Description"

    for(i in 1:get("NumCovar",eerieEnv)){
      desc.matrix[i,1] <- tclvalue(get("desc.lst",eerieEnv)[[i]])}
    pd.info <- list(pd.matrix,desc.matrix)
    names(pd.info) <- c("pData", "varLabels")

    assign("pd.info",pd.info,eerieEnv)
    if(tclvalue(pdName) != ""){
        assign(tclvalue(pdName), pd.info, .GlobalEnv)
    }
}





##############################################
### second widget
##############################################

  hierarchy[[2]] <- function(){

    assign("backCount1",0,eerieEnv)

    if(!is.na(match("NewNumCovariates.var",ls(eerieEnv)))){
      assign("OldNumCovariates.var",get("NewNumCovariates.var",eerieEnv),eerieEnv)
    }



    tt2 <- tktoplevel(width = 70)
    tktitle(tt2) <- "Covariate Names"
    tkconfigure(tt2, background = "white")

    tbar.fr <- tkframe(tt2,relief="sunken",borderwidth=5,width="5i")
    win.fr <- tkframe(tt2,relief="sunken",borderwidth=5,width="5i",height="7i")
    tkconfigure(win.fr, background = "white")
    tkpack(tbar.fr,side="top",fill="x")
    tkpack(win.fr,side="top", fill="both")

    assign("NumCovariates", as.numeric(tclvalue(get("NumCovariates.var",eerieEnv))),eerieEnv)
    assign("OldNumCovariates",as.numeric(tclvalue(get("OldNumCovariates.var",eerieEnv))),eerieEnv)

    if(!is.na(match("OldNumCovariates1.var",ls(eerieEnv)))){
      assign("OldNumCovariates1.var", get("OldNumCovariates1.var",eerieEnv),eerieEnv)}
    else{
      assign("OldNumCovariates1.var", tclVar(0),eerieEnv)
    }
    assign("cov.name.lst",list(),eerieEnv)
    if(get("OldNumCovariates",eerieEnv) != get("NumCovariates",eerieEnv)){
      for(i in 1:get("NumCovariates",eerieEnv)){
        assign("cov.name", tclVar(""),eerieEnv)
        assign("cov.name.lst",c(get("cov.name.lst",eerieEnv),list(get("cov.name",eerieEnv))),eerieEnv)
      }}
    else{
      if(!is.na(match("cov.name.lst",ls(eerieEnv)))){
        # Changed by Jianhua Zhang from the line commented below
        #assign("cov.name.lst", cov.name.label,eerieEnv)}
        assign("cov.name.lst", get("cov.name.label", eerieEnv),eerieEnv)}
      else{
        for(i in 1:get("NumCovariates",eerieEnv)){
          assign("cov.name", tclVar(""),eerieEnv)
          assign("cov.name.lst",c(get("cov.name.lst",eerieEnv),list(get("cov.name",eerieEnv))),eerieEnv)
        }  }}

    cov.entry.lst <- list()

    assign("desc.lst",list(),eerieEnv)
    if(get("OldNumCovariates",eerieEnv) != get("NumCovariates",eerieEnv)){
      for(i in 1:get("NumCovariates",eerieEnv)){
        assign("descvar",tclVar(""),eerieEnv)
        assign("desc.lst",c(get("desc.lst",eerieEnv),list(get("descvar",eerieEnv))),eerieEnv)}
    }
    else{
      if(!is.na(match("desc.lst",ls(eerieEnv)))){
        #Changed by John from the line commented out 
        #assign("desc.lst",desc.lst,eerieEnv)}
        assign("desc.lst",get("desc.lst", eerieEnv),eerieEnv)}
      else{
        for(i in 1:get("NumCovariates",eerieEnv)){
          assign("descvar",tclVar(""),eerieEnv)
          assign("desc.lst",c(get("desc.lst",eerieEnv),list(get("descvar",eerieEnv))),eerieEnv)}
      }}

    desc.entry <- list()

    space.label1 <- tklabel(win.fr, text = "")
    tkconfigure(space.label1, background = "white")
    space.label2 <- tklabel(win.fr, text = "")
    tkconfigure(space.label2, background = "white")
    space.label3 <- tklabel(win.fr, text = "")
    tkconfigure(space.label3, background = "white")


    tkgrid(space.label1, row = 1)

    for(i in 1:get("NumCovariates",eerieEnv)){

      cov.label <-tklabel(win.fr, text=paste("Cov",i))
      tkconfigure(cov.label, background = "white")
      tkgrid(cov.label, row = (i+2), column = 1)

      cov.entry.lst[[i]] <- tkentry(win.fr, width = 30, textvariable = get("cov.name.lst",eerieEnv)[[i]])
      tkconfigure(cov.entry.lst[[i]], background = "white")
      tkgrid(cov.entry.lst[[i]], row = (i+2), column = 2)

      covtop.label <-tklabel(win.fr, text="Covariate Names")
      tkconfigure(covtop.label, background = "white")
      tkgrid(covtop.label, row=2, column = 2)

      desc.label <- tklabel(win.fr, text = "Description")
      tkconfigure(desc.label, background = "white")
      tkgrid(desc.label, row=2, column = 3)

      desc.entry[[i]] <- tkentry(win.fr, width = 30, textvariable = get("desc.lst",eerieEnv)[[i]])
      tkconfigure(desc.entry[[i]], background = "white")
      tkgrid(desc.entry[[i]], row = (i+2), column = 3)
    }


    but1 <- tkbutton(win.fr, width = 8,text = "Back", command = function(){
      assign("backCount1",1,eerieEnv)
      tkdestroy(tt2)
      hierarchy[[1]]()})
    tkconfigure(but1, background = "white")
    but2 <- tkbutton(win.fr,text = "Continue",command= function(){

      for(i in 1:get("NumCovariates",eerieEnv)){
        if(tclvalue(get("cov.name.lst",eerieEnv)[[i]]) == ""){
          assign("error","Missing Entry",eerieEnv)}
      }

      if(get("error",eerieEnv)=="Missing Entry"){
        assign("error", "just for a change1!!",eerieEnv)
        error.fr <-tkframe(tt2, borderwidth = 5, width = "5i", height = "2i")
        tkconfigure(error.fr, background = "yellow")
        tkpack(error.fr,side="top", fill="both")
        error.lbl <- tklabel(error.fr, text = "Error! Missing Entry in Covariate Names")
        tkconfigure(error.lbl, background = "yellow")
        tkpack(error.lbl)
        error.but <- tkbutton(error.fr,text="OK",command = function(){tkdestroy(error.fr)})
        tkconfigure(error.but, background = "yellow")
        tkpack(error.but)
      }else{
        assign("NewNumCovariates.var",get("OldNumCovariates.var",eerieEnv),eerieEnv)
        assign("OldNumCovariates.var", get("NumCovariates.var",eerieEnv),eerieEnv)
        tkdestroy(tt2)
        hierarchy[[3]]()
      }})

    tkconfigure(but2, background = "white")

    tkgrid(space.label2,row = (get("NumCovariates",eerieEnv) + 5))
    tkgrid(space.label3,row = (get("NumCovariates",eerieEnv) + 6))
    tkgrid(but1,row = (get("NumCovariates",eerieEnv) + 7),column = 2)
    tkgrid(but2,row = (get("NumCovariates",eerieEnv) + 7), column = 3)
    tkgrid.configure(but1,sticky="e")
    tkgrid.configure(but2,sticky="w")


    tkwait.window(tt2)

    assign("OldNumCovariates1", as.numeric(tclvalue(get("OldNumCovariates1.var",eerieEnv))),eerieEnv)
  }

###############################################
###first widget
###############################################


  hierarchy[[1]] <- function(){


    tt1 <- tktoplevel(width = "5i")
    tkconfigure(tt1, background = "white")
    tktitle(tt1) <- "Number of Covariates"

    tbar.fr <- tkframe(tt1,relief="sunken",borderwidth=5,width="5i")
    win.fr <- tkframe(tt1,relief="sunken",borderwidth=5,width="5i",height="7i")
    tkconfigure(win.fr, background = "white")
    tkpack(tbar.fr,side="top",fill="x")
    tkpack(win.fr,side="top", fill="both")

    NumCovariates.label <- tklabel(win.fr, text="Enter the Number Of Covariates")
    tkconfigure(NumCovariates.label, background = "white")

    ##taking care of the back button( ie. once some value is assigned it remains unless changed by th user)
    if(!is.na(match("OldNumCovariates.var",ls(eerieEnv)))){
      assign("OldNumCovariates.var",get("OldNumCovariates.var",eerieEnv),eerieEnv)}
    else{
      assign("OldNumCovariates.var", tclVar(0),eerieEnv)
    }
    if(!is.na(match("NumCovariates.var",ls(eerieEnv)))){
      assign(" NumCovariates.var",get("NumCovariates.var",eerieEnv),eerieEnv)}
    else{
      assign("NumCovariates.var", tclVar(),eerieEnv)
    }

    NumCovariates.entry <- tkentry(win.fr, width = 6,textvariable = get("NumCovariates.var",eerieEnv))
    tkconfigure(NumCovariates.entry, background = "white")

    but1 <- tkbutton(win.fr,text = "Continue",command=function(){
      assign("error", "none", eerieEnv)
      if(tclvalue(get("NumCovariates.var",eerieEnv)) < 1){
        assign("error","Error!! Number of covariates should be atleast one",eerieEnv)
        error.fr <-tkframe(tt1, borderwidth = 5, width = "5i", height = "2i")
        tkconfigure(error.fr, background = "yellow")
        tkpack(error.fr,side="top", fill="both")
        error.lbl <- tklabel(error.fr, text = get("error",eerieEnv))
        tkconfigure(error.lbl, background = "yellow")
  tkpack(error.lbl)
        error.but <- tkbutton(error.fr,text="OK",command = function(){tkdestroy(error.fr)})
        tkconfigure(error.but, background = "yellow")
        tkpack(error.but)
      }
      else {
        tkdestroy(win.fr)
        tkdestroy(tt1)
      }})

    tkconfigure(but1, background = "white")

    space.label1 <- tklabel(win.fr, text = "")
    tkconfigure(space.label1, background = "white")
    space.label2 <- tklabel(win.fr, text = "")
    tkconfigure(space.label2, background = "white")
    space.label3 <- tklabel(win.fr, text = "")
    tkconfigure(space.label3, background = "white")
    space.label4 <- tklabel(win.fr, text = "")
    tkconfigure(space.label4, background = "white")
    space.label5 <- tklabel(win.fr, text = "")
    tkconfigure(space.label5, background = "white")


    tkgrid(space.label1, row =1)
    tkgrid(space.label2, row =2)
    tkgrid(NumCovariates.label, row = 3, column = 1)
    tkgrid(NumCovariates.entry, row = 3, column =2)
    tkgrid(space.label3, row =4)
    tkgrid(space.label4, row =5)
    tkgrid(but1, row = 6, column = 1)
    tkgrid(space.label5, row =7)

    tkwait.window(tt1)
    hierarchy[[2]]()



  }


  hierarchy[[1]]()



  return(get("pd.info",eerieEnv))
}

.onLoad <- function(libname, pkgname) {
    require("methods", quietly=TRUE) || stop("Package methods unavailable")
    require("widgetTools", quietly = TRUE) ||
                     stop("Package widgetTools unavailable!")
    require("DynDoc", quietly=TRUE) || stop("Package DynDoc unavailable")
    if(.Platform$OS.type == "windows" && require(Biobase) && interactive()
        && .Platform$GUI ==  "Rgui"){
        addVigs2WinMenu("tkWidgets")
    }
}

# This function prints the values for the Name, Value, canEdit, and
# buttonText of all the value containing widget elements on the widget
# created by using the function widgetRender.
#
# Copyright J. Zhang 2002, all rights reserved.
#
print.Widget <- function (x, ...){

    wList <- WwList(x)
    for(i in names(wList)) {
        pW <- wList[[i]]
        print(paste("widget_", i, ":", sep = ""))
        class(pW) <- "pWidget"
        print.pWidget(pW)
    }
    # for now we just the other parameters as a vector. Will do more later.
    if(length(unlist(list(...))) > 0)
        unlist(list(...))
}

# This function takes a argument list returned by formals(R function)
# and creates a widget that allows users to manipulate the values
# using an interface.
#
# Copyright 2002, J. Zhang, all rights reserved
#

argsWidget <- function(argsList, defaultNames = c("OK", "Cancel"),
                       inst = ""){

#    if(is.pairlist(argsList)){
        # as.list does not work.
#        temp <- list()
#        for(i in names(argsList)){
#            temp[[i]] <- argsList[[i]]
#        }
#        argsList <- temp
#    }

    # Arguments that are functions
    funcs <- getSymbol(argsList)
    # Conver functions to characters
    tempList <- as.list(sapply(funcs2Char(argsList, funcs), formatArg))
    # Constructs the interface
    # Sets the working environment
    PWEnv <- new.env(hash = TRUE, parent = emptyenv())
    pWidgets <- getPWidget(tempList, PWEnv, inst)
    widget <- widget(wTitle = "BioC Arguments Widget", pWidgets,
                     funs = list(), preFun = function() {},
                     postFun = function() {}, env = PWEnv,
                     defaultNames = defaultNames)
    if(!is.null(widget)){
        # Returns the input values
        for(i in names(argsList)){
            if(any(i == names(funcs))){
                argsList[[i]] <-
                    get(wValue(pWidgets(widget)[[i]][["entry"]])[[1]])
            }else{
                argsList[[i]] <-
                    formatArg(wValue(pWidgets(widget)[[i]][["entry"]])[[1]])
            }
        }
        return(argsList)
    }else{
        return(widget)
    }
#    return(argsList)
}
# Creates the primary widget list for building the interface
getPWidget <- function(argsList, PWEnv, inst = ""){
    # takes care of ""
    argsList[argsList[] == ""] <- ""
    # Figures out the width for lables
    lWidth <- max(nchar(names(argsList)))
    pWidgets <- list()

    if(inst != ""){
        label <- label(wName = "label", wValue = inst,
                       wWidth = nchar(inst), wEnv = PWEnv)
        tempList <- list()
        tempList[["label"]] <- label
        pWidgets[["inst"]] <- tempList
    }

    for(i in names(argsList)){
        tempList <- list()
        # Creates radio buttons with TRUE and FALSE if the default
        # value for an argument is either a TRUE or FALSE
        if(is.logical(argsList[[i]]) && !is.na(argsList[[i]])){
            eval(substitute(j <- radioButton(wName = j,
                     wValue = c("TRUE" = TRUE,"FALSE" = FALSE),
                     wEnv = PWEnv), list(j = i)))
        }else{
            eval(substitute(j <- entryBox(wName = j,
                                 wValue = argsList[[j]],
                                 wWidth = 15, wEnv = PWEnv), list(j = i)))

        }
        label <- label(wName = "label", wValue = i,
                                             wWidth = lWidth, wEnv = PWEnv)
        tempList[["label"]] <- label
        tempList[["entry"]] <- get(i)
        pWidgets[[i]] <- tempList
    }
    return(pWidgets)
}

# This function fomats the arguments obtained from a widget
formatArg <- function(toFormat){

    # Turns off any warnings when checking for NULL, NA, and boolean
    options(warn = -1)
    if(is.null(toFormat)){
        options(warn = 0)
        return(toFormat)
    }
    if(is.na(toFormat)){
        options(warn = -1)
        return(NA)
    }
    if(is.logical(toFormat)){
        options(warn = 0)
        return(toFormat)
    }
    if(toFormat == "TRUE"){
        return(TRUE)
    }
    if(toFormat == "FALSE"){
        return(FALSE)
    }
    if(toFormat == "\\t"){
        return("\t")
    }
    options(warn = 0)
    if(toFormat == ""){
        return(toFormat)
    }
    # expression and negative numbers can be "language"
    if(is.language(toFormat)){
        return(formula(toFormat))
    }
    options(warn = -1)
    temp <- as.numeric(toFormat)
    options(warn = 0)
    if(is.na(temp)){
        return(getTrueNullNa(toFormat))
    }else{
        return(temp)
    }
}

# All functions are of type "symbol", "builtin", in the list returned
# by formals
getSymbol <- function(args){
    temp <- sapply(args, typeof)
    temp <- args[names(
           temp[temp == "symbol" | temp == "closure" | temp == "builtin"])]
    temp <- temp[temp != ""]
    return(temp)
}

funcs2Char <- function(args,funcs){
    for(i in names(funcs)){
        args[[i]] <- as.character(funcs[i])
    }
    return(args)
}

getTrueNullNa <- function(toFormat){
     switch(tolower(toFormat),
                   "t" = ,
                   "true" = return(TRUE),
                   "f" = ,
                   "false" = return(FALSE),
                   "na" = return(NA),
                   "null" = return(NULL),
                   return(toFormat))
}

# This function lists all the rda files in the data directory of a
# Bioconductor data package and thus allow users to explorer the data
# sets.
#
# Copyrihgt, 2003, J. Zhang, all rights reserved
#

##FIXME: the selection of keys for returning needs to grab the environment
## as well, right now we merely try to use the last environment selected
## and that is not quite what we would like
DPExplorer <- function (pkgName = "", title = "BioC Data Package Explorer",
                        getFocus = TRUE){

    quit <- FALSE
    dataName <- NULL
    keyName <- NULL
    keySelection <- NULL

    currentList <- list()

    if(typeof(pkgName) != "character"){
        tkmessageBox(title = "Argument Error",
                         message = "Package name must be a character string",
                         icon = "error",
                         type = "ok")
        stop()
    }

    loadDP <- function(){
        pkgName <<- tclvalue(nameVar)
        if(pkgName == ""){
            tkmessageBox(title = "No Entry Error",
                         message = "Please enter a package name",
                         icon = "error",
                         type = "ok")
        }else{
            rdas <- loadDataPkg(pkgName)
            if(!is.null(rdas)){
                writeList(dataNameList, rdas)
            }
        }
    }
    activeLoadBut <- function(){
        tkconfigure(loadBut, state = "normal")
    }
    dataSelected <- function(){
        dName <- as.character(tkget(dataNameList,
                                       tkcurselection(dataNameList)))
        if(!is.environment(get(dName, pos = grep(pkgName, search())))){
            writeList(valueList, sort(capture.output(get(dName))))
        }else{
            dataName <<- dName
            currentList <<- as.list(get(dataName,
                                        pos = grep(pkgName, search())))
            #keys <- ls(get(dataName, pos = grep(pkgName, search())))
            writeList(keyList, sort(names(currentList)))
            tkdelete(valueList, "0", "end")
        }
    }
    keySelected <- function(){
        keyName <<- paste(as.character(tkget(keyList,
                                       tkcurselection(keyList))),
                          sep = "", collapse = " ")
        #values <- get(keyName, get(dataName, pos = grep(pkgName, search())))
        #writeList(valueList, values)
        writeList(valueList, currentList[[keyName]])
        tkconfigure(selectBut, state = "normal")
    }
    select <- function(){
        keySelection <<- unique(c(keySelection, keyName))
        writeList(selectionList, keySelection)
        tkconfigure(selectBut, state = "disabled")
        tkconfigure(clearBut, state = "normal")
    }
    drop <- function(){
        keySelection <<- keySelection[keySelection != keyName]
        writeList(selectionList, keySelection)
        tkconfigure(dropBut, state = "disabled")
    }
    clear <- function(){
        keySelection <<- NULL
        writeList(selectionList, NULL)
        tkconfigure(clearBut, state = "disabled")
    }
    selectionSelected <- function(){
        keyName <<- as.character(tkget(selectionList,
                                       tkcurselection(selectionList)))
        tkconfigure(dropBut, state = "normal")
    }
    cancel <- function(){
        quit <- TRUE
        if(getFocus){
            tkgrab.release(base)
        }
        tkdestroy(base)
    }
    on.exit(cancel())
    finish <- function(){
        tkdestroy(base)
    }

    if(pkgName != ""){
        nameVar <- tclVar(pkgName)
    }else{
        nameVar <- tclVar("")
    }

    base <- getTopLevel(title)
    # Pack the top frame with an entry button for package name
    nameFrame <- tkframe(base)
    label <- tklabel(nameFrame, text = "Data Package: ")
    entry <- tkentry(nameFrame, width = 15, textvariable = nameVar)
    tkbind(entry, "<KeyPress>", activeLoadBut)
    tkbind(entry, "<Return>", loadDP)
    loadBut <- tkbutton(nameFrame, width = 8, text = "Load",
                        command = loadDP, state = "disabled")
    tkpack(label, side = "left")
    tkpack(entry, side = "left", expand = TRUE, fill = "x")
    tkpack(loadBut, side = "left")
    tkpack(nameFrame, expand = FALSE, fill = "x", pady = 5, padx = 5)
    # Pack the frame with lists for data
    dataFrame <- tkframe(base)
    # Frame for a list for names of data sets
    dataListFrame <- tkframe(dataFrame)
    dataLabel <- tklabel(dataListFrame, text = "Data:")
    tempFrame <- tkframe(dataListFrame)
    dataNameList <- makeViewer(tempFrame, vWidth = NULL, vHeight = NULL,
                        hScroll = TRUE, vScroll = TRUE,
                        what = "list", side = "bottom")
    tkconfigure(dataNameList, exportselection = FALSE)
    tkbind(dataNameList, "<B1-ButtonRelease>", dataSelected)
    tkpack(dataLabel, side = "top")
    tkpack(tempFrame, side = "bottom", expand = TRUE, fill ="both")
    tkpack(dataListFrame, side = "left", expand = FALSE, fill = "y")
    # Frame for a list for names of keys
    keyListFrame <- tkframe(dataFrame)
    keyLabel <- tklabel(keyListFrame, text = "Keys:")
    tempFrame <- tkframe(keyListFrame)
    keyList <- makeViewer(tempFrame, vWidth = 13, vHeight = 15,
                        hScroll = TRUE, vScroll = TRUE,
                        what = "list", side = "bottom")
    tkconfigure(keyList, exportselection = FALSE)
    tkbind(keyList, "<B1-ButtonRelease>", keySelected)
    tkpack(keyLabel, side = "top")
    tkpack(tempFrame, side = "bottom", expand = TRUE, fill = "both")
    tkpack(keyListFrame, side = "left", expand = FALSE, fill = "y")
    # Frame for a list for displaying values of selected keys
    valueFrame <- tkframe(dataFrame)
    valueLabel <- tklabel(valueFrame, text = "Value(s)")
    temp <- tkframe(valueFrame)
    valueList <- makeViewer(temp, vWidth = 25, vHeight = 15,
                        hScroll = TRUE, vScroll = TRUE,
                        what = "list", side = "bottom")
    selectBut <- tkbutton(valueFrame, text = "Select Key", width = 16,
                          command = select, state = "disabled")
    dropBut <- tkbutton(valueFrame, text = "Drop Key", width = 16,
                         command = drop, state = "disabled")
    clearBut <- tkbutton(valueFrame, text = "Clear Selection", width = 16,
                          comman = clear, state = "disabled")
    tkpack(clearBut, side = "bottom", expand = FALSE, fill = "x")
    tkpack(dropBut, side = "bottom", expand = FALSE, fill = "x")
    tkpack(selectBut, side = "bottom", expand = FALSE, fill = "x")
    tkpack(temp, side = "bottom", expand = TRUE, fill = "both")
    tkpack(valueLabel, side = "bottom")
    tkpack(valueFrame, side = "left", expand = TRUE, fill = "both")
    # Frame for a list for selected keys
    selectionListFrame <- tkframe(dataFrame)
    selectionLabel <- tklabel(selectionListFrame, text = "Selected keys:")
    viewFrame <- tkframe(selectionListFrame)
    selectionList <- makeViewer(viewFrame, vWidth = 13, vHeight = 15,
                        hScroll = FALSE, vScroll = TRUE,
                        what = "list", side = "bottom")
    tkbind(selectionList, "<B1-ButtonRelease>", selectionSelected)
    tkpack(selectionLabel, side = "top")
    tkpack(viewFrame, side = "bottom", expand = TRUE, fill = "both")
    tkpack(selectionListFrame, side = "left", expand = FALSE, fill = "y")
    # Pack the frame for data lists
    tkpack(dataFrame, expand = TRUE, fill = "both", padx = 5)
    # Frame for the buttons
    butFrame <- tkframe(base)
    cancelBut <- tkbutton(butFrame, text = "Cancel", width = 8,
                          command = cancel)
    finishBut <- tkbutton(butFrame, text = "Finish", width = 8,
                          comman = finish)
    tkgrid(cancelBut, finishBut, padx = 10)
    tkpack(butFrame, side = "top", expand = FALSE, fill = "x")

    if(pkgName != ""){
        loadDP()
        activeLoadBut()
    }

    if(getFocus){
        tkgrab.set(base)
    }
    tkwait.window(base)

    if(quit){
        return(NULL)
    }else{
        if(is.null(keySelection)){
            return(NULL)
        }else{
            if(length(keySelection) == 1){
                return(get(keySelection,
                           get(dataName, pos = grep(pkgName, search()))))
            }else{
                return(mget(keySelection,
                            get(dataName, pos = grep(pkgName,
                                          search())), ifnotfound=NA))

            }
        }
    }
}

getTopLevel <- function(title){
    base <- tktoplevel()
    tktitle(base) <- title
    return(base)
}


##fixme: surely this should do something smarter
loadDataPkg <- function(pkgName){
    where <- do.call(require, list(pkgName, quietly=TRUE))
    if(!where){
        tkmessageBox(title = "Invalid Package Name",
                         message = paste("Package", pkgName,
                         "is not valid or has not been loaded yet!"),
                     icon = "error",
                     type = "ok")
        return(NULL)
    }else{
        rdas <- gsub("\\.rda$", "", ls(paste("package:", pkgName, sep="")))
        rdas <- setdiff(rdas, c(pkgName,
                                     paste(pkgName, "QC", sep = "")))
        return(rdas)
    }
}

# This widget allows users to explore an R package.
#

pExplorer <- function (pkgName = "", pkgPath = "",
                       exclude = getExclude(), getFocus = TRUE){

    if(pkgPath == ""){
        pkgPaths <- .libPaths()
    }else{
        pkgPaths <- c(pkgPath, .libPaths())
    }
    if(pkgName == ""){
        pkgPath <- tclVar(pkgPaths[1])
        pkgName <- tclVar(list.files(tclvalue(pkgPath))[1])
    }else{
        pkgPath <- tclVar(pkgPaths[1])
        pkgName <- tclVar(pkgName)
    }
    pkgNames <- getRPkgs(tclvalue(pkgPath))
    baseDir <- file.path(tclvalue(pkgPath), tclvalue(pkgName))
    subDirs <- NULL
    end <- function(){
        if(getFocus){
            tkgrab.release(base)
        }
        tkdestroy(base)
    }
    on.exit(end())
    pathEntered <- function(){
        tempNames <- getRPkgs(tclvalue(pkgPath))
        if(!is.null(tempNames)){
            pkgNames <<- tempNames
            tclvalue(pkgName) <<- pkgNames[1]
            baseDir <<- file.path(tclvalue(pkgPath), pkgNames[1])
            writePkgDirs()
            subDirs <<- NULL
        }else{
            tclvalue(pkgPath) <<- gsub(paste(.Platform$file.sep,
                                     basename(baseDir), sep = ""), "",
                                       baseDir)
        }
    }
    upDatePath <- function(){
        options(show.error.messages = FALSE)
        opt <- try(getListOption(pathEntry, pkgPaths))
        options(show.error.messages = TRUE)
        if(!inherits(opt, "try-error")){
            writeList(pathEntry, opt, clear = TRUE)
            tclvalue(pkgPath) <<- opt
            pkgNames <<- getRPkgs(opt)
            tclvalue(pkgName) <<- pkgNames[1]
            baseDir <<- file.path(opt, pkgNames[1])
            writePkgDirs()
            subDirs <<- NULL
        }
    }
    browse <- function(){
        tempPath <- tclvalue(tkchooseDirectory(mustexist = TRUE))
        tempNames <- getRPkgs(tempPath)
        if(!is.null(tempNames)){
            pkgNames <<- tempNames
            tclvalue(pkgPath) <<- tempPath
            pkgNames <<- getRPkgs(tclvalue(pkgPath))
            tclvalue(pkgName) <<- pkgNames[1]
            baseDir <<- file.path(tclvalue(pkgPath), tclvalue(pkgName))
            subDirs <<- NULL
            writePkgDirs()
        }
    }
    writePkgDirs <- function(){
        writeList(listView, getPkgContents(baseDir, getExclude()))
        tkconfigure(contViewer, state = "normal")
        tkdelete(contViewer, "0.0", "end")
        tkconfigure(contViewer, state = "disabled")
    }
    pkgSelect <- function(){
        options(show.error.messages = FALSE)
        opt <- try(getListOption(pkgDropBut, pkgNames, 15, TRUE))
        options(show.error.messages = TRUE)
        if(!inherits(opt, "try-error")){
            #tkconfigure(pkgEntry, state = "normal")
            #writeList(pkgEntry, opt, clear = TRUE)
            #tkconfigure(pkgEntry, state = "disabled")
            tclvalue(pkgName) <<- opt
            baseDir <<- file.path(tclvalue(pkgPath), opt)
            subDirs <<- NULL
            writePkgDirs()
        }
    }
    # When a user double clicks an item in the list box,
    # populate the list box with new files if the item is a directory
    # or write the contents to the display window if the item is a
    dClick <- function(){
        selectedObj <- as.character(tkget(listView,
                                          (tkcurselection(listView))))
        if(regexpr(.Platform$file.sep, selectedObj) >= 1){
            subDirs <<- c(subDirs, gsub(.Platform$file.sep, "", selectedObj))
            writeList(listView, getPkgContents(file.path(baseDir,
                paste(subDirs, sep = "", collapse = .Platform$file.sep)),
                                               getExclude()))
            tkconfigure(upBut, state = "normal")
        }else{
            popDisplay(getFileContents(file.path(baseDir,
                paste(subDirs, sep = "", collapse = .Platform$file.sep)),
                                       selectedObj))
        }
    }
    popDisplay <- function(contents){
        contents <- paste(contents, sep = "", collapse = "\n")
        tkconfigure(contViewer, state = "normal")
        writeText(contViewer, contents, TRUE)
        tkconfigure(contViewer, state = "disabled")
    }

    # Move the browser one level up the directory path
    goUp <- function(){
        if(length(subDirs) >= 1){
            subDirs <<- subDirs[1:length(subDirs) - 1]
            if(length(subDirs) == 0){
                writeList(listView, getPkgContents(baseDir,
                                                          getExclude()))
                tkconfigure(upBut, state = "disabled")
            }
            writeList(listView, getPkgContents(file.path(baseDir,
                paste(subDirs, sep = "", collapse = .Platform$file.sep)),
                                               getExclude()))
            tkconfigure(contViewer, state = "normal")
            tkdelete(contViewer, "0.0", "end")
            tkconfigure(contViewer, state = "disabled")
            if(length(subDirs) == 0){
                tkconfigure(upBut, state = "disabled")
            }
        }
    }
    tryExp <- function(){
        eExplorer(tclvalue(pkgName))
    }

    base <- tktoplevel()
    tktitle(base) <- paste("BioC Package Explorer")
    # A drop down list box that allows users to pick a package
    pathFrame <- tkframe(base)
    tkpack(tklabel(pathFrame, text = "Package path:"), side = "left",
           expand = FALSE)
    dropFrame <- tkframe(pathFrame, borderwidth = 2, relief = "sunken")
    pathEntry <- tkentry(dropFrame, width = 40, textvariable = pkgPath,
                     borderwidth = 1)
    tkbind(pathEntry, "<KeyPress-Return>", pathEntered)
    tkpack(pathEntry, side = "left", expand = TRUE, fill = "both")
    pathDropBut <- tkbutton(dropFrame, width = 1, text = "v", font = "bold",
                        command = upDatePath)
    tkpack(pathDropBut, side = "left", expand = FALSE)
    tkpack(dropFrame, side = "left", expand = TRUE, fill = "x")
    browseBut <- tkbutton(pathFrame, text = "Browse", width = 6,
                      command = browse)
    tkpack(browseBut, side = "left", padx = 5, expand = FALSE)
    tkpack(pathFrame, side = "top", expand = FALSE, fill = "x",
           pady = 5, padx = 5)

    pkgFrame <- tkframe(base)
    tkpack(tklabel(pkgFrame, text = "Exploring:"), side = "left",
           expand = FALSE)
    pkgDFrame <- tkframe(pkgFrame, borderwidth = 2, relief = "sunken")
    pkgEntry <- tklabel(pkgDFrame, textvariable = pkgName,
                        borderwidth  = 1)
    tkpack(pkgEntry, side = "left", expand = TRUE, fill = "both")
    pkgDropBut <- tkbutton(pkgDFrame, width = 14, text = "Select Package",
                        command = pkgSelect)
    tkpack(pkgDropBut, side = "left", expand = FALSE)
    tkpack(pkgDFrame, side = "left", expand = TRUE, fill = "x")
    tkpack(pkgFrame, side = "top", expand = FALSE, fill = "x",
           pady = 5, padx = 5)

    # Put the list box for package contents and associated buttons
    midFrame <- tkframe(base)
    leftFrame <- tkframe(midFrame)
    tkpack(tklabel(leftFrame, text = "Contents"), side = "top",
           expand = FALSE, fill = "x")
    dirLFrame <- tkframe(leftFrame)
    listView <- makeViewer(dirLFrame, vWidth = 15, vHeight = 10,
                           hScroll = TRUE)
    tkpack(dirLFrame, side = "top", expand = TRUE, fill = "y")
    upBut <- tkbutton(leftFrame, text = "Back", width = 10,
                      state = "disabled", command = goUp)
    tkpack(upBut, side = "top", expand = FALSE, fill = "x")

    tkbind(listView, "<Double-Button-1>", dClick)
#    tkbind(listView, "<B1-ButtonRelease>", sClick)
    tkpack(leftFrame, side = "left", expand = FALSE, fill = "y")
    # Put the text box to show contents of a selected file
    rightFrame <- tkframe(midFrame)
    tkpack(tklabel(rightFrame, text = "Display window"), side = "top",
           expand = FALSE, fill = "x")
    textFrame <- tkframe(rightFrame)
    contViewer <- makeViewer(textFrame, vWidth = 50, vHeight = 10,
                             vScroll = TRUE, hScroll = TRUE, what = "text")
    tkconfigure(contViewer, state = "disabled")
    tkpack(textFrame, side = "top", expand = TRUE, fill = "both")
    tkpack(rightFrame, side = "left", expand = TRUE, fill = "both")
    tkpack(midFrame, side = "top", expand = TRUE, fill = "both",
           padx = 5)
    # Put the end button
    butFrame <- tkframe(base)
    eExpBut <- tkbutton(butFrame, text = "Try examples", width = 12,
                    command = tryExp)
    tkpack(eExpBut, side = "left", expand = FALSE, padx = 5)
    endBut <- tkbutton(butFrame, text = "Finish", width = 12, command = end)
    tkpack(endBut, side = "left", expand = FALSE, padx = 5)
    tkpack(butFrame, pady = 5)
    writePkgDirs()

    if(getFocus){
        tkgrab.set(base)
    }
    tkwait.window(base)

    return(invisible())
}

getPkgContents <- function(pkgName, exclude = getExclude()){
    options(show.error.messages = FALSE)
    cont <- try(list.files(pkgName))
    options(show.error.messages = TRUE)
    if(inherits(cont, "try-error")){
        tkmessageBox(title = "Access Error",
                     message = (paste("Problem accessing", pkgName,
                                      "\nbecause of:\n",
                                      cont)),
                     icon = "info",
                     type = "ok")
        return("")
    }else{
        return(setdiff(appendSepDir(file.path(pkgName)), exclude))
    }
}

getFileContents <- function(path, fileName){
    if(basename(path) == "help"){
        return(procHelp(file.path(path, fileName)))
    }
    if(regexpr("\\.rda", fileName) > 0 ){
        return(procRda(file.path(path, fileName)))
    }
    if(regexpr("\\.gz", fileName) > 0){
        return(readLines(gzfile(file.path(path, fileName))))
    }
    if(regexpr("\\.zip", fileName) > 0){
        return(readLines(unz(file.path(path, fileName))))
    }
#    if(regexpr("\\.Rd", fileName) > 0){
#        return(procRd(file.path(path, fileName)))
#    }
    if(regexpr("\\.pdf", fileName) > 0){
        return(procPDF(file.path(path, fileName)))
    }
    if(regexpr("\\.html", fileName) > 0){
        return(procHTML(file.path(path, fileName)))
    }
    # Ohterwise, use readLines
    return(readLines(file.path(path, fileName)))
}

# For rda files, try to find the Rd file and return it
procRda <- function(fileName){
    if(regexpr(paste("data", .Platform$file.sep,
                     basename(fileName), sep = ""), fileName) > 0){
        return(procHelp(gsub(paste("data", .Platform$file.sep,
                               basename(fileName), sep = ""),
                         paste("help", .Platform$file.sep,
                               gsub("\\.rda", "", basename(fileName)),
                               sep = ""), fileName)))
    }else{
    # If not in "data" directory, ust do not display
        tkmessageBox(title = "Display Error",
                     message = paste("Data in\n", fileName,
                                      "\nare binary and are not displayed"),
                     icon = "info",
                     type = "ok")
        return("")
    }
}

procHelp <- function(fileName){
    options(show.error.messages = FALSE)
    doc <- try(readLines(fileName))
    options(show.error.messages = TRUE)
    if(inherits(doc, "try-error")){
        tkmessageBox(title = "Display Error",
                     message = (paste("Problem displaying\n", fileName,
                                      "\nbecause of:\n", doc)),
                     icon = "info",
                     type = "ok")
        return("")
    }else{
        # Get rid of "_\b"s
        return(gsub("_\\\b", "", doc))
    }
}

procPDF <- function(fileName){
   OST <- .Platform$OS.type
   if (OST == "windows") {
       shell.exec(fileName)
   }
   else if (OST == "unix") {
       viewer <- getOption("pdfviewer")
       if (is.null(viewer)) {
           for (x in c("xpdf", "acroread", "acroread4")) {
               viewer <- system(paste("which", x), intern = TRUE,
                                ignore.stderr = TRUE)
               if (length(viewer) > 0 && file.exists(viewer))
                   break
               viewer <- character()
           }
           if (length(viewer) == 0) {
               tkmessageBox(title = "Display Error",
                       message = ("No available PDF viewer found on system"),
                       icon = "info",
                       type = "ok")
               return("")
           }
       }
   }

   system(paste(viewer, fileName))
   return(invisible())
}

procHTML <- function(fileName){
    options(show.error.messages = FALSE)
    tryMe <- try(browseURL(fileName))
    options(show.error.messages = TRUE)
    if(inherits(tryMe, "try-error")){
        tkmessageBox(title = "Display Error",
                       message = (paste("Problem displaying\n", fileName,
                                        "becuase of:\n",
                                        tryMe)),
                       icon = "info",
                       type = "ok")
    }
    return(invisible())
}

getExclude <- function(){
    return(c("Meta/", "latex/"))
}

getRPkgs <- function(pkgPath){
     options(warn = -1)
     toCheck <- try(list.files(pkgPath))
     options(warn = 0)
     if(length(toCheck) == 0){
         tkmessageBox(title = "No Packages found",
                       message = paste("No R packages found in\n",
                                 pkgPath),
                       icon = "info",
                       type = "ok")
         return(NULL)
     }
     isd <- file.info(file.path(pkgPath, toCheck))
     dirWithDesc <- sapply(file.path(pkgPath,toCheck[isd$isdir]), hasDesc)
     if(length(dirWithDesc) == 0){
         tkmessageBox(title = "No Packages found",
                       message = paste("No R packages found in\n",
                                 pkgPath),
                       icon = "info",
                       type = "ok")
         return(NULL)
     }
     pkgs <- basename(names(dirWithDesc)[dirWithDesc])
     if(length(pkgs) != 0){
         return(pkgs)
     }else{
         tkmessageBox(title = "No Packages found",
                      message = paste("No R packages found in\n",
                                       pkgPath),
                      icon = "info",
                      type = "ok")
         return(NULL)
     }
}

hasDesc <- function(pkgPath){
    if(any(list.files(pkgPath) == "DESCRIPTION")){
        return(TRUE)
    }else{
        return(FALSE)
    }
}

# This function prints the values for all the value containing widgets
# elements on a widget created using the function widgetRender.
#
# Copyright J. Zhang 2002, all rights reserved.
#
values.Widget <- function (x){

    wList <- WwList(x)
    returnList <- vector("list", length = length(names(wList)))
    counter <- 1
    for(i in names(wList)) {
        pW <- wList[[i]]
        returnList[[counter]] <- list(Entry = i, Value = WValue(pW))
        counter <- counter + 1
    }
    return(returnList)
}

# This function makes a list of items for selection denoted by a yes
# and no radio button.
#
# Copyright 2002, J. Zhang. All rights reserved
#
listSelect <-
    function(aList, topLbl = "Select Elements From The Following List",
             typeFun = stdType, valueFun = stdView)
{
    if(is.null(aList) || length(aList) < 1)
        stop("Invalid `aList'")

    returnList <- list()
    end <- FALSE

    for(i in names(aList))
        i <- tclVar(TRUE)

    clear <- function(){
        for(i in names(aList))
            tclvalue(i) <<- 1
    }

    cancel <- function(){
        tkdestroy(base)
    }

    finish <- function(){
        for(i in names(aList)){
            if(tclvalue(i) == 1)
                returnList[[i]] <<- TRUE
            else
                returnList[[i]] <<- FALSE
        }
        end <<- TRUE
        cancel()
    }

    butList <- list(Clear = clear, Cancel = cancel,
                    Finish = finish)

    base <- tktoplevel()
    tkwm.title(base,"BioC Widget")

    can <- tkcanvas(base, width = 300, height = 200)
    scr <- tkscrollbar(base, repeatinterval=5,
                       command=function(...)tkyview(can,...))
    tkconfigure(can, yscrollcommand=function(...)tkset(scr,...))

##FIXME: please try to document what is going on in here
##these long sets of operations are not easy to understand and should
##be documented somewhat

    topFrame <- tkframe(can)
    titlelbl <- tklabel(topFrame, text = topLbl, font = "Helvetica 12")
    tkpack(titlelbl, side = "top", fill = "both", expand = TRUE)
    selFrame <- tkframe(topFrame, borderwidth = 5)
    writeSelBox(selFrame, aList, typeFun, valueFun)
    tkpack(selFrame, side = "top")
    butFrame <- tkframe(topFrame, borderwidth = 5)
    writeBut(butFrame, butList)
    tkpack(butFrame, side = "top")
    tkcreate(can, "window", 5,5, anchor = "nw", window = topFrame)

    tkpack(can, side="left", fill="both", expand = TRUE)
    tkpack(scr, side="right", fill = "y", expand = TRUE)

    tkwait.window(base)

    if(end)
        return(returnList)
    else
        return(aList)
}

writeSelBox <- function(baseW, aList, typeFun = NULL, valueFun = NULL){

    LABELFONT <- "Helvetica 12"

    writeLabel(baseW, typeFun, valueFun)

    for (i in names(aList)){
        tempName <- tklabel(baseW, text = paste(i, ":", sep = ""),
                            font = LABELFONT, padx = 2)
        if(!is.null(typeFun))
            tempType <- tklabel(baseW,
                                text = eval(call(paste(quote(typeFun)),
                                eval(substitute(aList[[i]], list(i = i))))),
                                font = LABELFONT, padx = 2)
        else
            tempType <- tklabel(baseW, text = "")
        if(!is.null(valueFun)){
            fun <- function() {}
            body <- list(as.name("{"),
                         substitute(valueFun(aList[[i]]), list(i = i))

                         )
            body(fun) <- as.call(body)
            viewBut <- tkbutton(baseW, text = "View", command = fun)
        }
        else
            viewBut <- tklabel(baseW, text = "")
        tempCheck <-tkcheckbutton(baseW, text = "Accept", variable = i)
        tkgrid(tempName, tempType, viewBut, tempCheck)
        tclvalue(i) <- 1
    }
}

writeBut <- function(baseW, butList, butWidth = 6){

    butFrame <- tkframe(baseW, borderwidth = 5)
    for(i in 1:length(butList)){
        button <- tkbutton(butFrame, text= names(butList)[i],
                           width=butWidth, command = butList[[i]])
        tkpack(button, side = "left")
    }
    tkgrid(butFrame, columnspan = 4)
}

writeLabel <- function(baseW, typeFun, valueFun){
    LABELFONT <- "Helvetica 12"
    name <- tklabel(baseW, text = "Name", font = LABELFONT, padx = 2)
    if(!is.null(typeFun))
        type <- tklabel(baseW, text = "Type", font = LABELFONT, padx = 2)
    else
        type <- tklabel(baseW, text = "", font = LABELFONT, padx = 2)
    if(!is.null(valueFun))
        view <- tklabel(baseW, text = "Value", font = LABELFONT, padx = 2)
    else
        view <- tklabel(baseW, text = "", font = LABELFONT, padx = 2)
    option <- tklabel(baseW, text = "Option", font = LABELFONT, padx = 2)

    tkgrid(name, type, view, option)
}

# This function takes a vector of strings for object names is an
# environment specified by the calling function and returns a vactor
# of strings for object names selected by the function passed.
#
# Copyright 2002, J. Zhang. All rights reserved.
#

pickObjs <- function (objNames, fun = noAuto){

    if(length(objNames) == 0){
        return(objNames)
    }

    whichOnes <- NULL

    for(i in objNames){
        whichOnes <- c(whichOnes, fun(i))
    }
    return (objNames[whichOnes])
}

noAuto <-  function(x) {
    if(regexpr("^Autoloads", x) > 0 ){
        return(FALSE)
    }else{
        return(TRUE)
    }
}

# This function provides the interface to browse files in the system
# and returns all or a given number of selected file names.
#

fileBrowser <- function (path = "", testFun = function(x) TRUE,
                         prefix = NULL, suffix = NULL,
                         textToShow = "Select file(s)", nSelect = -1)
{
    LABELFONT1 <- "Helvetica 12 bold"
    LABELFONT2 <- "Helvetica 11"
    BUTWIDTH <- 8
    CANWIDTH <- 500
    CANHEIGHT <- 420
    BOXHEIGHT <- 16
    BOXWIDTH <- 29
    OFFSET <- 10
    LABELHEIGHT <- 20

#    currentNode <- NULL
#    nodes <- NULL
    fileSelected <- NULL
#    currentDir <- NULL
    currentFile <- NULL
    selIndex <- NULL
    fileIndex <- NULL
    nextY <- NULL

    # Close the window. Warn users if the number of selected files is wrong
    end <- function(){
        tkgrab.release(base)
        if(nSelect == -1){
            tkdestroy(base)
        }else{
            if(nSelect != length(fileSelected)){
                tkmessageBox(title = "Wrong number", message =
                       paste("You can only select", nSelect, "file(s)"),
                       icon = "warning", type = "ok")
            }else{
                tkdestroy(base)
            }
        }
        setwd(oldDir)
    }
    on.exit(end())
    # When a user double clicks a file name in the list box for file names,
    # remembers the file name and path for that name and write the
    # contents to the list box if the name is a directory.
    inList <- function(){
        selectedObj <- as.character(tkget(listView,
                                          (tkcurselection(listView))))
        # In case the name selected has a space
        if(length(selectedObj) > 1)
            selectedObj <- paste(selectedObj, collapse = " ")
        if(regexpr(.Platform$file.sep, selectedObj[1]) >= 1){
            setwd(file.path(getwd(), selectedObj))
            write2List(listView,
                     pickFiles(appendSepDir(getwd()), testFun,
                               prefix, suffix))
            writeCap(getwd())
            if(length(unlist(strsplit(getwd(), getSep()))) >= 1)
                tkconfigure(upBut, state = "normal")
            tkconfigure(selectBut, state = "disabled")
        }else{
            selIndex <<- as.character(tkcurselection(listView))
            selectAFile()
        }
    }
    # Remember the index of the file name when a user single clicked a
    # file name in the box for file names.
    selInDir <- function (){
        fileIndex <<- NULL
        tkconfigure(selectBut, state = "normal")
        selIndex <<- unlist(strsplit(
                            as.character(tkcurselection(listView)), " "))
    }
    # Remember the index of the file name when a user single clicked a
    # file name in the box for selected file names.
    selInSelection <- function(){
        selIndex <<- NULL
        if(as.character(tkcurselection(selectView))[1] != ""){
            fileIndex <<-
              unlist(strsplit(as.character(tkcurselection(selectView)), " "))
            tkconfigure(remBut, state = "normal")
        }else
            tkconfigure(remBut, state = "disabled")
    }
    # Write a selected file name to the list box for selected files
    # when a user clicked the select button after clicking a file name
    #in the box for file names.
    selectAFile <- function(){
        if(length(selIndex) > 0){
            for(i in selIndex){
                selObj <- as.character(tkget(listView, i))
                # In case a file name contains a space
                if(length(selObj) > 1)
                   selObj <- paste(selObj, collapse = " ")
                fileSelected <<- c(fileSelected,
                                    file.path(getwd(), selObj))
            }
            fileSelected <<- unique(fileSelected)
            writeToView(selectView, fileSelected)
            selIndex <<- NULL
        }
    }
    # Clear the selected file names
    clearSelection <- function(){
        fileSelected <<- NULL
        writeToView(selectView, NULL)
    }
    # Remove a clicked file name from the box for selected file names
    # after a user clicked the remove button.
    dropSelection <- function(){
        toRemove <- NULL
        if(length(fileIndex) > 0){
            for(i in fileIndex)
                toRemove <- c(toRemove, -(as.numeric(i) + 1))
            fileSelected <<- fileSelected[toRemove]
            writeToView(selectView, fileSelected)
            fileIndex <<- NULL
         }
    }
    # Remember the path the browser has traveled.
#    doPath <- function(){
# nodes <<- unlist(strsplit(path, .Platform$file.sep))
#        currentNode <<- length(nodes)
#    }

    write2List <- function (listBox, toWrite){
        writeList(listBox, toWrite, clear = TRUE)
    }

    # Move the browser one level up the directory path
    goUp <- function(){
        tkconfigure(selectBut, state = "disabled")
        sep <- getSep()
        temp  <- unlist(strsplit(getwd(), sep))
        if(length(temp) >= 2){
            if(length(temp) > 2){
                temp <- paste(temp[1:(length(temp) - 1)],
                                  sep = "", collapse = .Platform$file.sep)
                if(length(temp) == 3 && .Platform$OS.type == "unix"){
                    tkconfigure(upBut, state = "disabled")
                }
            }else{
                temp <- paste(temp[1], sep, sep = "", collapse = "")
                tkconfigure(upBut, state = "disabled")
            }
            setwd(temp)
            write2List(listView, pickFiles(appendSepDir(getwd()), testFun,
                                         prefix, suffix))
            writeCap(getwd())
        }
    }
    # Returns the file separator
    getSep <- function(){
            return(.Platform$file.sep)
    }
    # Write the content of toWrite to a list given box
    writeToView <- function(aView, toWrite){
    tkdelete(aView, 0, "end")
        if(!is.null(toWrite)){
            for (i in toWrite){
                if(substr(i, nchar(i), (nchar(i) + 1))
                      == .Platform$file.sep)
                    i <- substr(i, 0, (nchar(i) - 1 ))
                tkinsert(aView, "end",
                     gsub(paste(".*", .Platform$file.sep, "(.*)",
                                sep = ""), "\\1", i))
            }
        }
        if(length(toWrite) > 0)
            tkconfigure(clearBut, state = "normal")
        else{
            tkconfigure(clearBut, state = "disabled")
            tkconfigure(remBut, state = "disabled")
        }
    }
    # Refresh the path shown on the widget
    writeCap <- function(toWrite)
  tkconfigure(caption, text = toWrite)

    oldDir <- getwd()
    if(path != "")
        setwd(path)

#    doPath()


    ## Set up the interface
    base <- tktoplevel()
    tktitle(base) <- paste("File Browser")
    # Writes the directory name
    topFrame <- tkframe(base)
    instruct <- tklabel(topFrame, text = textToShow, font = LABELFONT1)
    dir <- tklabel(topFrame, text = "Directory: ", font = LABELFONT2)
    caption <- tklabel(topFrame, text = getwd(), font = LABELFONT2)
    tkgrid(instruct, columnspan = 2)
    tkgrid(dir, caption)
    tkgrid(topFrame, columnspan = 2, padx = 10)
    # Put the list box for file names in a directory and the
    # associated buttons
    leftFrame <- tkframe(base)
    dirLabel <- tklabel(leftFrame, text = "Files in directory",
                        font = "Helvetica 11")
    tkgrid(dirLabel, columnspan = 2)
    dirLFrame <- tkframe(leftFrame)

    listView <- makeViewer(dirLFrame, vWidth = BOXWIDTH,
                         vHeight = BOXHEIGHT)
    tkgrid(dirLFrame, columnspan = 2)
    upBut <- tkbutton(leftFrame, text = "Up", width = BUTWIDTH,
          command = goUp)
    selectBut <- tkbutton(leftFrame, text = "Select >>", width = BUTWIDTH,
          state = "disabled", command = selectAFile)
    tkgrid(upBut, selectBut)
    tkgrid.configure(upBut, sticky = "e")
    tkgrid.configure(selectBut, sticky = "w")
    tkconfigure(listView, selectmode = "extended", font = LABELFONT2)
    tkbind(listView, "<Double-Button-1>", inList)
    tkbind(listView, "<B1-ButtonRelease>", selInDir)
    write2List(listView, pickFiles(appendSepDir(getwd()), testFun,
                                 prefix, suffix))
    # Put the list box for selected file names and the associated buttons
    rightFrame <- tkframe(base)
    selLabel <- tklabel(rightFrame, text = "Files selected",
                        font = "Helvetica 11")
    tkgrid(selLabel, columnspan = 2)
    selLFrame <- tkframe(rightFrame)
    selectView <- makeViewer(selLFrame, vWidth = BOXWIDTH,
                           vHeight = BOXHEIGHT)
    tkgrid(selLFrame, columnspan = 2)
    tkconfigure(selectView, selectmode = "extended", font = LABELFONT2)
    tkbind(selectView, "<B1-ButtonRelease>", selInSelection)
    remBut <- tkbutton(rightFrame, text = "<< Remove", width = BUTWIDTH,
          state = "disabled", command = dropSelection)
    clearBut <- tkbutton(rightFrame, text = "Clear", width = BUTWIDTH,
          state = "disabled", command = clearSelection)
    tkgrid(remBut, clearBut)
    tkgrid.configure(remBut, sticky = "e")
    tkgrid.configure(clearBut, sticky = "w")

    tkgrid(leftFrame, rightFrame)
    # Put the end button
    endBut <- tkbutton(base, text = "Finish", width = BUTWIDTH,
           command = end)
    tkgrid(endBut, columnspan = 2)

    tkgrab.set(base)

    tkwait.window(base)

    return(fileSelected)
}

# This function returns TRUE if a given prefix, suffix, or characters
# matches a character string or FALSE otherwise.
#
# Copyright 2002, J. Zhang. All rights reserved.
#

hasPrefix <- function(aPrefix){
    hasChar(aPrefix, "prefix")
}

hasSuffix <- function(aSuffix){
    hasChar(aSuffix, "suffix")
}

hasChar <- function (toCheck, what = ""){

    if(!is.character(toCheck) || nchar(toCheck)  < 1)
        stop(paste("Bad value:", toCheck))

    function(x){
        if(what == "prefix"){
            pattern <- paste("^", toCheck, sep = "")
        }else if(what == "suffix"){
            pattern <- paste(toCheck, "$", sep = "")
        }else{
            pattern <- toCheck
        }

        if(regexpr(pattern, x) > 0 ){
           return(TRUE)
        }else{
            return(FALSE)
        }
    }
}

# This function creates a widget based on the requirements passed as a
# list of lists.
# iWidget: a list of lists defining the appearance and behavour of the
# primitive widgets such entry boxex, buttons, ...
# tkTitle: text to be appear in the title bar of the widgets.
#
widgetRender <- function (iWidget, tkTitle)
{
    LABELFONT <- "Helvetica 12"
    ENTRYWIDTH <- 50
    BUTWIDTH <- 10
    BUTTONLAST <- NULL

    savediWidget <- iWidget
    wList <- WwList(iWidget)

    if(is.null(wList) || is.na(wList) )
        stop("Either wList or/and funName is null or empty")

    if(!is.null(WpreFun(iWidget)))
        tt <- eval(WpreFun(iWidget)())
    if(!is.null(WpostFun(iWidget)))
        on.exit(eval(WpostFun(iWidget)()))

    PFRAME <- parent.frame(1)
    CANCEL <- FALSE
    END <- FALSE
    cancel <- function() {
        CANCEL <<- TRUE
        tkdestroy(base)
    }
    end <- function() {
        END <<- TRUE
        tkdestroy(base)
    }

    base <- tktoplevel()
    tktitle(base) <- tkTitle
    eFrame <- tkframe(base)

    ## function that gets called at the end and updates the
    ## values of iWidget using data from the entry boxes
    getEntryValues <- function(){
        for(i in 1:length(wList) ) {
            if(!BUTTONLAST[[i]]){
                if(!is.null(WfromText(wList[[i]]))){
#                     eval(substitute(WLValue(iWidget, i) <<-
#                                     WfromText(wList[[i]])
#                                     (tclvalue(entryValue[[i]])),
#                                     list(i = i)))
                     WLValue(iWidget, i) <<- WfromText(wList[[i]])
                                     (tclvalue(entryValue[[i]]))
                }else{
                     WLValue(iWidget, i) <<- tclvalue(entryValue[[i]])
                }
            }
        }
    }

    ##build button functions
    for(i in 1:length(wList)) {
        fun <- function() {}
        body <- list(as.name("{"),
                     substitute(rval <-
                                eval(as.call(list(WbuttonFun(wList[[j]]))),
                                             env=PFRAME),
                                     list(j=i)),
                     substitute(mytext <- WtoText(wList[[j]])(rval),
                                list(j=i)),
                     substitute(if(!WcanEdit(wList[[j]]))
                                tkconfigure(entryList[[j]],state = "normal"),
                                list(j=i)),
                     substitute(tkdelete(entryList[[j]], 0, "end"),
                                list(j=i)),
                     substitute(tkinsert(entryList[[j]], 0, mytext),
                                list(j=i)),
                     substitute(if(!WcanEdit(wList[[j]]))
                                tkconfigure(entryList[[j]],
                                            state = "disabled"),
                                list(j=i)),

                     substitute(BUTTONLAST[[j]] <<- TRUE, list(j=i)),

                     substitute(WLValue(iWidget, j) <<- rval,
                                list(j = i))
                     )

        body(fun) <- as.call(body)
        assign(paste("funList",i,sep=""), fun)
    }

    # set the functions for user defined control buttons
    butFuns <- WRButtons(iWidget)
    for(i in 1:length(butFuns)) {
        fun <- function() {}
        body <- list(as.name("{"),
                     substitute(rval <-
                                eval(as.call(list(WbuttonFun(butFuns[[j]]))),
                                             env=PFRAME),
                                     list(j=i))
                     )

        body(fun) <- as.call(body)
        assign(paste("userFunList",i,sep=""), fun)
    }

    ##initialize the buttons/boxes
    entryList <- vector("list", length = length(wList))
    entryValue <- vector("list", length = length(wList))
    for(i in 1:length(wList) ) {
        pW <- wList[[i]]
        label <- tklabel(eFrame, text = WName(pW), font = LABELFONT)
        entryValue[[i]] <- tclVar()
        BUTTONLAST[[i]] <- TRUE

        entryList[[i]] <- tkentry(eFrame,
                                  textvariable = entryValue[[i]],
                                  width=ENTRYWIDTH)

        eval(substitute(tkbind(entryList[[i]], "<KeyPress>",
               kpress <- function() BUTTONLAST[[i]] <<- FALSE), list(i = i)))

        if( !is.null(WValue(pW))){
            tkinsert(entryList[[i]], 0, WValue(pW))
        }

        if(!WcanEdit(wList[[i]]))
           tkconfigure(entryList[[i]], state = "disabled")

        if(is.null(WbuttonFun(pW)))
            browse <- tklabel(eFrame, text = "  ")
        else
            browse <- tkbutton(eFrame, text= WbuttonText(pW),
                               width=BUTWIDTH,
                               command=get(paste("funList",i,sep="")))
        tkgrid(label, entryList[[i]], browse)
    }

    tkpack(eFrame)

    # make a list with all user defined and default buttons
    butFuns[["cancel"]] <-  list(buttonText = "Cancel",
                             buttonFun = cancel)
    butFuns[["end"]] <- list(buttonText = "Finish", buttonFun = end)

    # Put user defined buttons in
    butFrame <- tkframe(base)

    for(i in 1:length(butFuns)){
        aBut <- butFuns[[i]]
        button <- tkbutton(butFrame, text = WbuttonText(aBut),
                           width = BUTWIDTH,
                               command = WbuttonFun(aBut))
        tkpack(button, side = "left")
    }
    tkpack(butFrame)

    tkwait.window(base)

    if(END){
        getEntryValues()
        iWidget$end <- "END"
        class(iWidget) <- "Widget"
        return(iWidget)
    }else{
        savediWidget$end <- "CANCEL"
        class(savediWidget) <- "Widget"
        return(savediWidget)
    }
}

# This function creates a widget with a scrollable text box to show
# R object passed in the text box in a predefined format.
#
# Copyright 2002, J. Zhang. All right reserved.
#
objViewer <- function(toView, width = 40, height = 10){

    ok <- function() tkdestroy(base)

    base <- tktoplevel()
    tktitle(base) <- "Bioconductor Object Viewer"

    boxFrame <- tkframe(base)
    boxView <- makeViewer(boxFrame, vWidth = width,
                        vHeight = height, vScroll = TRUE,
                        hScroll = TRUE)
    writeList(boxView, toView)
    tkpack(boxFrame, side = "top")

    okBut <- tkbutton(base, text = "OK", command = ok)
    tkpack(okBut,side = "bottom")

    tkwait.window(base)
}

# This function reads the formal arguments of an R function and then
# generates an XML document containing those arguments
#
# Copyright 2002, J. Zhang, all rights reserved
#

args2XML<- function(fun, xml.name = "", full.names = NULL,
                      priority = NULL){

    if(xml.name == ""){
        xml.name = paste(deparse(substitute(fun)), "arg.xml", sep = "")
    }

    writeXML <- function(text){
        write(text, file = xml.name, append = TRUE)
    }

    args <- formals(fun)
    write(paste("<!DOCTYPE tkWidgets: SYSTEM \"http://",
                "www.bioconductor.org/datafiles/dtds/args.dtd\">",
                sep = ""), file = xml.name)
    writeXML(paste("<tkWidgets:Arguments xmlns:AnnBuilder='http://",
                "www.bioconductor.org/tkWidgets/'>", sep = ""))

    for(i in 1:length(args)){
        writeXML("<tkWidgets:Argument>")
        writeXML(paste("<tkWidgets:ArgName value = \"",
                       names(args[i]), "\"/>", sep = ""))
        writeXML(paste("<tkWidgets:ArgVal value = \"", args[i],
                       "\"/>", sep = ""))
        writeXML(paste("<tkWidgets:FullName value = \"",
                       ifelse(is.null(full.names), "", full.names[i]),
                       "\" />", sep = ""))
        writeXML(paste("<tkWidgets:Priority value = \"",
                       ifelse(is.null(priority), "", priority[i]),
                       "\" />", sep = ""))
        write("</tkWidgets:Argument>")
    }

    writeXML("</tkWidgets:Arguments>")

    return(xml.name)
}

# This function reads a few lines from a given file and then guesses
# if there is a header line, the separator used to separate columns,
# and the data type of each column.
#
# Copyright 2002, J. Zhang, all rights reserved
#

guess.sep <- function(file.name, numLine = 5, seps, isFile = TRUE){

    separator <- ""
    header <- FALSE
    sep <- NULL

    if(missing(seps)){
        seps <- c(",", ";", "\t", "\\t", " ")
    }#else{
    #    seps <- c(seps, ",", ";", "\t", " ")
    #}

    if(isFile){
        conn <- safeFileOpen(file.name)
        if(inherits(conn, "connection")){
            toCheck <- readLines(conn, n = numLine)
            close(conn)
        }else{
            stop(paste("Can't read file because", conn))
        }
    }else{
        toCheck <- file.name
    }

    good <- function(x) all(x==x[1]) && x[1] > 1

    for(i in seps){
        w <- strsplit(toCheck[2:length(toCheck)], i)
        v <- sapply(w, length)
        if(good(v)){
            sep <- i
            break
        }
    }
    if(!is.null(sep)){
        separator <- sep
        if(length(unlist(strsplit(toCheck[1], separator)))
                    == length(unlist(strsplit(toCheck[2], separator))) - 1){
            header <- TRUE
            colNames <- gsub("\"", "",
                              unlist(strsplit(toCheck[1], separator)))
            skip <- 0
            rowNames <- getRowNames(file.name, separator, header, skip)
        }else{
            headerNSkip <- guess.header(toCheck[1:2], separator)
            header <- headerNSkip[["header"]]
            skip <- headerNSkip[["skip"]]
            colNames <- headerNSkip[["colNames"]]
            rowNames <- getRowNames(file.name, separator, header, skip)
        }
        type <- find.type(file.name, separator, header, numLine)
        return(list(header = header, separator = separator, skip = skip,
                    col.names = colNames, row.names = rowNames, type = type))
    }else{
        # New line is always the separator
        return(list(header = FALSE, separator = "\n", col.names = NA,
                    row.names = NA, skip = 0,
                    type = find.type(file.name, sep = "\n", header = FALSE)))
    }
}

guess.header <- function(twoLines, sep){

    on.exit(options(warn = 1))

    if(!is.null(sep)){
        firstLine <- unlist(strsplit(twoLines[1], sep))
        scndLine <- unlist(strsplit(twoLines[2], sep))
    }else{
        firstLine <- twoLines[1]
        scndLine <- twoLines[2]
    }

    options(warn = -1)
    firstLine <- as.numeric(firstLine)
    scndLine <- as.numeric(scndLine)
    options(warn = 1)

    firstLine[!is.na(firstLine)] <- "num"
    scndLine[!is.na(scndLine)] <- "num"

    if(!setequal(firstLine, scndLine)){
        return(list(header = TRUE, skip = 1,
            colNames = gsub("\"", "",  unlist(strsplit(twoLines[1], sep)))))
    }else{
        #if(any(!is.na(firstLine))){
        #    return(list(header = FALSE, skip = 0))
        #}
        return(list(header = FALSE, skip = 0, colNames = NA))
    }
}

find.type <- function(file.name, sep, header = FALSE, numLine = 5,
                      isFile = TRUE){
    if(isFile){
        line <- as.matrix(read.table(file.name, sep = sep, header = header,
                                     nrows = numLine, as.is = TRUE))
    }else{
        line <- as.matrix(file.name)
    }

    types <- NULL
    for(i in 1:nrow(line)){
        types <- rbind(types, charOrNum(line[i,]))
    }
    if(nrow(unique(types)) == 1){
        return(types[1,])
    }else{
        return(rep("Character", ncol(types)))
    }
}

charOrNum <- function(vect){
    options(warn = -1)
    temp <- as.numeric(vect)
    options(warn = 1)

    temp[is.na(temp)] <- "Character"
    temp[!is.na(temp) & temp != "Character"] <- "Numeric"
    return(temp)
}

getRowNames <- function(file.name, sep, header, skip){
    data <- read.table(file.name, sep = sep, nrow = 3, header = header,
                       skip = skip)
    return(rownames(data))
}

# This function gets a vector containing the names of R objects and
# returns a list of lists with name and object pairs. If a name is for
# a package, the content of the package will be associated with the
# package name.
#
# J. Zhang, copyright 2002, all rights reserved.
#
objNameToList <- function (objNames, env){
    returnList <- list()
    for(i in 1:length(objNames)){
        # if it is a package, the list contains the contents of
        # the package
        if(regexpr("^package", objNames[i]) > 0){
            returnList[[objNames[i]]] <- package.contents(gsub("(^package:)",
                                                          "\\", objNames[i]))
        }else{
            returnList[[objNames[i]]] <- get(objNames[i], env = env)
        }
    }
    return(returnList)
}

# Functions that guide users through the steps of importing an
# AnnotatedDataFrame object. Used by the affy package.

importPhenoData <- function(fileName = NULL, sampleNames = NULL, from = NULL){

    if(!require("Biobase", character.only = TRUE)){
        tkmessageBox(title = paste("Dependency error"),
                     message = paste("This widget requires Biobase",
                     "that is not available in your system.",
                     "Please install Biobase and try again"),
                     icon = "error",
                     type = "ok")
        stop()
    }

    varLabels <- NULL
    phenodata <- NULL
    newPhenoData <- NULL

    end <- function(){
        tkgrab.release(base)
        tkdestroy(base)
    }
    on.exit(if(!any(from == c("file", "object", "edit", "new"))) end())

    cancel <- function(){
        newPhenoData <- NULL
        end()
    }

    getPData <- function(what, desc = NULL){
        if(what == "file"){
            if(!is.null(fileName)){
                pdata <- importWizard(fileName)[["data"]]
            }else{
                pdata <- importWizard()[["data"]]
            }
            if(is.null(pdata)){
                return(invisible())
            }
            #colnames(pdata) <- paste("Covar", 1:ncol(pdata), sep = "")
            #if(is.null(sampleNames)){
                #rownames(pdata) <- paste("Sample", 1:nrow(pdata), sep = "")
            #}
            varList <- list()
            varList[colnames(pdata)] <- ""
        }else if (what == "df"){
            pdata <- getOBJWidget("data.frame")
            if(is.null(pdata)){
                return(invisible())
            }
            varList <- list()
            varList[colnames(pdata)] <- ""
        }else if (what == "pd"){
            pdata <- getOBJWidget("AnnotatedDataFrame")
            if(is.null(pdata)){
                return(invisible())
            }
            varList <- varLabels(pdata)
            pdata <- pData(pdata)
        }else{
            sampleNCov <- getSNCNums(sampleNames)
            if(is.null(sampleNCov)){
                return(invisible())
            }
            pdata <- data.frame(matrix("", nrow = sampleNCov$samples,
                                       ncol = sampleNCov$covars))
            colnames(pdata) <- paste("Covar", 1:ncol(pdata), sep = "")
            if(is.null(sampleNames)){
                rownames(pdata) <- paste("Sample", 1:nrow(pdata), sep = "")
            }
            varList <- list()
            varList[colnames(pdata)] <- ""
        }
        if(!is.null(sampleNames)){
            pdata <- writePDRowNames(pdata, sampleNames)
        }
        tempData <- createPData(pdata, varList)
        if(!is.null(tempData)){
            #names(varList) <- colnames(tempData)
            #phenoList <- getCovarDesc(varList, pdata)
            #tempPheno <- constPhenoData(tempData, varList)
            #if(!is.null(tempPheno)){
            #    newPhenoData <<- tempPheno
            newPhenoData <<- tempData
            filename <- getName4Data("phenodata", objType = "AnnotatedDataFrame")
            if(!is.null(filename)){
                .GlobalEnv[[filename]] <- newPhenoData
            }
            if(is.null(from) ||
               !any(tolower(from) == c("file", "object", "edit", "new"))){
                end()
            }
            #}
        }
    }
    readFile <- function(){
        getPData("file")
    }

    readDF <- function(){
        getPData("df")
    }

    readPheno <- function(){
        getPData("pd")
    }

    createNew <- function(){
        getPData("new")
    }

    if(!is.null(from) &&
       any(tolower(from) == c("file", "object", "edit", "new"))){
        switch(tolower(from),
               file =  getPData("file"),
               object = getPData("df"),
               edit = getPData("pd"),
               new = getPData("new"),
               return(TRUE))
    }else{
        base <- tktoplevel()
        tktitle(base) <- "BioC Read AnnotatedDataFrame"

        tkpack(tklabel(base, text = paste("Please make a selection using",
                         "the buttons below:"),
                         font = "Helvetica 11 bold"), side = "top",
               expand = FALSE, pady = 8, padx = 5)

        # Frame for read from file
        fileFrame <- tkframe(base, borderwidth = 2, relief = "groove")
        tkpack(tkbutton(fileFrame, text = "Read From File", width = 18,
                        command = readFile), side = "left", expand = FALSE)
        tkpack(tklabel(fileFrame, text = paste("Create an AnnotatedDataFrame object",
                                  "using a specified file")),
               side = "left", expand = FALSE)
        tkpack(fileFrame, side = "top", anchor = "w", pady = 2, padx = 5)
        # frame for read from data frame
        dfFrame <- tkframe(base, borderwidth = 2, relief = "groove")
        tkpack(tkbutton(dfFrame, text = "Read From Object", width = 18,
                        command = readDF), side = "left", expand = FALSE)
        tkpack(tklabel(dfFrame, text = paste("Create an AnnotatedDataFrame object",
                                "using an existing data frame")),
               side = "left", expand = FALSE)
        tkpack(dfFrame, side = "top", anchor = "w", pady = 2, padx = 5)
        # Frame for editing AnnotatedDataFrame
        epFrame <- tkframe(base, borderwidth = 2, relief = "groove")
        tkpack(tkbutton(epFrame, text = "Edit AnnotatedDataFrame", width = 18,
                        command = readPheno), side = "left", expand = FALSE)
        tkpack(tklabel(epFrame, text = paste("Editing an existing AnnotatedDataFrame",
                                "object")),
               side = "left", expand = FALSE)
        tkpack(epFrame, side = "top", anchor = "w", pady = 2, padx = 5)

        # Frame for creating new AnnotatedDataFrame
        newFrame <- tkframe(base, borderwidth = 2, relief = "groove")
        tkpack(tkbutton(newFrame, text = "Create New AnnotatedDataFrame", width = 18,
                        command = createNew), side = "left", expand = FALSE)
        tkpack(tklabel(newFrame, text = "Create a new AnnotateDataFrame object"),
               side = "left", expand = FALSE)
        tkpack(newFrame, side = "top", anchor = "w", pady = 2, padx = 5)

        tkpack(tkbutton(base, text = "Cancel", command = cancel, width = 15),
               side = "top", anchor = "center", expand = FALSE, pady = 10)

        tkgrab.set(base)
        tkwait.window(base)
    }

    return(invisible(newPhenoData))
}

# Read a data frame from a specified file
#getPDFromFile <- function(){

#    pdata <- NULL

#    fileName <- getNameWidget("file")
#    if(is.null(fileName)){
#        return(NULL)
#    }
#    args <- guess.sep(fileName)
    # Try read.table by figuring out the args

#    options(show.error.messages = FALSE)
#    tryMe <- try(read.table(file = fileName, sep = args[["separator"]],
#                            header = args[["header"]]))
#    options(show.error.messages = TRUE)
#    if(inherits(tryMe, "try-error")){
        # If fail, try this
#        pdata <- readFileByUserArgs(fileName)
#    }else{
#        pdata <- tryMe
#    }
#    return(pdata)
#}

# A widget to read in the name of an object
getOBJWidget <- function(type = NULL){
    toReturn <- NULL
    fileName <- tclVar("")

    end <- function(){
        if(tclvalue(fileName) == ""){
            tkmessageBox(title = paste("No name entered"),
                         message = paste("You have not entered a name yet",
                         "Please enter a name"),
                         icon = "error",
                         type = "ok")
        }else{
            if(objExists(tclvalue(fileName))){
                toReturn <<- get(tclvalue(fileName))
                tkgrab.release(base)
                tkdestroy(base)
            }else{
                tkmessageBox(title = paste("Reading Error"),
                    message = paste("I can't continue because:",
                    "\n 1. You may have entered an invalid name or",
                    "\n 2. the name of the object is not of",
                    "class data.frame/AnnotatedDataFrame.\nPlease try again."),
                          icon = "error",
                          type = "ok")
            }
        }
    }

    cancel <- function(){
        tkgrab.release(base)
        tkdestroy(base)
        toReturn <<- NULL
    }
    on.exit(cancel())

    browse <- function(){
        filter <- function(x, env = .GlobalEnv){
            if(class(env[[x]]) == type)
                return(TRUE)
            else
                return(FALSE)
        }
        obj <- objectBrowser(nSelect = 1, fun = filter)
        if(!is.null(obj)){
            toReturn <<- obj[[1]]
        }
        tkgrab.release(base)
        tkdestroy(base)
    }

    base <- tktoplevel()
    tktitle(base) <- "BioC Input Widget"

    readFrame <- tkframe(base)
    tkpack(tklabel(readFrame, text = "Object name:", width = 14,
                   justify = "left"), side = "left", expand = FALSE)
    tkpack(tkentry(readFrame, width = 50, textvariable = fileName),
           side = "left", expand = TRUE, fill = "x")
    tkpack(tkbutton(readFrame, text = "Browse", command = browse),
           side = "left", expand = FALSE)
    tkpack(readFrame, side = "top", padx = 5, pady = 10, expand = TRUE,
           fill = "x")

    butFrame <- tkframe(base)
    backBut <- tkbutton(butFrame, text = "Continue", width = 8, command = end)
    contBut <- tkbutton(butFrame, text = "Cancel", width = 8,
                    command = cancel)
    tkgrid(backBut, contBut, padx = 20)
    tkpack(butFrame, expand = FALSE, fill = "x", padx = 5, pady = 5)

    tkgrab.set(base)

    tkwait.window(base)

    return(toReturn)
}

# Check to see if an object exists in .GlobalEnv
objExists <- function(name, type = NULL){
    if(name %in% ls(.GlobalEnv)){
        if(!is.null(type)){
            if(class(.GlobalEnv[[name]]) == type){
                return(TRUE)
            }else{
                return(FALSE)
            }
        }else{
            return(TRUE)
        }
    }else{
        return(FALSE)
    }
}

# Get the number of samples and covariates from a user through a widget
getSNCNums <- function(sampleNames){
    sampleNCov <- NULL

    covarNum <- tclVar(1)
    if(!is.null(sampleNames)){
        sampleNum <- tclVar(length(sampleNames))
    }else{
        sampleNum <- tclVar(1)
    }

    end <- function(){
        sampleNCov <<- list(samples = as.numeric(tclvalue(sampleNum)),
                            covars = as.numeric(tclvalue(covarNum)))
        tkgrab.release(base)
        tkdestroy(base)
    }

    cancel <- function(){
        tkgrab.release(base)
        tkdestroy(base)
        sampleNCov <<- NULL
    }

    base <- tktoplevel()
    tktitle(base) <- "BioC Input Widgets"

    numFrame <- tkframe(base)
    dropdownList(numFrame, as.character(1:20), sampleNum, 3,
                 tclvalue(sampleNum), TRUE)
    numLab <- tklabel(base, text = "Number of samples: ")
    tkgrid(numLab, numFrame, padx = 5, pady = 5)
    tkgrid.configure(numLab, sticky = "w")

    numFrame <- tkframe(base)
    dropdownList(numFrame, as.character(1:20), covarNum, 3, "1", TRUE)
    covLab <- tklabel(base, text = "Number of covariates: ")
    tkgrid.configure(covLab, numFrame)
    tkgrid.configure(covLab, sticky = "w")

    butFrame <- tkframe(base)
    backBut <- tkbutton(butFrame, text = "Continue", width = 8, command = end)
    contBut <- tkbutton(butFrame, text = "Cancel", width = 8,
                    command = cancel)
    tkgrid(backBut, contBut, padx = 20)
    tkgrid(butFrame, columnspan = 2, padx = 5, pady = 10)

    tkgrab.set(base)
    tkwait.window(base)

    return(sampleNCov)
}

# Put sample names as row names of the data frame
writePDRowNames <- function(pdata, sampleNames){
    if(is.null(pdata)){
        return(pdata)
    }
    options(show.error.messages = FALSE)
    tryMe <- try(rownames(pdata) <- sampleNames)
    options(show.error.messages = TRUE)
    if(inherits(tryMe, "try-error")){
        ok <- tkmessageBox(title = "Sample mis-match",
                     message = paste("Length of sample names and",
                         "row numbers of data frame do not match.",
                         "\nContinue anyway?"),
                     icon = "question",
                     type = "yesno")
        if(tclvalue(ok) == "no"){
            return(NULL)
        }
    }else{
        if(!is.null(sampleNames)){
            rownames(pdata) <- sampleNames
        }
    }
    return(pdata)
}

# This widget is called by importPhenoData when uses decide to create
# an AnnotatedDataFrame object based on a file, a data frame, or
# AnnotatedDataFrame object
createPData <- function(pdata, varList){
    newPhenoData <- NULL
    phenoList <- NULL

    end <- function(){
        newPhenoData <<- NULL
        tkgrab.release(base)
        tkdestroy(base)
    }
    on.exit(end())
    # When the continus button is clicked, create an AnnotatedDataFrame object
    cont <- function(){
        newPData <- convert2PData(phenoList)
        names(varList) <- colnames(newPData)
        phenoList <- getCovarDesc(varList)
        if(!is.null(phenoList)){
            options(show.error.messages = FALSE)
            tryMe <- try(new("AnnotatedDataFrame", pData=data.frame(newPData),
                             varLabels=phenoList))
            options(show.error.messages = TRUE)
            if(inherits(tryMe, "try-error")){
                tkmessageBox(title = paste("Data Error"),
                       message = paste("I can't create an AnnotatedDataFrame object.",
                       "Perhaps the numbers of covariates and their",
                       "descriptions do not match."),
                       icon = "error",
                       type = "ok")
            }else{
                newPhenoData <<- tryMe
                #newPhenoData <<- newPData
                tkgrab.release(base)
                tkdestroy(base)
            }
        }
    }
    # When user decides to add new samples or covariates, reconstruct
    # pdata and update the table for user inputs

    base <- tktoplevel()
    tktitle(base) <- "BioC PhenoData Wizard"

    tkpack(tklabel(base, text = "Enter and Editor Data",
                   font = "Helvetica 11 bold"), side = "top",
           pady = 5, padx = 5, expand = FALSE)
    tkpack(tklabel(base, text = paste("Please enter pheno data using",
                        "the table below:")))
    noteFrame <- tkframe(base, borderwidth = 2, relief = "groove")
    tkpack(tklabel(noteFrame, text = paste("Cells in the first row",
                              "show covariate names and cells in the",
                         "the first column show \n sample names.",
                         "Values in all cells (including covariate/sample",
                         "names) are edit-able."),
                   justify = "left"),
                  side = "top", expand = FALSE, pady = 5)
    tkpack(noteFrame, side = "top", expand = FALSE, padx = 5, pady = 5)

    # A text widget to keep AnnotatedDataFrame entries
    dataFrame <- tkframe(base)
    dataText <- makeViewer(dataFrame, vWidth = 85, vHeight = 16,
                           hScroll = TRUE,
                           vScroll = TRUE, what = "text", side = "left")
    tkpack(dataText, side = "top", expand = TRUE, fill = "both")
    tkpack(dataFrame, side = "top", expand = TRUE, fill = "both",
           padx = 5)

    butFrame <- tkframe(base)
    backBut <- tkbutton(butFrame, text = "Cancel", width = 8, command = end)
    contBut <- tkbutton(butFrame, text = "Continue", width = 8,
                    command = cont)
    tkgrid(contBut, backBut, padx = 20)
    tkpack(butFrame, expand = FALSE, fill = "x", padx = 5, pady = 5)

    tkgrab.set(base)

    phenoList <- writePhenoTable(base, dataText, pdata)


    tkwait.window(base)

    return(newPhenoData)
}
# Write data contained by pdata to the text widget containing the
# table for user inputs
writePhenoTable <- function(base, textWidget, pdata){
    tkconfigure(textWidget, state = "normal")
    phenoMat <- makePhenoData(pdata)
    values <- list()
    tkdelete(textWidget, "0.0", "end")
    #tempEntry <- list()
    for(i in 1:nrow(phenoMat)){
        tempList <- list()
        for(j in 1:ncol(phenoMat)){
            if(i == 1 || j == 1 ){
                style <- "raised"
            }else{
                style <- "sunken"
            }
            if(i == 1  && j == 1 ){
                state <- "disabled"
            }else{
                state <- "normal"
            }
            tempList[[j]] <- tclVar(phenoMat[i, j])
            tempEntry <- tkentry(base, textvariable = tempList[[j]],
                                state = state, width = 11, relief = style)
            tkwindow.create(textWidget, "end", window = tempEntry)
        }
        tkinsert(textWidget, "end", "\n")
        values[[i]] <- tempList
    }
    tkconfigure(textWidget, state = "disabled")
    return(values)
}

# Constructs a matrix containing user input data
makePhenoData <- function(pdata){
        temp <- rbind(c("", colnames(pdata)),
                      cbind(rownames(pdata), as.matrix(pdata)))
    return(as.matrix(temp))
}

# Conver values in a matrix containing user input data to an AnnotatedDataFrame
# object
convert2PData <- function(phenoList){
    pdata <- NULL
    varlist <- list()
    cnames <- NULL
    for(i in 1:length(phenoList)){
        tempP <- NULL
        temp <- phenoList[[i]]
        for(j in 1:length(temp)){
            tempP <- c(tempP, tclvalue(temp[[j]]))
        }
        pdata <- rbind(pdata, tempP)
    }
    #pdata <- pdata[, pdata[1,] != "Delete"]
    #pdata <- pdata[pdata[,1] != "Delete",]
    #varlist <- as.list(pdata[2, 2:ncol(pdata)])
    rnames <- pdata[2:nrow(pdata), 1]
    cnames <- pdata[1, 2:ncol(pdata)]
    pdata <- pdata[-1, -1]
    if(is.null(nrow(pdata))){
        pdata <- data.frame(matrix(pdata, ncol = 1))
    }
    rownames(pdata) <- rnames
    colnames(pdata) <- cnames
    #names(varlist) <- as.character(1:length(varlist))
#    return(new("AnnotatedDataFrame", pData=data.frame(pdata), varLabels=varlist))
    return(pdata)
}

# A widget that takes user inputs for covariate descriptions
# varList - a list with names being covariate names and values
# being a short description of the covariate
getCovarDesc <- function(varList){
    toReturn <- list()
    covarDesc <- list()

    end <- function(){
        temp <- sapply(covarDesc, tclvalue)
        toReturn[names(temp)] <<- temp
        tkgrab.release(base)
        tkdestroy(base)
    }
    on.exit(end())

    cancel <- function(){
        toReturn <<- NULL
        tkgrab.release(base)
        tkdestroy(base)
    }
    base <- tktoplevel()
    tktitle(base) <- "BioC PhenoData Wizard"

    tkpack(tklabel(base, text = "Describe Variables",
                   font = "Helvetica 11 bold"), side = "top",
           pady = 5)
    tkpack(tklabel(base, text = paste("Please enter/edit a short textual",
                         "description for each covariate")), pady = 2)

    # A text widget to keep description entries
    dataFrame <- tkframe(base)
    dataText <- makeViewer(dataFrame, vWidth = 85, vHeight = 16,
                           hScroll = TRUE,
                           vScroll = TRUE, what = "text", side = "left")
    tkpack(dataText, side = "top", expand = TRUE, fill = "both")
    tkpack(dataFrame, side = "top", expand = TRUE, fill = "both",
           padx = 5, pady = 5)

    butFrame <- tkframe(base)
    backBut <- tkbutton(butFrame, text = "Cancel", width = 8,
                        command = cancel)
    contBut <- tkbutton(butFrame, text = "Continue", width = 8,
                    command = end)
    tkgrid(contBut, backBut, padx = 20)
    tkpack(butFrame, expand = FALSE, fill = "x", padx = 5, pady = 5)

    for(i in names(varList)){
        tkinsert(dataText, "end", paste(i, " "))
        covarDesc[[i]] <- tclVar(varList[[i]])
        tempEntry <- tkentry(base, textvariable = covarDesc[[i]],
                             width = 60)
        tkwindow.create(dataText, "end", window = tempEntry)
        tkinsert(dataText, "end", "\n")
    }
    tkconfigure(dataText, state = "disabled")

    tkgrab.set(base)

    tkwait.window(base)

    return(toReturn)
}

# This function provides the interface for users to select items from
# a set of source elements.
#
# items - a vector of character strings for the items to be picked
# from.
#
# Copyright 2002 J. Zhang, all rights reserved
#
pickItems <- function (items, title1 = "Items to pick",
                       title2 = "Picked items"){

    on.exit(end())

    columns <- NULL
    colIndex <- NULL
    indexInSel <- NULL
    text2 <- "Select item(s) from the list box on the left"

    end <- function(){
        tkdestroy(base)
    }

    # When a user double clicks a column name in the list box, put the
    # library name in the vector for selected SAGE libraries.
    colDClicked <- function(){
        column <- as.character(tkget(colView,(tkcurselection(colView))))
        columns <<- unique(c(columns, column))
        writeList(selectView, columns)
        tkconfigure(clearBut, state = "normal")
        tkconfigure(selectBut, state = "disabled")
    }
    # When a user single clicked a column name, remember that name and
    # activate the select button
    colSClicked <- function(){
        colIndex <<- unlist(strsplit(
                              as.character(tkcurselection(colView)), " "))
        tkconfigure(selectBut, state = "normal")
    }
    # When a user click the select button, put the selected column name
    # in the list box for selected columns
    selectCol <- function(){
        for(i in colIndex){
            columns <<- c(columns, as.character(tkget(colView, i)))
        }
        writeList(selectView, unique(columns))
        tkconfigure(selectBut, state = "disabled")
        tkconfigure(clearBut, state = "normal")
    }
    # Remember the column name when a name in the selected column names list
    # box is single clicked
    selSClick <- function(){
        indexInSel <<- unlist(strsplit(
                              as.character(tkcurselection(selectView)), " "))
        tkconfigure(remBut, state = "normal")
    }
    # Removes the selected column name from the list box for selected
    # column names
    dropSelCol <- function(){
        for(i in indexInSel){
            columns <<- columns[columns != as.character(tkget(selectView, i))]
        }
        writeList(selectView, unique(columns))
        tkconfigure(remBut, state = "disabled")
    }
    # Remove everything from the list box for selected column names
    clearSelCol <- function(){
        writeList(selectView, "")
        columns <<- NULL
        tkconfigure(clearBut, state = "disabled")
    }

    base <- tktoplevel()
    tktitle(base) <- "BioC tkWidgets"

    # Lists for column names
    midFrame <- tkframe(base)
    text2Label <- tklabel(midFrame, text = text2, font = "Helvetica 12")
    tkgrid(text2Label, columnspan = 2, pady = 2)
    # Label for available SAGE libs
    leftFrame <- tkframe(midFrame)
    label1 <- tklabel(leftFrame, text = title1, font = "Helvetica 11")
    tkpack(label1)
    # List box showing the available SAGE libs
    colFrame <- tkframe(leftFrame)
    colView <- makeViewer(colFrame, vWidth = 40, vHeight = 15,
                           hScroll = TRUE)
    tkbind(colView, "<Double-Button-1>", colDClicked)
    tkbind(colView, "<B1-ButtonRelease>", colSClicked)
    tkpack(colFrame, padx = 5)
    selectBut <- tkbutton(leftFrame, text = "Select >>", width = 12,
		      state = "disabled", command = selectCol)
    tkpack(selectBut)
    tkconfigure(colView, selectmode = "extended")
    # Put the list box for selected SAGE libs and the associated buttons
    rightFrame <- tkframe(base)
    label2 <- tklabel(rightFrame, text = title2, font = "Helvetica 11")
    tkgrid(label2, columnspan = 2)
    selLFrame <- tkframe(rightFrame)
    selectView <- makeViewer(selLFrame, vWidth = 40, vHeight = 15,
                             hScroll = TRUE)
    tkgrid(selLFrame, columnspan = 2, padx = 5)
    tkconfigure(selectView, selectmode = "extended")
    tkbind(selectView, "<B1-ButtonRelease>", selSClick)
    remBut <- tkbutton(rightFrame, text = "<< Remove", width = 12,
		      state = "disabled", command = dropSelCol)
    clearBut <- tkbutton(rightFrame, text = "Clear", width = 12,
		      state = "disabled", command = clearSelCol)
    tkgrid(remBut, clearBut)
    tkgrid.configure(remBut, sticky = "e")
    tkgrid.configure(clearBut, sticky = "w")

    tkgrid(leftFrame, rightFrame)
    tkpack(midFrame)

    # Put the end button
    endBut <- tkbutton(base, text = "Finish", width = 12, command = end)
    tkpack(endBut, pady = 5)

    writeList(colView, items)

    tkwait.window(base)
    return(columns)
}

# This function provides the interface to browse objects in the work
# place and allows users to pick given number of objects to be
# returned.
# fun = a function that filters objects to be shown;
# textToShow = text to be shown as the title of the widget;
# nSelect = number of selection can be made (default to no limit).
#
#Copyright 2002, J. Zhang, all rights reserved
#

objectBrowser<- function (env = .GlobalEnv,
                          fun = noAuto, textToShow = "Select object(s)",
                          nSelect = -1){

    LABELFONT1 <- "Helvetica 12 bold"
    LABELFONT2 <- "Helvetica 11"
    BUTWIDTH <- 8

    selectedObj <- NULL
    isPack <- FALSE
    returnObj <- NULL
    returnList <- NULL
    selIndex <- NULL
    objIndex <- NULL
    objsInSel <- NULL
    tempObj <- NULL
    currentEnv <- env
    currentState <- "env"

    # close window
    end <- function(){
        tkgrab.release(base)
        tkdestroy(base)
    }
    on.exit(end(), add = TRUE)
    # Executed when a user clicks the end button. returnList that
    # contains names of selected objects will be updated before the
    # window closes.
    finish <- function(){
        if(currentState != "env"){
            returnList <<- objsInSel
            end()
        }else{
            if(length(objsInSel) != 0){
                if(nSelect == -1){
                    returnList <<- objNameToList(objsInSel, currentEnv)
                    end()
                }else{
                    if(nSelect != length(objsInSel)){
                        tkmessageBox(title = "Wrong number", message =
                         paste("You can only select", nSelect, "object(s)"),
                         icon = "warning", type = "ok")
                    }else{
                        returnList <<- objNameToList(objsInSel, currentEnv)
                        end()
                    }
                }
            }else{
                returnList <<- NULL
                end()
            }
        }
    }
    # Write the content of the global environment to the list box for
    # object names
    viewEnv <- function(env){
        writeList(listView, pickObjs(objNames = ls(env = env,
                                    all = TRUE), fun = fun), clear = TRUE)
        writeCap(substitute(env))
    }
    # Executed when a user double clicks an object that is an R
    # environment. List object names in an enviroment to the list
    # boxes for objects.
    doEnv <- function (item){
        writeList(listView,  pickObjs(objNames = ls(env = get(item)),
                                      fun = fun), clear = TRUE)
        writeCap(item)
        if(!is.null(parent.env(get(item))))
            tkconfigure(upBut, state = "normal")
    }
    # Executed when a user couble clicks an object that is an R
    # package. List all object names in the list box for objects.
    doPack <- function (index, pack){
        whichOne <- as.numeric(index) + 1
        writeList(listView, ls(pos = whichOne), clear = TRUE)
        isPack <<- TRUE
        writeCap(pack, asis = TRUE)
        tkconfigure(upBut, state = "normal")
    }
    # Will be done for other objects
    doElse <- function(data){
        if(is.vector(data)){
            doVector(data)
        }
    }
    # Executed when a user double clicks an ojbect that is a
    # list. Shows the number of columns, number of rows and column names.
    doList <- function (aList){
        currentState <<- "list"
        if(is.data.frame(get(aList))){
            toWrite <- c("Type: data frame",
                         paste("Number of columns:", ncol(get(aList))),
                         paste("Number of row(s):", nrow(get(aList))),
                         "Column name(s):",
                         colnames(get(aList)),
                         "Row name(s):",
                         row.names(get(aList)))
        }else{
            toWrite <- c("Type: list",
                         paste("Length:", length(get(aList))),
                         "Element name(s):",
                         names(get(aList)))
        }
        writeList(listView, toWrite, clear = TRUE)
        writeCap(aList)
        tkconfigure(selectBut, state = "disabled")
    }

    doVector <- function(vect){
        currentState <<- "vector"
        writeList(listView, get(vect), clear = TRUE)
    }

    doClosure <- function(code){
    }

    # Executed when a user double clicks an object name in a list box.
    # Shows the content of the object if there is any
    dClick <- function (){
        selectedObj <<- as.character(tkget(listView,
                                           tkcurselection(listView)))
        goin()
    }

    # Determines the type of an object that is double clicked to
    # decide what to do
    goin <- function (){
        if(!is.null(selectedObj)){
            if(regexpr("^package", selectedObj) > 0){
                objType <- "package"
            }else{
                objType <- typeof(get(selectedObj))
            }
            switch(objType,
               "closure" = doClosure(selectedObj),
               "environment" = doEnv(selectedObj),
               "package" =  doPack(tkcurselection(listView), selectedObj),
               "list" = doList(selectedObj),
               doElse(selectedObj)
            )
            tkconfigure(selectBut, state = "disabled")
            selectedObj <<- NULL
        }
    }

    # Response to a single click to an object name in the list box for
    # object names
    sClick <- function () {
        selectedObj <<- NULL
        if(currentState != "list"){
            tkconfigure(selectBut, state = "normal")
        }
        selIndex <<- unlist(strsplit(
                              as.character(tkcurselection(listView)), " "))
        if(length(selIndex) == 1){
            tempObj <<- as.character(tkget(listView, selIndex))
        }else{
            for(i in selIndex){
                tempObj <<- c(tempObj,
                                  as.character(tkget(listView, i)))
            }

        }
    }

    # When the global environment is clicked and shows the content
    getAct <- function(){
        currentState <<- "env"
        tkdelete(selectView, "0", "end")
        objsInSel <<- NULL
        selectedObj <<- ".GlobalEnv"
        goin()
        tkconfigure(selectBut, state = "disabled")
    }

    # Moves one step back the path of objects browsered
    up <- function(){
        options(show.error.messages = FALSE)
        tryMe <- try(parent.env(get(selectedObj)))
        options(show.error.messages = TRUE)

        if(isPack || selectedObj == ".GlobalEnv" ||
           inherits(tryMe, "try-error")){
            writeList(listView, pickObjs(objNames = search(),
                                             fun = fun), clear = TRUE)
            writeCap("Top Level")
            tkconfigure(upBut, state = "disabled")
        }else{
            writeList(listView,
                    pickObjs(objNames = ls(env = get(selectedObj)),
                                             fun = fun), clear = TRUE)
            writeCap(selectedObj)

        }
        tkconfigure(selectBut, state = "disabled")
    }
    # Writes the name of an object in the list box for object names to
    # the list box for selected objects.
    selectObj <- function (){
        objsInSel <<- c(objsInSel, tempObj)
        objsInSel <<- unique(objsInSel)
        writeSelection(objsInSel)
        tkconfigure(clearBut, state = "normal")
        tkconfigure(selectBut, state = "disabled")
    }
    # Removes everything from the list box for selected ojbects
    clearSelection <- function(){
        objsInSel <<- NULL
        tkdelete(selectView, 0, "end")
        tkconfigure(clearBut, state = "disabled")
        tkconfigure(removeBut, state = "disabled")
        tkconfigure(selectBut, state = "disabled")
    }
    # Destroy the widow and returns NULL
    cancel <- function (){
        objsInSel <<- NULL
        finish()
    }
    # Removes items from the list box for selected objects
    removeSelection <- function (){
        toRemove <- NULL
        if(length(objIndex) > 0){
            for(i in objIndex)
                toRemove <- c(toRemove, -(as.numeric(i) + 1))

            objsInSel <<- objsInSel[toRemove]
            writeSelection(objsInSel)
        }
        tkconfigure(removeBut, state = "disabled")
    }
    # When an object in the box for selected objects is clicked, the
    # index of the object name is remembered
    selClick <- function (){
        objIndex <<- NULL
        tkconfigure(removeBut, state = "normal")
        objIndex <<- unlist(strsplit(
                      as.character(tkcurselection(selectView)), " "))
    }
    # Write to the list box for selected objects
    writeSelection <- function (toWrite){
        writeList(selectView, toWrite, clear = TRUE)
        #tkdelete(selectView, 0, "end")
        #for(i in toWrite)
        #    tkinsert(selectView, "end", i)
    }
    # Writes to the top of the widget to indicate the current environment
    writeCap <- function(objName, asis = FALSE){
        if(asis){
            tkconfigure(labl1, text = objName)
        }else{
            if(objName == "Top Level"){
                tkconfigure(labl1, text = "Top level")
            }else{
                tkconfigure(labl1, text = objName)
            }
        }
    }

    ## This portion sets up the interface
    base <- tktoplevel()
    tktitle(base) <- paste("Bioconductor Object Browser")
    # Set up the labels for list boxes of objects
    capFrame <- tkframe(base)
    noteLabel <- tklabel(capFrame, text = textToShow, font = LABELFONT1)
    labl1 <- tklabel(capFrame, text = " ", font = LABELFONT2)
    labl2 <- tklabel(capFrame, text = "Selected", font = LABELFONT2)
    dummyLabel <- tklabel(capFrame, text = "           ")
    tkgrid(noteLabel, columnspan = 3)
    tkgrid(labl1, dummyLabel, labl2)
    tkgrid(capFrame, columnspan = 2, padx = 10)
    # Sets up the list boxes. One for objects to browse and one for selected
    leftFrame <- tkframe(base)
    listFrame <- tkframe(leftFrame)
    listView <- makeViewer(listFrame)
    tkgrid(listFrame, columnspan = 2)
    tkconfigure(listView, selectmode = "extended", font = LABELFONT2)
    tkbind(listView, "<Double-Button-1>", dClick)
    tkbind(listView, "<B1-ButtonRelease>", sClick)
    # Puts in the buttons for the list box for object names
    butFrame <- tkframe(leftFrame)
    upBut <- tkbutton(butFrame, text = "Up", width = BUTWIDTH,
		      command = up)
    activeBut <- tkbutton(butFrame, text = "Back", width = BUTWIDTH,
		      command = getAct)
    selectBut <- tkbutton(butFrame, text = "Select >>", width = BUTWIDTH,
                          command = selectObj, state = "disabled")
    tkgrid(upBut, selectBut)
    tkgrid(activeBut, columnspan = 2)
    tkgrid(butFrame)
    # puts in the buttons for list box for selected objects
    rightFrame <- tkframe(base)
    selectFrame <- tkframe(rightFrame)
    selectView <- makeViewer(selectFrame)
    tkconfigure(selectView, selectmode = "extended", font = LABELFONT2)
    tkgrid(selectFrame, columnspan = 2)
    tkbind(selectView, "<B1-ButtonRelease>", selClick)

    butFrame2 <- tkframe(rightFrame)
    removeBut <- tkbutton(butFrame2, text = "<< Remove", width = BUTWIDTH,
		      command = removeSelection, state = "disabled")
    clearBut <- tkbutton(butFrame2, text = "Clear", width = BUTWIDTH,
		      command = clearSelection, state = "disabled")
    canBut <- tkbutton(butFrame2, text = "Cancel", width = BUTWIDTH,
                       command = cancel)
    endBut <- tkbutton(butFrame2, text = "Finish", width = BUTWIDTH,
		       command = finish)
    tkgrid(removeBut, clearBut)
    tkgrid(canBut, endBut)
    tkgrid(butFrame2)

    tkgrid(leftFrame, rightFrame)

    viewEnv(env)

    tkgrab.set(base)

    tkwait.window(base)

    return(returnList)
}

# A function to create a light wight tk widget with a text.
# x and y - the location for the left upper coner of the widget to
#           appear on the screen
getLightTW <- function(x, y, text){
    on.exit(end())

    end <- function(){
        tkdestroy(base)
    }
    # Takes out the frame and title bar
    tkwm.overrideredirect(base <- tktoplevel(), TRUE)
    # Put the TW in the right place
    tkwm.geometry(base, paste("+", x, "+", y, sep = ""))
    text <- tklabel(base, text = text)
    tkpack(text)
    tkbind(base, "<ButtonPress>", end)

    tkwait.window(base)

    return(invisible())
}

### R code from vignette source 'tkWidgets.Rnw'

###################################################
### code chunk number 1: tkWidgets.Rnw:55-87
###################################################
library(tkWidgets)
PWEnv <- new.env(hash = TRUE, parent = parent.frame(1))
argsFun <- function(){
    argsWidget(list(Entry1 = "aaaaa", Ehtry2 = "bbbb"))
}
button1 <- button(wName = "button1", wValue = "argsWidget",
                     wFuns = list(command = argsFun), wEnv = PWEnv)
button2 <- button(wName = "button2", wValue = "DPExplorer",
                     wFuns = list(command = DPExplorer), wEnv = PWEnv)
button3 <- button(wName = "button3", wValue = "fileBrowser",
                     wFuns = list(command = fileBrowser), wEnv = PWEnv)
button4 <- button(wName = "button4", wValue = "importWizard",
                     wFuns = list(command = importWizard), wEnv = PWEnv)
button5 <- button(wName = "button5", wValue = "objectBrowser",
                     wFuns = list(command = objectBrowser), wEnv = PWEnv)
button6 <- button(wName = "button6", wValue = "vExplorer",
                     wFuns = list(command = vExplorer), wEnv = PWEnv)
button7 <- button(wName = "button7", wValue = "pExplorer",
                     wFuns = list(command = pExplorer), wEnv = PWEnv)
fun <- function(){eExplorer("tkWidgets")}
button8 <- button(wName = "button8", wValue = "eExplorer",
                     wFuns = list(command = fun), wEnv = PWEnv)

pWidgets <- list(A = list(button1 = button1, button2 = button2), C =
list(button3 = button3, button4 = button4), D = list(button5 = button5,
button6 = button6), E = list(button7 = button7, button8 = button8))

if(interactive()){
viewWidget <- widget(wTitle = "tkWidgets Examples", pWidgets, funs = list(),
                 preFun = function() print("Hello"),
                 postFun = function() print("Bye"), env = PWEnv)
}


###################################################
### code chunk number 2: tkWidgets.Rnw:244-245
###################################################
toLatex(sessionInfo())

tkMIAME <- function(){
  tt <- tktoplevel(width = 30)
  tkconfigure(tt, background = "white")
  tktitle(tt) <- "MIAME Information"

  tbar.fr <- tkframe(tt,relief="sunken",borderwidth=5,width="5i")
  win.fr <- tkframe(tt,relief="sunken",borderwidth=5,width="5i",height="7i")
  tkconfigure(win.fr, background = "white")
  tkpack(tbar.fr,side="top",fill="x")
  tkpack(win.fr,side="top", fill="both")

  space.label1 <- tklabel(win.fr, text = "")
  tkconfigure(space.label1, background = "white")
  space.label2 <- tklabel(win.fr, text = "")
  tkconfigure(space.label2, background = "white")
  space.label3 <- tklabel(win.fr, text = "")
  tkconfigure(space.label3, background = "white")
  space.label4 <- tklabel(win.fr, text = "")
  tkconfigure(space.label4, background = "white")
  space.label5 <- tklabel(win.fr, text = "")
  tkconfigure(space.label5, background = "white")
  space.label6 <- tklabel(win.fr, text = "")
  tkconfigure(space.label6, background = "white")
  space.label7 <- tklabel(win.fr, text = "")
  tkconfigure(space.label7, background = "white")
  space.label8 <- tklabel(win.fr, text = "")
  tkconfigure(space.label8, background = "white")
  space.label9 <- tklabel(win.fr, text = "")
  tkconfigure(space.label9, background = "white")
  space.label10 <- tklabel(win.fr, text = "")
  tkconfigure(space.label10, background = "white")

  ExpName.label <- tklabel(win.fr, text="Experimenter's Name: ")
  tkconfigure(ExpName.label, background = "white")
  ExpName.var <- tclVar()
  tclvalue(ExpName.var) <- ""
  ExpName.entry <- tkentry(win.fr, width = 25,textvariable = ExpName.var)
  tkconfigure(ExpName.entry, background = "white")

  LabName.label <- tklabel(win.fr, text="Laboratory: ")
  tkconfigure(LabName.label, background = "white")
  LabName.var <- tclVar()
  tclvalue(LabName.var) <- ""
  LabName.entry <- tkentry(win.fr, width = 25,textvariable = LabName.var)
  tkconfigure(LabName.entry, background = "white")

  Contact.label <- tklabel(win.fr, text="Contact Information: ")
  tkconfigure(Contact.label, background = "white")
  Contact.txt <- tktext(win.fr, width = 25, height =5)
  Contact.var <- tclVar()
  tkconfigure(Contact.txt, background = "white")

  ExpTitle.label <- tklabel(win.fr, text="Experiment Title: ")
  tkconfigure(ExpTitle.label, background = "white")
  ExpTitle.var <- tclVar()
  tclvalue(ExpTitle.var) <- ""
  ExpTitle.entry <- tkentry(win.fr, width = 25,textvariable = ExpTitle.var)
  tkconfigure(ExpTitle.entry, background = "white")

  Desc.label <- tklabel(win.fr, text="Experiment Description: ")
  tkconfigure(Desc.label, background = "white")
  Desc.txt <- tktext(win.fr, width = 25, height =10)
  Desc.var <- tclVar()
  tkconfigure(Desc.txt, background = "white")


  URL.label <- tklabel(win.fr, text="URL: ")
  tkconfigure(URL.label, background = "white")
  URL.var <- tclVar()
  tclvalue(URL.var) <- ""
  URL.entry <- tkentry(win.fr, width = 25,textvariable = URL.var)
  tkconfigure(URL.entry, background = "white")



  Exit.but <- tkbutton(win.fr, text = "Finish", command = function(){
    tclvalue(Contact.var) <- tclvalue(tkget(Contact.txt,"0.0","end"))
    tclvalue(Desc.var) <- tclvalue(tkget(Desc.txt,"0.0","end"))
    tkdestroy(tt)
  })

  tkconfigure(Exit.but, background = "white")


  tkgrid(space.label1, row =1)
  tkgrid(space.label2, row =2)
  tkgrid(ExpName.label, row = 3, column = 1, sticky ="e")
  tkgrid(ExpName.entry, row = 3, column =2, sticky = "w")
  tkgrid(space.label3, row =4)
  tkgrid(LabName.label, row = 5, column = 1, sticky = "e")
  tkgrid(LabName.entry, row = 5, column =2, sticky = "w")
  tkgrid(space.label4, row =6)
  tkgrid(Contact.label, row = 7, column = 1, sticky = "e")
  tkgrid(Contact.txt, row = 7, column =2, sticky = "w")
  tkgrid(space.label5, row =8)
  tkgrid(ExpTitle.label, row = 9, column = 1, sticky = "e")
  tkgrid(ExpTitle.entry, row = 9, column =2, sticky = "w")
  tkgrid(space.label6, row =10)
  tkgrid(Desc.label, row = 11, column = 1, sticky = "e")
  tkgrid(Desc.txt, row = 11, column =2, sticky = "w")
  tkgrid(space.label7, row =12)
  tkgrid(URL.label, row = 13, column = 1, sticky = "e")
  tkgrid(URL.entry, row = 13, column =2, sticky = "w")
  tkgrid(space.label8, row =14)
  tkgrid(space.label9, row =15)
  tkgrid(Exit.but, row = 16, column =2, sticky = "e")
  tkgrid(space.label10, row =17)

  tkwait.window(tt)

  miame.lst <- list(tclvalue(ExpName.var), tclvalue(LabName.var),tclvalue(Contact.var),tclvalue(ExpTitle.var),tclvalue(Desc.var),tclvalue(URL.var))
  names(miame.lst) <- c("ExperimentName","LabName","ContactInfo","ExperimentTitle","Description","URL")

  return(miame.lst)
}



# pW1 <- list(Name="Experiments's Name: ", Value="", toText=NULL, fromText=NULL, canEdit=TRUE, buttonFun = NULL, buttonText = NULL)

# pW2 <- list(Name="Laboratory: ", Value="", toText=NULL, fromText=NULL, canEdit=TRUE, buttonFun = NULL, buttonText = NULL)

# pW3 <- list(Name="Contact Information: ", Value="", toText=NULL, fromText=NULL, canEdit=TRUE, buttonFun = NULL, buttonText = NULL)

# pW4 <- list(Name="Experimental Title: ", Value="", toText=NULL, fromText=NULL, canEdit=TRUE, buttonFun = NULL, buttonText = NULL)

# pW5 <- list(Name="Experiment Description: ", Value="", toText=NULL, fromText=NULL, canEdit=TRUE, buttonFun = NULL, buttonText = NULL)

# pW6 <- list(Name="URL: ", Value="", toText=NULL, fromText=NULL, canEdit=TRUE, buttonFun = NULL, buttonText = NULL)

# widget1 <- list(wList = list(a = pW1, b = pW2, c = pW3, d = pW4, e = pW5, f = pW6), preFun = NULL, postFun = NULL)

# x <- widgetRender(widget1, "MIAME Information")

# This function takes a path and returns a vector containing names of
# files. A platform file separator will be appended to the end of
# subdirectory names.
#

appendSepDir <- function(path = ".") {

     toCheck <- list.files(path)

     if (length(toCheck) == 0) return("")

     isd <- file.info(file.path(path, toCheck))
     if(length(toCheck[isd$isdir]) != 0){
         # Separate dirs and files into two groups for better presentation
         dirs <- paste(toCheck[isd$isdir], .Platform$file.sep, sep = "")
     }else{
         dirs <- NULL
     }
     return(c(dirs, toCheck[!isd$isdir]))
}

tkSampleNames <- function(...,filenames=character(0)){


  auxnames <- as.list(substitute(list(...)))[-1]
  filenames <- .Primitive("c")(filenames, auxnames)

  NumSamples <- length(filenames)

  sample.names <- array("",NumSamples)

  for(i in 1:NumSamples){
    s2 <-strsplit(strsplit(filenames[[i]],"/")[[1]][length(strsplit(filenames[[i]],"/")[[1]])],"\\.")[[1]]
    sample.names[i] <- s2[1]
  }

  tt <- tktoplevel(width = 30)
  tkconfigure(tt, background = "white")
  tktitle(tt) <- "Sample Information"

  tbar.fr <- tkframe(tt,relief="sunken",borderwidth=5,width="5i")
  win.fr <- tkframe(tt,relief="sunken",borderwidth=5,width="5i",height="7i")
  tkconfigure(win.fr, background = "white")
  tkpack(tbar.fr,side="top",fill="x")
  tkpack(win.fr,side="top", fill="both")


  array.name.lst <- list()
  array.entry.lst <- list()


  var.lst <- list()
  for(i in 1:NumSamples) {
    var.lst[[i]] <-tclVar()
    tclvalue(var.lst[[i]]) <- sample.names[i]
  }

  desc.lst <- list()
  for(i in 1:NumSamples) {
    desc.var <- tclVar("")
    desc.lst <- c(desc.lst,list(desc.var))
  }


  array.var <- list()

  space.label1 <- tklabel(win.fr, text = "")
  tkconfigure(space.label1, background = "white")
  space.label2 <- tklabel(win.fr, text = "")
  tkconfigure(space.label2, background = "white")
  space.label3 <- tklabel(win.fr, text = "")
  tkconfigure(space.label3, background = "white")
  tkgrid(space.label1,row = 1)

  array.name.lst <- tklabel(win.fr, text="File PathNames")
  tkconfigure(array.name.lst, background = "white")
  tkgrid(array.name.lst, row = 2, column = 1)

  array.entry.lst <- tklabel(win.fr, text="Sample Names")
  tkconfigure(array.entry.lst, background = "white")
  tkgrid(array.entry.lst, row = 2, column = 2)

  desc.entry.lst <- tklabel(win.fr, text="Description")
  tkconfigure(desc.entry.lst, background = "white")
  tkgrid(desc.entry.lst, row = 2, column = 3)



  for(i in 1:NumSamples){
    array.name.lst[[i]] <-tklabel(win.fr, text=filenames[[i]])
    tkconfigure(array.name.lst[[i]], background = "white")
    tkgrid(array.name.lst[[i]], row = (i+2), column = 1)
    tkgrid.configure(array.name.lst[[i]], sticky = "e")

    array.entry.lst [[i]] <- tkentry(win.fr, width = 30, textvariable
    = var.lst[[i]])
    tkconfigure(array.entry.lst[[i]], background = "white")
    tkgrid(array.entry.lst[[i]], row = (i+2), column = 2)
    tkgrid.configure(array.entry.lst[[i]], sticky = "e")

    desc.entry.lst [[i]] <- tkentry(win.fr, width = 30, textvariable = desc.lst[[i]])
    tkconfigure(desc.entry.lst[[i]], background = "white")
    tkgrid(desc.entry.lst[[i]], row = (i+2), column = 3)
    tkgrid.configure(desc.entry.lst[[i]], sticky = "w")




  }


  tkgrid(space.label3,row=(NumSamples+7))
  finish.but <- tkbutton(win.fr, text = "Continue", command = function(){tkdestroy(tt)})
  tkconfigure(finish.but, background = "white")
  tkgrid(finish.but, row = (NumSamples + 8), column = 2)
  tkgrid.configure(finish.but, sticky="e")

  tkwait.window(tt)

  sam.vec <- matrix("",nrow=NumSamples,ncol=2)
  colnames(sam.vec) <- c("Sample Names","Description")
  for(i in 1:NumSamples){
    sam.vec[i,1] <- tclvalue(var.lst[[i]])
    sam.vec[i,2] <- tclvalue(desc.lst[[i]])}
  return(sam.vec)
}

# This function lists all the R packages in the library that have a
# Bioconductor vignettes and waits for the user to selecte one to
# explore.
#
# Copyrihgt, 2002, J. Zhang, all rights reserved
#

vExplorer <- function (title = "BioC Vignettes Explorer",
                       pkgName ="",
                       font = ifelse(.Platform$OS.type
                                    == "unix", "arial 14", "arial 11")){

    require("tools", character.only = TRUE) ||
    stop("Package tools not available!")

    on.exit(tkdestroy(base))
    PLATFORM <- .Platform$OS.type
    selectedPkg <- NULL
    vigList <- NULL

    end <- function(){
        tkdestroy(base)
    }

    # Executes when a user clicks a package name in the list of pkg names
    packSelected <- function(){
         selectedPkg <<-
             tclvalue(tkget(packViewer,(tkcurselection(packViewer))))
         if(selectedPkg != ""){
             writeList(statusBar, paste("Getting vignette names"), TRUE)
             # Make sure widget gets redrawn
             Sys.sleep(1)
             write2VigList(selectedPkg)
             writeList(statusBar, "Done", TRUE)
         }
    }
    # Writes vignette names to the list box for vignettes
    write2VigList <- function(selectedPkg){
         #checkMe <- .vigOrNot(selectedPkg)
         #if(is.null(checkMe)){
         #    tkmessageBox(title = "No vignette found",
         #            message = paste("Package", selectedPkg,
         #            "has no vignette"))
         #}else{
             vigList <<- pkgVignettes(selectedPkg)$docs
             names(vigList) <<- basename(vigList)
             writeList(vigViewer, names(vigList))
             #tkdelete(vigViewer, 0, "end")
             #for(i in names(vigList)){
                 #if(!inherits(chunkList, "try-error")){
             #        tkinsert(vigViewer, "end", i)
                 #}
             #}
         #}
    }

    # Executes when a user clicks a vignette name in the list of Rnw files
    vigSelected <- function(){
        selectedVig <-
             tclvalue(tkget(vigViewer,(tkcurselection(vigViewer))))
        if(selectedVig != ""){
            writeList(statusBar, paste("Loading", selectedVig), TRUE)
            # Make sure widget gets redrawn
            Sys.sleep(1)
            viewVignette(title, selectedPkg, vigList[[selectedVig]], font)
            writeList(statusBar, "", TRUE)
            # tkconfigure(vButton, state = "normal")
        }
    }

    # Executes when a user clicks the view button after selecting a
    # vignette
#    viewVig <- function(){
#        viewVignette(title, selectedPkg, vigList[[selectedVig]]$VigPath,
#                     vigList[[selectedVig]]$PDFpath, font)
#    }


    base <- tktoplevel()
    tktitle(base) <- title

    listFrame <- tkframe(base)

    # List box showing all the packages that have a vignette
    packFrame <- tkframe(listFrame)
    packName <- tklabel(packFrame, text = "Package List", font = font)
    tkpack(packName, side = "top")
    packViewer <- makeViewer(packFrame, hScroll = TRUE, vScroll = TRUE)
    tkconfigure(packViewer, selectmode = "browse")
    tkconfigure(packViewer, font = font)
    tkconfigure(packViewer, exportselection = FALSE)
    tkbind(packViewer, "<B1-ButtonRelease>", packSelected)
    tkpack(packFrame, side = "left", expand = TRUE, fill = "both")

    # List box for vignettes of a given package
    vigFrame <- tkframe(listFrame)
    vigName <- tklabel(vigFrame, text = "Vignette List", font = font)
    tkpack(vigName, side = "top")
    vigViewer <- makeViewer(vigFrame, hScroll = TRUE, vScroll = TRUE)
    tkconfigure(vigViewer, selectmode = "browse")
    tkconfigure(vigViewer, font = font)
    tkconfigure(vigViewer, exportselection = FALSE)
    tkbind(vigViewer, "<B1-ButtonRelease>", vigSelected)
    tkpack(vigFrame, side = "left", expand = TRUE, fill = "both")

    # Buttons to view a vignette and end the widget
#    vButton <- tkbutton(listFrame, text = "View", width = 8,
#                        font = font, command = viewVig)
#    tkpack(vButton, side = "left")

    # Put the three frames in
    tkpack(listFrame, expand = TRUE, fill = "both", pady = 4, padx = 4)
    # put in the end button
    endButton <- tkbutton(base, text = "End", width = 8,
                          font = font, command = end)
    tkpack(endButton, pady = 4)

    # Put a status
    tkpack(statusBar <- tkentry(base, foreground = "Red"),
           expand = FALSE, side = "bottom", fill = "x")

    # Populates the list box for package names
    packValid <- .popPackList(packViewer, pkgName)
    if(packValid && pkgName != ""){
        selectedPkg <- pkgName
        write2VigList(pkgName)
    }
    if(packValid){
        tkwait.window(base)
    }

    return(invisible())
}

.vigOrNot <- function(libName){
    options(show.error.messages = FALSE, warn = -1)
    tryMe <- list.files(file.path(.libPaths(), libName, "doc"))
    options(show.error.messages = TRUE, warn = 0)
    if(inherits(tryMe, "try-error")){
        return(FALSE)
    }else{
        if(length(grep("\\.Rnw", tryMe)) > 0){
            return(TRUE)
        }
    }
    return(FALSE)
}

# Check for the availability of vignettes and populate the list box
# for packages that have a vignette
.popPackList <- function(packViewer, packName){

    if(packName == ""){
        packs <- .packages(all = TRUE)
    }else{
        packs <- packName
    }
    goodNames <- sapply(packs, .vigOrNot)
    goodNames <- names(goodNames[goodNames])
    if(length(goodNames) > 0){
        writeList(packViewer, sort(goodNames))
        return(TRUE)
    }else{
         tkmessageBox(title = "No vignette found",
                      message = "Packages contain no vignette",
                      icon = "info",
                      type = "ok")
        return(FALSE)
    }
    #tkdelete(packViewer, 0, "end")
    #for(i in goodNames){
        #if(!is.null(pkgVignettes(i)) &&
        #   length(pkgVignettes(i)$docs) > 0){
    #        tkinsert(packViewer, "end", i)
        #}
    #}
}

# Returns package names that have a vignette
.getPackNames <- function(packName = ""){

    if(packName == ""){
        packNames <- .packages(all = TRUE)
    }else{
        packNames <- packName
    }

    goodNames <- NULL
    for(i in packNames){
        eval(call(deparse(substitute(require)), i, TRUE))
        path <- path.package(i)
        options(warn = -1)
        tryMe <- getPkgVigList(path)
        options(warn = 1)
        if(!is.null(tryMe))
        goodNames <- c(goodNames, i)
    }
    return(goodNames)
}

# This window is called by vExplorer for interacting with the code
# chunks of a vignette
viewVignette <- function(title, packName, vigPath, font = "arial 11"){
    end <- function(){
        tkgrab.release(base)
        tkdestroy(base)
    }
    on.exit(end)

    selectedChunk <- NULL
    buts <- vector("list")
    codeVersion <- NULL
    newCode <- FALSE
    executed <- NULL
    chunkOrNot <- "Code Chunk"

    chunkList <- getVignetteCode(vigPath)

    if(is.null(chunkList)){
        chunkOrNot <- "No Code Chunk"
        nameNCode <- NULL
#        tkmessageBox(title = "No code chunk found",
#                     message = paste(gsub(".*/(.*)", "\\1", vigPath),
#                     "does not contain any code chunk"))
#        return()
    }else{
        nameNCode <- .getNameNCode(chunkList)
#        codeVersion[[1]] <- chunkList
    }

    # Not implemented now but will be later
    #back <- function(){
    #    if(length(codeVersion) > 1){
    #        codeVersion <<- codeVersion[[-length(codeVersion)]]
    #    }
    #    if(length(codeVersion) == 1){
    #        tkconfigure(backButton, state = "disabled")
    #    }
    #    tempCode <- chunk(getChunk(codeVersion[[length(codeVersion)]]))
    #    tkdelete(editViewer, "1.0", "end")
    #   for(i in tempCode){
    #        tkinsert(editViewer, "end", paste(i, "\n", sep = ""))
    #    }
    #    tkdelete(resultViewer, 0, "end")
    #}

    # Executed when a user clicks the view PDF button
    viewPDF <- function(){
        options(show.error.messages = FALSE)
        temp <- try(vignette(gsub("\\..*", "", basename(vigPath))))
        options(show.error.message = TRUE)
        if(inherits(temp, "try-error")){
            tkmessageBox(title = "PDF File Error",
                         message = paste("No PDF files available for",
                                   basename(vigPath)),
                         icon = "",
                         type = "ok")
        }
    }
    # Shows the code chunk in a text box that allows the user to
    # editor the code chunk in the box but not to the actual code chunk
    showCode <- function(chunkName){
        tkdelete(editViewer, "1.0", "end")
        tkconfigure(resultViewer, state = "normal")
        tkdelete(resultViewer, "1.0", "end")
        tkconfigure(resultViewer, state = "disabled")
        for(i in nameNCode[[chunkName]]){
            tkinsert(editViewer, "end", paste(i, "\n", sep = ""))
        }
        tkconfigure(buts[[chunkName]], state = "active")
        if(chunkName != 1){
            tkconfigure(buts[[chunkName - 1]], state = "normal")
        }
        tkconfigure(execButton, state = "normal")
        tkconfigure(clearButton, state = "normal")
        tkconfigure(expoButton, state = "normal")
    }
    # Export code chunk to the R session
    export <- function(){
        temp <- objectBrowser(evalEnv(chunkList))
        for(i in names(temp)){
            assign(i, temp[[i]], env = .GlobalEnv)
        }
    }
    # Executes whatever that is in the text box for code chunk
    execute <- function(){
#        if(selectedChunk == 1 || any(executed == (selectedChunk - 1))){
            if(newCode){
                tempCode <- tclvalue(tkget(editViewer, "1.0", "end"))
                tempChunk <-
                    editVignetteCode(chunkList,
                                     selectedChunk,tempCode)
                result <- evalChunk(tempChunk, selectedChunk)
                newCode <<- FALSE
#                tkconfigure(backButton, state = "normal")
            }else{
                result <- evalChunk(chunkList, selectedChunk)
#                modButton(buts[[selectedChunk]], "libhtblue")
                tkconfigure(buts[[selectedChunk]], relief = "sunken",
                            state = "active")
                if(selectedChunk < length(buts)){
                    tkconfigure(buts[[selectedChunk + 1]], state = "normal")
                }

            }
            tkdelete(resultViewer, "", "end")
            tkconfigure(resultViewer, state = "normal")
            tkinsert(resultViewer, "end", result)
            tkconfigure(resultViewer, state = "disabled")
#            modButton(buts[[selectedChunk]], "blue")
#            executed <<- unique(c(executed, selectedChunk))
#        }else{
#             tkmessageBox(title = "Execution failed",
#                     message = "Code chunks need to be executed in order")
#        }
    }

    # keeps track of code modification done
    codeChanged <- function(){
        newCode <<- TRUE
    }

    # Cleans the boxes for code chunk and result of execution
    clear <- function(){
        tkdelete(editViewer, "1.0", "end")
        tkconfigure(resultViewer, state = "normal")
        tkdelete(resultViewer, "1.0", "end")
        tkconfigure(resultViewer, state = "disabled")
        for(i in 1:length(buts)){
            tkconfigure(buts[[i]], state = "disabled", relief = "raised")
#            modButton(buts[[i]], "green")
        }
        tkconfigure(buts[[1]], state = "normal")
        tkconfigure(execButton, state = "disabled")
        tkconfigure(expoButton, state = "disabled")
        tkconfigure(clearButton, state = "disabled")
        executed <<- NULL
        codeVersion[[1]] <<- chunkList
#        tkconfigure(backButton, state = "disabled")
    }

    # Changes the background colour of a widget
    modButton <- function(but, what){
        tkconfigure(but, background = what)
    }

    # Initilizes the buttons for code chunks
    popChunks <- function(){
        if(!is.null(nameNCode)){
            k <- 1
            for(i in names(nameNCode)){
                # Create button functions
                tempBut <- substitute(buts[[j]], list(j = k))

                fun <- function() {}
                body <- list(as.name("{"),
                             substitute(showCode(j),
                                        list(j = k)),
                             substitute(selectedChunk <<- j,
                                        list(j = k)))
                body(fun) <- as.call(body)
                assign(paste("chunkList",k,sep=""), fun)

                buts[[k]] <<- tkbutton(base, text= i, width = 13,
                                       state = "disabled", font = font,
                                       command = get(paste("chunkList",
                                       k, sep = "")))
                tkbind(buts[[k]], "<Double-Button-1>", execute)
                tkwindow.create(chunkText, "end", window = buts[[k]])
#                tkcreate(chunkText, "window", 5, space, anchor = "nw",
#                 window = buts[[k]])
                tkinsert(chunkText, "end", "\n")
                k <- k + 1
            }
            tkconfigure(buts[[1]], state = "normal")
        }
    }

    base <- tktoplevel()
    tktitle(base) <- title
    # Write package and vignette names
    pNvNames <- paste("Package:", packName, "   Vignette:", basename(vigPath))
    tkpack(tklabel(base, text = pNvNames, font = font), pady = 4)

    listFrame <- tkframe(base)
    # Create a text widgets for code chunks
    chunkFrame <- tkframe(listFrame)
    tkpack(tklabel(chunkFrame, text = chunkOrNot, font = font))
    chunkText <- makeViewer(chunkFrame, vWidth = 18, vHeight = NULL,
                      hScroll = TRUE, vScroll = TRUE, what = "text")
    tkconfigure(chunkText)
    popChunks()
    tkpack(chunkFrame, side = "left", anchor = "nw", expand = FALSE,
           fill = "y")

    # Create the viewers for code and results of execution
    codeNRelFrame <- tkframe(listFrame)
    editFrame <- tkframe(codeNRelFrame)
    tkpack(tklabel(editFrame, text = "R Source Code", font = font))
    eViewerFrame <- tkframe(editFrame)
    editViewer <- makeViewer(eViewerFrame, vWidth = 40, vHeight = 4,
                      hScroll = TRUE, vScroll = TRUE, what = "text")
    tkconfigure(editViewer, font = font)
    tkbind(editViewer, "<KeyRelease>", codeChanged)
    tkpack(eViewerFrame, expand = TRUE, fill = "both")
    tkpack(tklabel(editFrame, text = "Results of Execution", font = font))
    rViewerFrame <- tkframe(editFrame)
    resultViewer <-  makeViewer(rViewerFrame, vWidth = 40, vHeight = 4,
                      hScroll = TRUE, vScroll = TRUE, what = "text")
    tkconfigure(resultViewer, font = font)
    tkpack(rViewerFrame, expand = TRUE, fill = "both")
    tkpack(editFrame, expand = TRUE, fill = "both")
    tkpack(codeNRelFrame, side = "left", expand = TRUE, fill = "both")

    tkpack(listFrame, side = "top", expand = TRUE, fill = "both", padx
    = 4, pady = 6)

    # Put the buttons in
    butFrame <- tkframe(base)
    pdfButton <- tkbutton(butFrame, text = "View PDF", width = 12,
                          font = font, command = viewPDF)
    execButton <- tkbutton(butFrame, text = "Execute Code", width = 12,
                           font = font, command = execute)
    tkconfigure(execButton, state = "disabled")
    expoButton <- tkbutton(butFrame, text = "Export to R", width = 12,
                           font = font, command = export)
    tkconfigure(expoButton, state = "disabled")
    clearButton <- tkbutton(butFrame, text = "Clear", width = 12,
                            font = font, command = clear)
    tkconfigure(clearButton, state = "disabled")
    tkpack(pdfButton, execButton, expoButton, clearButton, side = "left")
    tkpack(butFrame, pady = 6)
    # Put end button separately to avoid accidents
    endButton <- tkbutton(base, text = "End", width = 12,
                          font = font, command = end)
    tkpack(endButton)

    tkgrab.set(base)

#    if(is.null(pdfPath) || is.na(pdfPath) || length(pdfPath) == 0){
#        tkconfigure(pdfButton, state = "disabled")
#    }
#    tkconfigure(resultViewer, state = "disabled")

#    tkwait.window(base)
}

.getNameNCode <- function(chunkList){
    chunkNum <- numChunks(chunkList)
    nameNCode <- list()
    for(i in 1:chunkNum){
        name <- chunkName(getChunk(chunkList, i))
        if(length(name) == 0){
            name <- paste("Code chunk", i)
        }
        nameNCode[[name]] <- chunk(getChunk(chunkList, i))
    }
    return(nameNCode)
}

# This widget gets all the R example code from R-ex directory of a
# given package and allows users to execute the example code chunks
# and view the result of the execution.
eExplorer <- function(pkgName, font = "arial 13", getFocus = TRUE){
    # An environment to evaluate the code within
    evalEnv <- new.env(hash = TRUE, parent = parent.frame())
    if(any(missing(pkgName), is.null(pkgName), is.na(pkgName),
           pkgName == "")){
        stop("Can not proceed without a package name")
    }
    if(!require(pkgName, character.only = TRUE)){
        stop(paste("Package name", pkgName, "is invalid"))
    }

    chunkList <- getExCode(pkgName)

    if(is.null(chunkList)){
        chunkOrNot <- "No example code obtained"
        nameNCode <- NULL
    }else{
        chunkOrNot <- "Example code chunk"
    }

    end <- function(){
        if(getFocus){
            tkgrab.release(base)
        }
        tkdestroy(base)
    }
    on.exit(end())
    showHelp <- function(){
         chunk <- as.character(tkget(chunkText,
                                          (tkcurselection(chunkText))))
         helpFile <- getHelpFile(pkgName, chunk)
         # Get rid of the "_\b"
         helpFile <- gsub("_\\\b", "", helpFile)
         tkconfigure(resultViewer, state = "normal")
         tkdelete(resultViewer, "1.0", "end")
         for(i in helpFile){
             tkinsert(resultViewer, "end", paste(i, "\n", sep = ""))
         }
         tkconfigure(resultViewer, state = "disabled")
     }

    # Shows the code chunk in a text box that allows the user to
    # editor the code chunk in the box but not to the actual code chunk
    showCode <- function(){
        chunk <- as.character(tkget(chunkText,
                                          (tkcurselection(chunkText))))
        tkconfigure(editViewer, state = "normal")
        tkdelete(editViewer, "1.0", "end")
        for(i in chunkList[[chunk]]){
            tkinsert(editViewer, "end", paste(i, "\n", sep = ""))
        }
        tkconfigure(editViewer, state = "disabled")
        tkconfigure(resultViewer, state = "normal")
        tkdelete(resultViewer, "0.0", "end")
        tkconfigure(resultViewer, state = "disabled")

        tkconfigure(execButton, state = "normal")
        tkconfigure(clearButton, state = "normal")
#        tkconfigure(expoButton, state = "normal")
        tkconfigure(helpButton, state = "normal")
    }
    # Export code chunk to the R session
    export <- function(){
        temp <- objectBrowser(evalEnv)
        for(i in names(temp)){
            assign(i, temp[[i]], env = .GlobalEnv)
        }
    }

    # Executes whatever that is in the text box for code chunk
    execute <- function(){
        expCode <- as.character(tkget(chunkText,
                                          (tkcurselection(chunkText))))
        tkconfigure(resultViewer, state = "normal")
        tkdelete(resultViewer, "0.0", "end")
        options(show.error.messages = FALSE)
        out <- try(capture.output(do.call(example, list(topic = expCode))))
        options(show.error.messages = TRUE)
        if(inherits(out, "try-error")){
            cont <- paste("Execution fauled because of:", out)
            tkinsert(resultViewer, "end", out)
                tkinsert(resultViewer, "end", "\n")
        }else{
            if(length(out) > 0 && out != "NULL"){
                for(outputs in out){
                    tkinsert(resultViewer, "end", outputs)
                    tkinsert(resultViewer, "end", "\n")
                }
            }
        }
        tkconfigure(resultViewer, state = "disabled")
        tkconfigure(expoButton, state = "normal")
    }

    # keeps track of code modification done
    #codeChanged <- function(){
    #    newCode <<- TRUE
    #}

    # Cleans the boxes for code chunk and result of execution
    clear <- function(){
        tkconfigure(editViewer, state = "normal")
        tkdelete(editViewer, "1.0", "end")
        tkconfigure(editViewer, state = "disabled")
        tkconfigure(resultViewer, state = "normal")
        tkdelete(resultViewer, "1.0", "end")
        tkconfigure(resultViewer, state = "disabled")

        tkconfigure(execButton, state = "disabled")
        tkconfigure(expoButton, state = "disabled")
        tkconfigure(clearButton, state = "disabled")
    }

    # Initilizes the buttons for code chunks
    popChunks <- function(){
        if(!is.null(chunkList)){
            writeList(chunkText, names(chunkList), TRUE)
        }
    }

    base <- tktoplevel()
    tktitle(base) <- "BioC R-ex Explorer\n"
    # Write package and vignette names
    pNvNames <- paste("Package:", pkgName,
                      "\nPick a code chunk to view/execute", sep = "")
    tkpack(tklabel(base, text = pNvNames, font = font), pady = 4)

    listFrame <- tkframe(base)
    # Create a text widgets for code chunks
    chunkFrame <- tkframe(listFrame)
    tkpack(tklabel(chunkFrame, text = chunkOrNot, font = font))
    chunkText <- makeViewer(chunkFrame, vWidth = 18, vHeight = NULL,
                      hScroll = TRUE, vScroll = TRUE, what = "list")
    tkbind(chunkText, "<B1-ButtonRelease>", showCode)
    popChunks()
    tkpack(chunkFrame, side = "left", anchor = "nw", expand = FALSE,
           fill = "y")

    # Create the viewers for code and results of execution
    codeNRelFrame <- tkframe(listFrame)
    editFrame <- tkframe(codeNRelFrame)
    tkpack(tklabel(editFrame, text = "R Source Code", font = font))
    eViewerFrame <- tkframe(editFrame)
    editViewer <- makeViewer(eViewerFrame, vWidth = 50, vHeight = 5,
                      hScroll = TRUE, vScroll = TRUE, what = "text")
    tkconfigure(editViewer, font = font)
    tkconfigure(editViewer, state = "disabled")
#    tkbind(editViewer, "<KeyRelease>", codeChanged)
    tkpack(eViewerFrame, expand = TRUE, fill = "both")
    tkpack(tklabel(editFrame, text = "Display window", font = font))
    rViewerFrame <- tkframe(editFrame)
    resultViewer <-  makeViewer(rViewerFrame, vWidth = 50, vHeight = 5,
                      hScroll = TRUE, vScroll = TRUE, what = "text")
    tkconfigure(resultViewer, font = font)
    tkpack(rViewerFrame, expand = TRUE, fill = "both")
    tkpack(editFrame, expand = TRUE, fill = "both")
    tkpack(codeNRelFrame, side = "left", expand = TRUE, fill = "both")

    tkpack(listFrame, side = "top", expand = TRUE, fill = "both", padx
    = 4, pady = 6)

    # Put the buttons in
    butFrame <- tkframe(base)
    helpButton <- tkbutton(butFrame, text = "View Help", width = 12,
                          font = font, state = "disabled",
                          command = showHelp)
    execButton <- tkbutton(butFrame, text = "Execute Code", width = 12,
                           font = font, command = execute)
    tkconfigure(execButton, state = "disabled")
    expoButton <- tkbutton(butFrame, text = "Export to R", width = 12,
                           font = font, command = export)
    tkconfigure(expoButton, state = "disabled")
    clearButton <- tkbutton(butFrame, text = "Clear", width = 12,
                            font = font, command = clear)
    tkconfigure(clearButton, state = "disabled")
    tkpack(helpButton, execButton, expoButton, clearButton, side = "left")
    tkpack(butFrame, pady = 6)
    # Put end button separately to avoid accidents
    endButton <- tkbutton(base, text = "End", width = 12,
                          font = font, command = end)
    tkpack(endButton)

    if(getFocus){
        tkgrab.set(base)
    }
    tkwait.window(base)

    return(invisible())
}

getExCode <- function(pkgName){
    options(show.error.messages = FALSE)
    tryMe <- try(list.files(file.path(path.package(pkgName), "R-ex")))
    options(show.error.messages = TRUE)

    if(inherits(tryMe, "try-error")){
        return(NULL)
    }
    # Make sure only to deal with files with an R extension
    tryMe <- tryMe[grep("\\.R", tryMe)]
    if(length(tryMe) == 0){
        return(NULL)
    }
    codeChunks <- list()
    for(i in tryMe){
        codeChunks[[gsub("\\.R", "", i)]] <- readLines(
                     file.path(path.package(pkgName), "R-ex", i))
    }
    return(codeChunks)
}

getHelpFile <- function(pkgName, fileName){
    if(any(missing(pkgName), missing(fileName))){
        return("Can't get help file because pkgName or fileName is missing")
    }
    if(any(is.null(pkgName), is.null(fileName), is.na(pkgName),
           is.na(fileName))){
        return(paste("Can't get help file because pkgName or",
                     "fileName is NULL or NA"))
    }
    options(show.error.message = FALSE)
    tryMe <- try(readLines(file.path(path.package(pkgName), "help",
                                     fileName)))
    options(show.error.messages = TRUE)
    if(inherits(tryMe, "try-error")){
        return("Can't get help file because pkgName or fileName is invalid")
    }else{
        return(tryMe)
    }
}

# This function provides preliminary visual data inport.
#
# Copyright 2002, J. Zhang, all rights reserved.

fileWizard <- function(filename = "", fun = read.table, file = "file",
                       basic = c("header", "sep"), getFocus = TRUE){

    BOLD12 <- "Helvetica 12 bold"
    NORMAL11 <- "Helvetica 11"
    BOXW <- 15

    args <- formals(fun)
    rest <- setdiff(names(args), c(file, basic))
    boxes <- vector("list")
    dList <- vector("list")
    fileRead <- NULL

    # Destroy the window
    end <- function(){
        if(getFocus){
            tkgrab.release(top)
        }
        tkdestroy(top)
    }
    on.exit(end)
    # Write toPop to a given entry box
#    writeEntry <- function(name, toPop){
#        tkdelete(name, "0", "end")
#        tkinsert(name, "end", toPop)
#    }
    # Initialize the list box if fileWizard is called with a file name
    init <- function(){
        if(!is.null(filename) && !is.na(filename) && filename != ""){
            tkinsert(nameEntry, "0", filename)
            writeList(fileText, readLines(filename))
            makeGuess(filename)
        }else{
            writeList(boxes[["header"]], "")
            writeList(boxes[["sep"]], "")
            tkconfigure(finishBut, state = "disabled")
        }
    }
    # Browse directories for a file
    brows <- function(){
        filename <<- tclvalue(tkcmd("tk_getOpenFile"))
        args$file <<- filename
        writeList(fileText, readLines(filename))
        writeList(nameEntry, args$file)
        makeGuess(args$file)
        tkconfigure(finishBut, state = "normal")
    }
    # Take a guess at the delimiter and header of a file
    makeGuess <- function(filename){
        headerNSep <- guess.sep(filename)
        args$header <<- headerNSep$header
        args$sep <<- headerNSep$separator
        if(is.element("header", basic)){
            writeList(boxes[["header"]], ifelse(args$header, "TRUE", "FALSE"))
        }
        if(is.element("sep", basic)){
            writeList(boxes[["sep"]], .sep2Entry(args$sep))
        }
    }
    # View the file after setting some of the arguments. Willl be
    # functioning later.
    view <- function(){
        fileRead <- read.table(file = args$file, head = args$header,
                               sep = args$sep, as.is = TRUE)

        fileRead <- as.matrix(fileRead)
        tkdelete(fileText, 0, "end")

        tkinsert(fileText, "end", fileRead[1:nrow(fileRead),])
    }
    # Read the file in before ending
    finish <- function(){
        for(i in names(boxes)){
            args[[i]] <<- .entry2Arg(tclvalue(tkget(boxes[[i]])))
        }
        fileRead <<- read.table(file = args$file, head = args$header,
                               sep = args$sep, as.is = TRUE)
        end()
    }
    # Not for this release yet
    #showMore <- function(){
    #    writeList(restList, rest)
    #}
    # Not for this release yet
    #update <- function(){
    #    cat("workds")
    #}
    # Not for this release yet
    #argSelected <- function(){
    #    selectedArg <<-
    #        tclvalue(tkget(restList,(tkcurselection(restList))))
    #    writeList(restEntry, args[[selectedArg]])
    #    tkconfigure(restUp, state = "normal")
    #}
    # Set up the interface
    top <- tktoplevel()
    tktitle(top) <- "BioC Data Import Wizard"
    # The top frame that has an entry box for a file name
    nameFrame <- tkframe(top)
    nameLabel <- tklabel(nameFrame, text = "File name:", font = NORMAL11)
    nameEntry <- tkentry(nameFrame, width = 60)
    browsBut <- tkbutton(nameFrame, text = "Browse", command = brows)
    tkpack(nameLabel, side = "left", padx = 2, pady = 4)
    tkpack(nameEntry, side = "left", padx = 2, pady = 4)
    tkpack(browsBut, side = "left", padx = 2, pady = 4)
    tkgrid(nameFrame, columnspan = 2, sticky = "w")
    # Put the entry boxes for basic arguments
    argFrame <- tkframe(top)
    i <- 1
    while(i <= length(basic)){
        if(i != length(basic)){
            frame1 <- tkframe(argFrame)
            boxes[[basic[i]]] <- tkentry(frame1, width = BOXW)
            tempLabel <- tklabel(frame1, text = paste(basic[i], ": ",
                            sep = ""), font = NORMAL11)
            tkgrid(tempLabel, boxes[[basic[i]]])
            frame2 <- tkframe(argFrame)
            boxes[[basic[i + 1]]] <- tkentry(frame2, width = BOXW)
            tempLabel <- tklabel(frame2, text = paste(basic[i + 1],
                                   ": ", sep = ""),
                                 font =NORMAL11)
            tkgrid(tempLabel, boxes[[basic[i + 1]]])
            tkgrid(frame1, frame2, padx = 10)
            tkgrid.configure(frame1, sticky = "w")
            tkgrid.configure(frame2, sticky = "e")
            writeList(boxes[[basic[i]]], args[[basic[i]]])
            writeList(boxes[[basic[i + 1]]], args[[basic[i + 1]]])
        }else{
            # Write the one that is left if the total is an odd number
            frame1 <- tkframe(argFrame)
            boxes[[basic[i]]] <- tkentry(frame1, width = BOXW)
            tempLabel <- tklabel(frame1, text = paste(basic[i], ": ",
                            sep = ""), font = NORMAL11)
            tkgrid(tempLabel, boxes[[basic[i]]])
            tkgrid.configure(tempLabel, sticky = "w")
            tkgrid.configure(boxes[[basic[i]]], sticky = "e")
            frame2 <- tkframe(argFrame)
            frame2 <- tkframe(argFrame)
            tkgrid(frame1, frame2, padx = 10)
            writeList(boxes[[basic[i]]], args[[basic[i]]])
        }
        i <- (i + 2)
    }
    tkgrid(argFrame, columnspan = 2)
    # Put in the rest of the arguments. Not for this release
#    restFrame <- tkframe(top)
#    bFrame <- tkframe(restFrame)
#    restButton <- tkbutton(bFrame, text = "More", width = 10,
#                           command = showMore)
#    tkpack(restButton)
#    restUp <- tkbutton(bFrame, text = "Update", width = 10,
#                       command = update)
#    tkpack(restUp)
#    tkpack(bFrame, side = "left", padx = 10)
#    listFrame <- tkframe(restFrame)
#    restList <- makeViewer(listFrame, vHeight = 2, vWidth = 20,
#                           vScroll = TRUE)
#    tkpack(listFrame, side = "left")
#    tkbind(restList, "<B1-ButtonRelease>", argSelected)
#    dFrame <- tkframe(restFrame)
#    restLabel <- tklabel(dFrame, text = "Default Value:")
#    tkpack(restLabel)
#    restEntry <- tkentry(dFrame, width = 20)
#    tkpack(restEntry)
#    tkpack(dFrame, side = "left", padx = 10)
#    tkgrid(restFrame, columnspan = 2, pady = 10)
#    tkconfigure(restUp, state = "disabled")
    # Put the window for viewing a file
    fileFrame <- tkframe(top)
    fileLabel <- paste("Preview of file:", filename)
    previewLabel <- tklabel(fileFrame, text = fileLabel,
                            font = NORMAL11)
    tkgrid(previewLabel, pady = 4, padx = 2, sticky = "nw")
    textFrame <- tkframe(fileFrame)
    fileText <- makeViewer(textFrame, vWidth = 20, vHeight = 15,
                           vScroll = TRUE, hScroll = TRUE,
                           what = "list")
    tkgrid(textFrame)
    tkgrid(fileFrame, columnspan = 2, padx = 2)
    # Put the buttons for different functions
    butFrame <- tkframe(top)
    cancelBut <- tkbutton(butFrame, text = "Cancel", width = 10,
                          command = end)
#    backBut <- tkbutton(butFrame, text = "< Back", width = 10,
#                        command = init)
#    viewBut <- tkbutton(butFrame, text = "View", width = 10,
#                        command = view)
    finishBut <- tkbutton(butFrame, text = "Finish", width = 10,
                          command = finish)
    tkpack(cancelBut, finishBut, side = "left",
           padx = 2)
    tkgrid(butFrame, columnspan = 2, pady = 4)

    init()

    if(getFocus){
        tkgrab.set(top)
    }
    tkwait.window(top)

    return(fileRead)
}
# Format a delimiter so that it can be displayed in an entry box
.sep2Entry <- function(sep){
    switch(sep,
           "\t" = return("\\t"),
           " " = return("\" \""),
           "\n" = return("\\n"),
           return(sep))
}

.entry2Arg <- function(entry){
    switch(entry,
           "T" = ,
           "TRUE" = ,
           "True" = ,
           "true" = return(TRUE),
           "F" = ,
           "FALSE" = ,
           "False" = ,
           "false" = return(FALSE),
           "\\t" = return("\t"),
           "\"\"" = return(""),
           "\" \"" = return(" "),
           return(entry))
}

# This function checks a vector of file names from a directory and
# determins what to be sent for desplay on the fileBrowser  based
# on the default and user speficied parameters.
#
# Copyright 2002, J. Zhang. All rights reserved.
#
pickFiles <- function (fileNames, fun = function(x) TRUE,
                       prefix = NULL, suffix = NULL,
                       exclude = .Platform$file.sep){

    unTouched <- fileNames[regexpr(exclude, fileNames) > 0]
    rest <- setdiff(fileNames, unTouched)
    if(length(rest) > 0){
        rest <- rest[sapply(rest, fun)]

        if(!is.null(prefix)){
            tryMe <- hasChar(prefix, "prefix")
            rest <- rest[sapply(rest, tryMe)]
        }
        if(!is.null(suffix)){
            tryMe <- hasChar(suffix, "suffix")
            rest <- sapply(rest, tryMe)
        }
        return(c(unTouched, rest))
    }else{
        return(unTouched)
    }
}

# Function widgetRender takes a list of a widget list that has a name,
# value, ... buttonText, and buttonFun as shown below plus a
# prefunction, postfunction, and a few buttons. The functions listed
# here provide a defined interface for accessing and manipulate these
# values. The functions are currently temporary and will be modified
# for better names.

WName <- function(x) x$Name
WValue <- function(x) x$Value
"WValue<-" <- function(x, value) {x$Value <- value; x}
WtoText <- function(x) x$toText
WfromText <- function(x) x$fromText
WcanEdit <- function(x) x$canEdit
WbuttonText <- function(x) x$buttonText
WbuttonFun <- function(x) x$buttonFun

#get and set the widget list
##FIXME: shouldn't these be getWidgetList and setWidgetList?
WwList <- function(x) x$wList
"WwList<-" <- function(x, value) {x$wList[names(value)] <- value; x}

##what about getIndexValuepWidget and setIndexValuepWidget
#get and set index' pWidgets value
WLValue <- function(x, index) WValue(WwList(x)[[index]])
"WLValue<-" <- function(x, index, value)
    {WValue(WwList(x)[[index]]) <- value; x}


WpreFun <- function(x) x$preFun
WpostFun <- function(x) x$postFun
WRButtons <- function(x) x$buttons
WEnd <- function(x) x$end

# Functions that initializes or constructs a colInfo class/object
# name - the name for a column
# type - data type for a column
# dropOrNot - a boolean indicating whether the column will be droped

    setClass("colInfo", representation(colName = "character",
                                       colType = "character",
                                       dropOrNot = "logical"))
    # Set the get methods
    setGeneric("colName",
               function(object) standardGeneric("colName"))
    setMethod("colName", "colInfo",
              function(object) object@colName)
    
    setGeneric("colType",
               function(object) standardGeneric("colType"))
    setMethod("colType", "colInfo",
              function(object) object@colType)
    
    setGeneric("dropOrNot",
               function(object) standardGeneric("dropOrNot"))
    setMethod("dropOrNot", "colInfo",
              function(object) object@dropOrNot)
    # Define the replace methods
    setGeneric("colName<-", function(object, value)
                   standardGeneric("colName<-"))
    setReplaceMethod("colName", "colInfo", function(object, value){
                  object@colName <- value; object})
    
    setGeneric("colType<-", function(object, value)
                   standardGeneric("colType<-"))
    setReplaceMethod("colType", "colInfo", function(object, value){
                  object@colType <- value; object})
  
    setGeneric("dropOrNot<-", function(object, value)
                   standardGeneric("dropOrNot<-"))
    setReplaceMethod("dropOrNot", "colInfo", function(object, value){
                  object@dropOrNot <- value; object})

colInfo <- function(name, type, drop){
    new("colInfo", colName = name, colType = type, dropOrNot = drop)
}

# These functions provide standard outputs that are going to be
# rendered to a widget to indicate the type or value of the R object
# shown on the widget.
#
# Copyright 2002, J. Zhang. All rights reserved
#

##what is formular????
##is this really what you want?? shouldn't it always use a class if 
##there is one? 
stdType <- function(toCheck){
    if(inherits(toCheck, "formular")){
        return("formula")
    }else{
        return(mode(toCheck))
    }
}

stdView <- function(toView){
    if(inherits(toView, "formular")){
        toView <- format(toView)
    }
    objViewer(toView)
}

# This function provides data import interfaces by mimicing MS Excel's
# Text Wizard. read.table will be used to import the data.
#
# filename - an optional character string for the name of the file to
# be imported
# maxRow - an integer for the maximum number of rows to be
# displayed. Large row numbers may slow down the machine
#
# Copyright 2002, J. Zhang, all rights reserved.

importWizard <- function(filename = NULL, maxRow = 400){
    argsSet <- FALSE
    # Creates an environment to make some variables available to all
    # related functions
    workEnv <- new.env(hash = TRUE, parent = emptyenv())
    # A string to keep track of the current state
    assignCState("state1", env = workEnv)

    if(!is.null(filename)){
        lineNums <- length(readFileByLines(filename))
        if(!is.null(lineNums)){
            argsSet <- setArgsList(filename, workEnv)
        }
    }else{
        # Otherwise, assign an empty list to argsList and colInfo
        assignArgs(list(), workEnv)
        #setColInfos(env = workEnv)
        lineNums <- maxRow
        argsSet <- TRUE
    }
    if(argsSet){
        # Number of row to be displayed
        assignShowNum(ifelse(maxRow > lineNums, lineNums,
                             maxRow), env = workEnv)
        # Initializes the interface
        initImportWizard(workEnv)
    }
}

readFileByLines <- function(filename){
    conn <- safeFileOpen(filename)
    if(inherits(conn, "connection")){
        lines <- readLines(conn)
        close(conn)
        return(lines)
    }else{
        tkmessageBox(title = "IO Error",
                     message = paste("can't open file because", conn),
                     icon = "error", type = "ok")
        return(NULL)
    }
}
# Using function guess.sep to figure out the the header, sep, and data
# type of a file and sets the argument list and colInfo
setArgsList <- function(filename, env, isFile = TRUE, init = TRUE){
    options(show.error.messages = FALSE, warn = -1)
    fileInfo <- try(guess.sep(file.name = filename, numLine = 40,
                              isFile = isFile))
    options(show.error.messages = TRUE, warn = 0)
    if(inherits(fileInfo, "try-error")){
        tkmessageBox(title = "Incorrect File Name",
                 message = paste("An error message:\n\n", fileInfo,
                           "\nwas generated while reading file",
                           filename, "."), icon = "error", type = "ok")
        return(FALSE)
    }else{
        env$rowNameCol <- 0
        if(init){
            argsList <- list()
            temp <- formals("read.table")
            temp[["file"]] <- filename
            temp[["header"]] <- fileInfo[["header"]]
            temp[["sep"]] <- fileInfo[["separator"]]
            #chrNBothtemp[["quote"]] <- ""
            # Reassign fill with the value of blank.lines.skip
            temp[["fill"]] <- !temp[["blank.lines.skip"]]
            argsList[["state1"]] <- as.list(temp)
        }else{
            argsList <- getArgs(env)
            argsList[["state1"]][["header"]] <- fileInfo[["header"]]
            argsList[["state1"]][["sep"]] <- fileInfo[["separator"]]
        }
        assignArgs(argsList, env)
        #setColInfos(fileInfo[["type"]], env)
        if(isFile){
            fileLines <- readFileByLines(filename)
            if(!is.null(fileLines)){
                assignLineData(fileLines[1:min(length(fileLines),
                                               getShowNum(env))], env)
                assignShowNum(min(length(fileLines), getShowNum(env)), env)
            }else{

            }
        }else{
            assignLineData(filename, env)
        }
        return(TRUE)
    }
}
# Set the temp data read as lines with a maxmun number
assignLineData <- function(lineData, env){
    assign("lineData", lineData, env = env)
}
# Get the temp data stroed as lines with a maxmun number
getLineData <- function(env){
    env$lineData
}
# Set and get methods for argument list
assignArgs <- function(value, env){
    assign("argsList", value, env = env)
}
getArgs <- function(env){
    env$argsList
}
# Set and get methods for number to show in the interface
assignShowNum <- function(value, env){
    assign("showNum", value, env)
}
getShowNum <- function(env){
    env$showNum
}
# Set and get methods for current state to keep track of the state
assignCState <- function(value, env){
    assign("currentState", value, env)
}
getCState <- function(env){
    env$currentState
}

# Set and get methods for colInfo that is a list of colInfo objects to
# keep column name, type, and drop info
assignColInfo <- function(value, env){
    assign("colInfos", value, env)
}
getColInfo <- function(env){
    env$colInfos
}
# Creates colInfo objects and sets the value of 'colInfos' list
setColInfos <- function(types, env){
#    initColInfo()
    if(missing(types)){
        assignColInfo(list(), env)
    }else{
        temp <- list()
        for(i in 1:length(types)){
            # name = "", type = types[i], dropOrNot = FALSE
            temp[[i]] <- colInfo("", types[i], FALSE)
        }
        assignColInfo(temp, env)
    }
}
# This function initializes the interface for importWizard by creating
# a widget with an empty top canvas and bottom frame filled with four buttons
initImportWizard <- function(env){
    # A list to be returned that contains an argument list and data
    # imported using read.table
    dataList <- NULL
    # A variable to keep the frame that is currently displayed
    #currentFrame <- NULL

    on.exit(end())
    # Destroy the window
    end <- function(){
        tkgrab.release(top)
        tkdestroy(top)
    }

    nextState <- function(){
        args <- getArgs(env)
        if(is.null(args[["state1"]][["file"]])){
            tkmessageBox(title = "Import Error",
                         message = "I do not know what file to import!",
                         icon = "error",
                         type = "ok")
        }else{
            tempFrame <- changeState(canvas, backBut, nextBut, env, TRUE,
                                 endBut, viewBut)
            tkdestroy(currentFrame)
            tkpack(tempFrame, fill = "both", expand = TRUE)
            currentFrame <<- tempFrame
        }
    }
    preState <- function(){
        tempFrame<- changeState(canvas, backBut, nextBut, env, FALSE,
                                endBut, viewBut)
        tkdestroy(currentFrame)
        tkpack(tempFrame, fill = "both", expand = TRUE)
        currentFrame <<- tempFrame
    }
    redraw <- function(){
        tempFrame <- getAFrame(canvas, env)
        tkdestroy(currentFrame)
        tkpack(tempFrame, fill = "both", expand = TRUE)
        currentFrame <<- tempFrame
    }
    finishClicked <- function(){
        dataList <<- finish(env)
        if(!is.null(dataList)){
            end()
        }
    }

    ## Set up the interface
    top <- tktoplevel()
    tktitle(top) <- "BioC Data Import Wizard"
    # Set the empty canvas that will be filled later
    canvas <- getTopCan(top, env)
    # Sets current frame to state1 now
    currentFrame <- getAFrame(canvas, env)
    tkpack(currentFrame, fill = "both", expand = TRUE)
    #tkcreate(canvas, "window", 0, 0, anchor = "nw", window = currentFrame)
    ## The bottom frame contains the buttons that allow users to
    ## navigate the importing process
    butFrame <- tkframe(top)
    viewBut <- tkbutton(butFrame, text = "View", width = 8,
                        state = "disabled", command = redraw)
    canBut <- tkbutton(butFrame, text = "Cancel", width = 8,
                       command = end)
    backBut <- tkbutton(butFrame, text = "< Back", width = 8,
                        state = "disabled", command = preState)
    nextBut <- tkbutton(butFrame, text = "Next >", width = 8,
                        command = nextState)
    endBut <- tkbutton(butFrame, text = "Finish", width = 8,
                       state = "disabled", command = finishClicked)
    tkpack(canBut, backBut, nextBut, endBut, side = "left")
    tkpack(butFrame, pady = 10, fill = "y", expand = TRUE)

    args <- getArgs(env)
    tkgrab.set(top)
    tkwait.window(top)
    return(invisible(dataList))
}
# Creates a top frame of an empty canvas
getTopCan <- function(base, env){
    WIDTH <- 730
    HEIGHT <- 400
    ## The canvas has widgets for the relevant
    ## arguments and preview of the original data. The content various
    ## depending on the state
    canvas <- makeViewer(base, vWidth = WIDTH, vHeight = HEIGHT,
                           vScroll = FALSE, hScroll = FALSE,
                           what = "canvas", side = "top")

    return(canvas)
}
# Changes the state and thus the interface
changeState <- function(canvas, backBut, nextBut, env, forward = TRUE,
                        endBut, viewBut){
    # Sets the current state
    setNewState(env, backBut, nextBut, forward, endBut, viewBut)
    if(forward){
        addArgs(env)
    }else{
        dropArgs(env)
    }
    return(getAFrame(canvas, env))
#    tkcreate(canvas, "window", 0, 0, anchor = "nw", window = newFrame)
}
# Sets the string for the new state (next or previous) and
# actviates/inactivates buttons depending on the state
setNewState <- function(env, backBut, nextBut, forward = TRUE,
                        endBut, viewBut){
    if(forward){
        if(getCState(env) == "state1"){
            assignCState("state2", env)
            tkconfigure(backBut, state = "normal")
            tkconfigure(viewBut, state = "normal")
        }else{
            assignCState("state3", env)
            tkconfigure(nextBut, state = "disabled")
            tkconfigure(endBut, state = "normal")
            tkconfigure(viewBut, state = "disabled")
        }
    }else{
        if(getCState(env) == "state2"){
            env$rowNameCol <- 0
            assignCState("state1", env)
            tkconfigure(nextBut, state = "normal")
            tkconfigure(backBut, state = "disabled")
            tkconfigure(viewBut, state = "disabled")
        }else{
            assignCState("state2", env)
            tkconfigure(nextBut, state = "normal")
            tkconfigure(endBut, state = "disabled")
            tkconfigure(viewBut, state = "normal")
        }
    }
}
# Add a new state arguments list to argsList
addArgs <- function(env){
    temp <- getArgs(env)
    if(length(temp) == 1){
        temp[["state2"]] <- temp[[length(temp)]]
        assignArgs(temp, env)
    }else{
        temp[["state3"]] <- temp[[length(temp)]]
        assignArgs(temp, env)
    }
}
# Drop a state arguments list from argsList when the back button is clicked
dropArgs <- function(env){
    temp <- getArgs(env)
    if(length(temp) > 1){
        temp <- temp[-length(temp)]
        assignArgs(temp, env)
    }
}
# Gets a frame based on which state is of interest
getAFrame <- function(base, env){
    switch(getCState(env),
           "state1" = return(getState1Frame(base, env)),
           "state2" = return(getState2Frame(base, env)),
           "state3" = return(getState3Frame(base, env)))
}
# The importing process ends. Return a list with argument list and
# data read using read.table as elements
finish <- function(env){
    args <- getArgs(env)[["state3"]]
    if(is.null(args[["quote"]])){
        args[["quote"]] <- "\"'"
    }
    dataName <- getName4Data(args[["file"]], "data frame")
    conn <- safeFileOpen(args[["file"]])
    if(inherits(conn, "connection")){
        args[["file"]] <- conn
        options(show.error.messages = FALSE)
        dataFile <- try(do.call(read.table, args))
        options(show.error.messages = TRUE)
        #close(args[["file"]])
        if(inherits(dataFile, "try-error")){
            tkmessageBox(title = "Import Error",
                     message = paste("An error message:\n\n", dataFile,
                     "\nwas generated while reading file ",
                     args[["file"]], "."), icon = "error", type = "ok")
        }else{
            if(env$rowNameCol != 0){
                rownames(dataFile) <- dataFile[, env$rowNameCol]
                dataFile <- dataFile[, - env$rowNameCol]
            }
            colInfos <- getColInfo(env)
            colNames <- NULL
            colToDrop <- NULL
            for(i in 1:length(colInfos)){
                if(dropOrNot(colInfos[[i]])){
                    colToDrop <- c(colToDrop, i)
                }else{
                    switch(colType(colInfos[[i]]),
                           "Character" = dataFile[, i] <-
                           as.character(dataFile[, i]),
                           "Numeric" = dataFile[, i] <-
                           as.numeric(dataFile[, i]))
                    colNames <- c(colNames, colName(colInfos[[i]]))
                }
            }
            # Drop the columns
            if(!is.null(colToDrop)){
                dataFile <- dataFile[, -colToDrop]
            }
            # In case there is only one column left
            if(is.null(ncol(dataFile))){
                dataFile <- data.frame(matrix(dataFile, ncol = 1))
                names(dataFile) <- colNames
            }else{
                colnames(dataFile) <- colNames
            }
            if(!is.null(dataName)){
                assign(dataName, dataFile, env = .GlobalEnv)
            }
            return(list(args = args, data = dataFile))
        }
    }else{
        tkmessageBox(title = "IO Error",
                     message = paste("Can't open file because", conn),
                     icon = "error", type = "ok")
    }
    return(NULL)
}
# Gets the frame containing the interface for the top frame of
# importWizard for state1
getState1Frame <- function(base, env){
    # A frame containing the interface that will be returned
    frame <- tkframe(base)
    # The bottom frame contains a list box showing the data. The
    # bottom frame is set first to make the list box available for
    # updating by the top frame
    bottomFrame <- tkframe(frame)
    dataViewer <- setState1BFrame(bottomFrame, env)
    # The mid frame contains the delimiter and number line
    # information.
    midFrame <- tkframe(frame)
    delims <- setState1MFrame(midFrame, env, dataViewer)
    # The top frame contains a entry box and a browse button that
    # allows for browing directories for a file name
    topFrame <- tkframe(frame)
    setState1TFrame(topFrame, dataViewer, delims, env, delims[["start"]])
    tkpack(topFrame, pady = 5, padx = 5, fill = "both", expand = TRUE)
    tkpack(midFrame, padx = 5, fill = "both", expand = TRUE)
    # Pack the bottom frame last
    tkpack(bottomFrame, pady = 5, padx = 5, fill = "both", expand = TRUE)
    return(frame)
}
# Sets the botton frame for state1
setState1BFrame <- function(frame, env){
    # A list box to show the original data
    viewFrame <- tkframe(frame)
    dataViewer <- makeViewer(viewFrame, vWidth = 50, vHeight = 10,
                            vScroll = TRUE, hScroll = TRUE,
                            what = "list", side = "top")
    tkpack(viewFrame, anchor = "w", pady = 10, fill = "both",
                                                      expand = TRUE)
    return(dataViewer)
}
# Sets the top frame for state1
setState1TFrame <- function(frame, viewer, delims, env, startList){
    fName <- tclVar()
    # Populate the entry box for file name when the brose button is
    # clicked
    browse <- function(){
        filename <- tclvalue(tkgetOpenFile())
        if(filename != ""){
            writeList(nameEntry, filename, clear = TRUE)
            argsSet <- setArgsList(filename, env)
            if(argsSet){
                showData4State1(viewer, env)
                if(!is.null(getArgs(env)[["state1"]][["sep"]])){
                    tkselect(delims[["delimit"]])
                }
                popStartLine(startList, env)
            }
        }
    }
    # Get the file
    getFile <- function(){
        argsSet <- setArgsList(tclvalue(fName), env)
        if(argsSet){
            showData4State1(viewer, env)
            if(!is.null(getArgs(env)[["state1"]][["sep"]])){
                tkselect(delims[["delimit"]])
            }
        }
    }

    # Frame to hole the widgets
    nameFrame <- tkframe(frame)
    label1 <- tklabel(nameFrame, text = "File name: ")
    tkpack(label1, side = "left")
    # An entry box to hold the result of fileBrowser
    nameEntry <- tkentry(nameFrame, width = 20, textvariable = fName)
    tkbind(nameEntry, "<KeyPress-Return>", getFile)
    # If a file name is given, fill the widget with data
    if(!is.null(getArgs(env)[["state1"]][["file"]])){
        writeList(nameEntry, getArgs(env)[["state1"]][["file"]], clear = TRUE)
        showData4State1(viewer, env)
        if(length(getArgs(env)[["state1"]][["sep"]]) != 0){
            tkselect(delims[["delimit"]])
        }
    }
    tkpack(nameEntry, side = "left", fill = "x", expand = TRUE)
    # A button to envoke fileBrowser
    browseBut <- tkbutton(nameFrame, width = 6, text = "Browse",
                          command = browse)
    getBut <- tkbutton(nameFrame, width = 6, text = "Get",
                       command = getFile)
    tkpack(browseBut, side = "left", fill = "x")
    tkpack(getBut, side = "left", fill = "x")
    tkpack(nameFrame, fill = "both", expand = TRUE)
}
# Show the data read in using readLines for state1
showData4State1 <- function(widget, env){
     #skip <- getArgs(env)[["state1"]][["skip"]]
     #if(!is.null(skip)){
         dataFile <- getLineData(env)
     #    showNum <- getShowNum(env)
     #    if(length(dataFile) > showNum){
     #        dataFile <- dataFile[(skip + 1):showNum]
     #    }else{
     #        dataFile <- dataFile[(skip + 1):length(dataFile)]
     #    }
     #}#else{
      #   dataFile <- getLineData(env)
     #}
     # Preventing the header to be shown
     if(getArgs(env)[["state1"]][["header"]]){
         dataFile <- dataFile[2:length(dataFile)]
     }
     # determines how many lines to show
     if(length(dataFile) > getShowNum(env)){
         writeList(widget, paste(1:getShowNum(env), ": ",
                             dataFile[1:getShowNum(env)], sep = ""), TRUE)
     }else{
         writeList(widget, paste(1:length(dataFile), ": ",
                                                dataFile, sep = ""), TRUE)
     }
}
# Sets the mid frame for state1
setState1MFrame <- function(frame, env, dataViewer){
    # Executed when values in start at row list box is clicked
    startClicked <- function(){
        args <- getArgs(env)
        if(length(args) != 0 && args[["state1"]][["file"]] != ""){
            setSkip(startList, env)
            #args <- getArgs(env)
            #skip <- as.numeric(as.character(tkget(startList,
            #                     tkcurselection(startList)))) - 1
            #skip <- as.numeric(args[["state1"]][["skip"]])

            #assignShowNum((getShowNum(env) + skip), env)
            #dataFile <- getLineData(env)
            #showNum <- getShowNum(env)
            #if(length(dataFile) > showNum){
            #    dataFile <- dataFile[(skip + 1):showNum]
            #}else{
            #    dataFile <- dataFile[(skip + 1):length(dataFile)]
            #}
            #setArgsList(args[["state1"]][["file"]], env, TRUE, FALSE)
            #        showData4State1(dataViewer, env)
        }
    }
    leftPan <- tkframe(frame)
    delimit <- tclVar()
    delimitRadio <- tkradiobutton(leftPan, text = paste("Delimited",
                                  " - Files are separated by a character",
                                  " such as a comma, tab ...", sep =""),
                                  value = "delim", variable = delimit,
                                  anchor = "nw")
    tkpack(delimitRadio, anchor = "w", expand = TRUE, fill = "x")
    fixedRadio <- tkradiobutton(leftPan, text = paste("Fixed",
                                " width - Fields are aligned in columns",
                                " with spaces between fields", sep = ""),
                                value = "fixed", variable = delimit,
                                anchor = "nw")
    tkpack(fixedRadio, anchor = "w", expand = TRUE, fill = "x")
    tkpack(leftPan, side = "top", anchor = "w",
           pady = 5, padx = 5, fill = "x", expand = TRUE)

    rightPan <- tkframe(frame, borderwidth = 2, relief = "groove")
    paraLabel2 <- tklabel(rightPan, text = paste("Start importing data from",
                          "line "))
    tkpack(paraLabel2, side = "left", anchor = "ne")
    startFrame <- tkframe(rightPan)
    startList <- makeViewer(startFrame, vWidth = 2, vHeight = 1,
                            what  = "list", side = "top")
    tkconfigure(startList, selectmode = "single")
    tkbind(startList, "<B1-ButtonRelease>", startClicked)
    popStartLine(startList, env)
    tkpack(startFrame, anchor = "w", side = "left",
                                          fill = "x", expand = TRUE)
    tkpack(tklabel(rightPan, text = " of the file shown below"),
           side = "left", expand = FALSE,  anchor = "ne")
    tkpack(rightPan, side = "top", padx = 5, pady = 5,
           expand = TRUE, fill = "x")
    return(list(delimit = delimitRadio, fixed = fixedRadio,
                start = startList))
}

popStartLine <- function(startList, env){
    args <- getArgs(env)
    if(length(args) != 0 && args[["state1"]][["file"]] != ""){
        writeList(startList, 1:(getShowNum(env) - 1), clear = TRUE)
        startLine <- getArgs(env)
        if(length(startLine) == 0 ||
           length(startLine[["state1"]][["skip"]]) == 0){
            line2Start <- 0
        }else{
            line2Start <- startLine[["state1"]][["skip"]]
        }
        tkselection.set(startList, line2Start)
    }
}

# Sets the value for skip when user selects line to start in
# state1
setSkip <- function(widget, env, state = "state1"){
    temp <- getArgs(env)
    temp[[state]][["skip"]] <- as.numeric(as.character(tkget(widget,
                                 tkcurselection(widget)))) - 1
    assignArgs(temp, env)
}
# Gets a frame for state2
getState2Frame <- function(base, env, state = "state2",
                           reset = FALSE){
    bottomFrame <- NULL

    applySep <- function(){
        tkdelete(dataView, "0.0", "end")
        showData4State2(dataView, env)
        #args <- getArgs(env)
        #setArgsList(args[["state2"]][["file"]], env,
        #            isFile = TRUE, init = FALSE, state = "state2")
    }
    frame <- tkframe(base)
    # Shows the name of the file
    label1 <- tklabel(frame, text = paste("File:",
                      getArgs(env)[[state]][["file"]]),
                      font = "Helvetica 11 bold")
    tkpack(label1, pady = 5, padx = 5)
    midFrame <- tkframe(frame)
    applyBut <- setState2MFrame(midFrame, env)
    tkbind(applyBut, "<B1-ButtonRelease>", applySep)
    tkpack(midFrame, pady = 5, padx = 5, fill = "x", expand = TRUE)
    bottomFrame <- tkframe(frame)
    dataView <- setState2BFrame(bottomFrame, env)
    tkpack(bottomFrame, fill = "both", expand = TRUE)
    return(frame)
}
# Sets the state2 mid frame containing radio buttons for delimiters
# and a list box for quote selection
setState2MFrame <- function(frame, env){
    if(env$rowNameCol == 0){
        rowNames <- tclVar()
    }else{
        rowNames <- tclVar(env$rowNameCol)
    }
    rowNameEntered <- function(){
        if(tclvalue(rowNames) != ""){
            options(warn = -1)
            if(is.na(as.numeric(tclvalue(rowNames)))){
                tkmessageBox(title = "Entry Error",
                             message = "Column number shold be numerical",
                             icon = "error", type = "ok")
                tkdelete(rowNameEntry, "0", "end")
            }else{
                if(as.numeric(tclvalue(rowNames)) > env$numCols){
                    tkmessageBox(title = "Entry Error",
                                 message = paste("Column number can't be",
                                 "greater than", env$numCols),
                                 icon = "error", type = "ok")
                    tkdelete(rowNameEntry, "0", "end")
                    if(env$rowNameCol != 0){
                        env$rowNameCol <- 0
                    }
                }else{
                    env$rowNameCol <- as.numeric(tclvalue(rowNames))
                }
            }
            options(warn = 0)
        }else{
            env$rowNameCol <- 0
        }
    }
    mainFrame <- tkframe(frame, borderwidth = 2, relief = "groove")
    # Radio buttons for delimiters
    leftFrame <- tkframe(mainFrame)
    applyBut <- setSepRadios(leftFrame, env)
    # A list for quote selecttion (" or/and ')
    rightFrame <- tkframe(mainFrame)
    setQuoteList(rightFrame, env)
    tkpack(leftFrame, side = "left", anchor = "w", fill = "x",
           expand  = TRUE)
    tkpack(rightFrame, side = "left", fill = "x", expand = TRUE)
    tkpack(mainFrame, side = "top")

    rowNameFrame <- tkframe(frame, borderwidth = 2, relief = "groove")
    tkpack(tklabel(rowNameFrame, text = "Use column number "), side = "left")
    rowNameEntry <- tkentry(rowNameFrame, textvariable = rowNames,
                            width = 4, background = "white")
    tkbind(rowNameEntry, "<KeyRelease>", rowNameEntered)
    tkpack(rowNameEntry, side = "left", expand = FALSE)
    tkpack(tklabel(rowNameFrame, text = " for row names"), side = "left",
           expand = FALSE)
    tkpack(rowNameFrame, side = "top", expand = TRUE, pady = 5,
           anchor = "w", fill = "x")

    return(applyBut)
}
# Sets the radio buttons for separators for state2 mid frame
setSepRadios <- function(frame, env, state = "state2"){

    rowNames <- tclVar()
    labelFrame <- tkframe(frame)
    label <- tklabel(labelFrame, text = "File Delimiter:")
    tkpack(label, side = "left", anchor = "nw")
    tkpack(labelFrame, side = "left")
    sepFrame <- tkframe(frame)
    sepVar <- tclVar()
    sepButs <- list()

    sepButFun <- function(){
        if(tclvalue(sepVar) != "other"){
            temp <- getArgs(env)
            temp[[state]][["sep"]] <- tclvalue(sepVar)
            assignArgs(temp, env)
            tkconfigure(otherEntry, state = "disabled")
        }else{
            tkconfigure(otherEntry, state = "normal")
        }
    }
    sepEntered <- function(){
        tkselect(sepButs[["other"]])
        temp <- getArgs(env)
        temp[[state]][["sep"]] <- as.character(tkget(otherEntry))
        assignArgs(temp, env)
    }
    sepButs[["tab"]] <- tkradiobutton(sepFrame, text = "Tab",
                              variable = sepVar, width = 9,
                              value = "\t", anchor = "nw",
                                      command = sepButFun)
    sepButs[["semi"]] <- tkradiobutton(sepFrame, text = "Semicolon",
                               variable = sepVar, width = 9,
                               value = ";", anchor = "nw",
                                       command = sepButFun)
    sepButs[["comma"]] <- tkradiobutton(sepFrame, text = "Comma",
                              variable = sepVar, value = ",",
                              width = 9, anchor = "nw",
                                        command = sepButFun)
    sepButs[["space"]] <- tkradiobutton(sepFrame, text = "Space",
                              variable = sepVar, value = "\"\"",
                              width = 9, anchor = "nw",
                                        command = sepButFun)
    # Puts the buttons in two rows. First row now
    tkgrid(sepButs[["tab"]], sepButs[["semi"]], sepButs[["comma"]],
           sepButs[["space"]])
    sepButs[["newline"]] <- tkradiobutton(sepFrame, text = "Newline",
                              variable = sepVar, value = "\n",
                              width = 9, anchor = "nw",
                                        command = sepButFun)
    sepButs[["other"]] <- tkradiobutton(sepFrame, text = "Other:",
                              variable = sepVar, value = "other",
                              width = 9, anchor = "nw",
                                        command = sepButFun)
    otherEntry <- tkentry(sepFrame, width = 10, state = "disabled")
    tkbind(otherEntry, "<KeyRelease>", sepEntered)
    applyBut <- tkbutton(sepFrame, text = "Apply", width = 9)
    # Second row with an entry box for delimiters other those given here
    tkgrid(sepButs[["newline"]], sepButs[["other"]], otherEntry, applyBut)
    tkpack(sepFrame, side = "left", anchor = "ne", fill = "x",
           expand = TRUE)
    if(!is.null(getArgs(env)[[state]][["sep"]])){
        tkselect(sepButs[[whatDeli(getArgs(env)[[state]][["sep"]])]])
    }

    return(applyBut)
}

# Sets the list box for quotes for state2 mid frame
setQuoteList <- function(frame, env){
    quoteSelected <- function(){
        setQuote(quoteList, env)
    }

    label1 <- tklabel(frame, text = "     Quote:")
    tkpack(label1, side = "left", anchor = "ne")
    quoteFrame <- tkframe(frame)
    quoteList <- makeViewer(quoteFrame, vWidth = 8, vHeight = 1,
                            what  = "list", side = "top")
    tkconfigure(quoteList, selectmode = "extended")
    tkbind(quoteList, "<B1-ButtonRelease>", quoteSelected)
    writeList(quoteList, c("\"", "'"), clear = TRUE)
    tkpack(quoteFrame, anchor = "w", fill = "x", expand = TRUE)

}

# Sets the value for quote when user selects quote in the list for
# quotes in state2
setQuote <- function(listBox, env, state = "state2"){
    quotes <- ""
    # Quote can be multiple (" and/or ')
    selIndex <- unlist(strsplit(as.character(tkcurselection(listBox)), " "))
    for(i in selIndex){
        quotes <- paste(quotes, tkget(listBox, i), sep = "")
    }
    temp <- getArgs(env)
    temp[[state]][["quote"]] <- quotes
    assignArgs(temp, env)
}
# Sets the canvas holding the preview of data for state2
setState2BFrame <- function(frame, env){
    viewFrame <- tkframe(frame)
    dataView2 <- makeViewer(viewFrame, vScroll = TRUE, hScroll = TRUE,
                           vWidth = 30, vHeight = 20,
                            what = "text", side = "top")
    tkpack(viewFrame, anchor = "w", padx = 5, pady = 5, fill = "both",
           expand = TRUE)
    showData4State2(dataView2, env)
    return(dataView2)
}
# Populates the data preview list of state2
showData4State2 <- function(canvas, env, state = "state2"){
    writeColList <- function(i){
        tempList <- tklistbox(tempFrame, height = 0, width = 0,
                              background = "white")
        writeList(tempList, dataFile[,i])
        #tkinsert(tempList, "end", dataFile[,i])
        tkpack(tempList, side = "left", fill = "both", expand = TRUE)
    }

    # Only show the number of rows defined
    temp <- getArgs(env)[[state]]
    tempFrame <- tkframe(canvas)
    # Puts n in temporaly
    temp[["nrows"]] = getShowNum(env)
    conn <- safeFileOpen(temp[["file"]])
    if(inherits(conn, "connection")){
        temp[["file"]] <- conn
        options(show.error.messages = FALSE)
        dataFile <- try(do.call(read.table, temp))
        options(show.error.messages = TRUE)
        if(inherits(dataFile, "try-error")){
            tkmessageBox(title = "Import Error",
                         message = paste("An error message:\n\n", dataFile,
                         "\nwas generated while reading file ",
                         args[["file"]], "."), icon = "error", type = "ok")
        }else{
            # For data without a separater
            if(is.null(ncol(dataFile))){
                writeColList(1)
                env$numCols <- length(dataFile)
            }else{
                for(i in 1:ncol(dataFile)){
                    writeColList(i)
                }
                env$numCols <- ncol(dataFile)
            }
        }
    }else{
        tkmessageBox(title = "IO Error",
                     message = paste("Can't open file because", conn),
                     icon = "error", type = "ok")
    }
    tkwindow.create(canvas, "end", window = tempFrame)
    #tkcreate(canvas, "window", 0, 0, anchor = "nw", window = tempFrame)
}

# Gets the frame containing the interface for the top frame of
# importWizard for state3
getState3Frame <- function(base, env){
    # A frame containing the interface that will be returned
    frame <- tkframe(base)
    label1 <- tklabel(frame, text = paste("File:",
                             getArgs(env)[["state3"]][["file"]]),
                      font ="Helvetica 11 bold")
    tkpack(label1, pady = 5)
    topFrame <- tkframe(frame)
    if(!is.null(getArgs(env)[["state3"]][["sep"]])){
        setState3TFrame(topFrame, env)
        tkpack(topFrame, anchor = "nw", fill = "x", expand = TRUE)
    }
    bottomFrame <- tkframe(frame)
    setState3BFrame(bottomFrame, env)
    tkpack(bottomFrame, padx = 5, pady = 5, fill = "both", expand = TRUE)
    return(frame)
}
# Creates the left bottom portion of state3 frame
setState3TFrame <- function(frame, env){
    # More arguments for read.table
    moreClicked <- function(){
        moreArgs(env)
    }
    label <- tklabel(frame, text = paste("Editable column names are",
                            " shown in the first entry box on top of data",
                            " columns.\nEditable data type of columns is",
                            " shown in the entry box following column",
                            " names\nClick the check box on top of a column",
                            " to drop the column.\nClick 'More Args' button",
                            " for more arguments.", sep = ""),
                       width = 80, height = 4, justify = "left")
    tkpack(label, anchor = "w", pady = 5, side = "left", padx = 5)
    moreBut <- tkbutton(frame, text = "More Args...", width = 10,
                                                 command = moreClicked)
    tkpack(moreBut, side = "left", padx = 5, pady = 15)
}
# Read the other arguments from a widget for read.table arguments
moreArgs <- function(env){
    temp <- getArgs(env)
    moreArgs <- getMoreArgs()
    for(i in names(moreArgs)){
        temp[[getCState(env)]][[i]] <- moreArgs[[i]]
    }
    assignArgs(temp, env)
}
# Creates the right bottom portion of state3 frame
setState3BFrame <- function(frame, env){
    # Creat a canvas to hold the other widget elements
    rCanv <-  makeViewer(frame, vWidth = 700, vHeight = 280,
                       vScroll = TRUE, hScroll = TRUE,
                       what = "canvas", side = "top")
    tempFrame <- tkframe(rCanv)
    argsList <- getArgs(env)[["state3"]]
    argsList[["nrows"]] <- getShowNum(env)
    conn <- safeFileOpen(argsList[["file"]])
    if(inherits(conn, "connection")){
        argsList[["file"]] <- conn
        options(show.error.messages = FALSE)
        dataFile <- try(do.call(read.table, argsList))
        options(show.error.messages = TRUE)
        if(inherits(dataFile, "try-error")){
            tkmessageBox(title = "Import Error",
                         message = paste("An error message:\n\n", dataFile,
                         "\nwas generated while reading file ",
                         args[["file"]], "."), icon = "error", type = "ok")
        }else{
            if(env$rowNameCol != 0){
                # Take out the column that will be used for row names
                dataFile <- dataFile[, -env$rowNameCol]
            }
            setColInfos(find.type(dataFile, argsList[["state3"]][["sep"]],
                                  isFile = FALSE), env)
    # Cut to right size of file if longer than maxRow
#    if(nrow(dataFile) > getShowNum(env)){
#        dataFile <- dataFile[1:getShowNum(env),]
#    }
    # Finds the data type for columns
            colInfos <- getColInfo(env)
            writeCol4Matrix(tempFrame, dataFile, colInfos, env)
        }
    }else{
        tkmessageBox(title = "IO Error",
                     message = paste("Can't open file because", conn),
                     icon = "error", type = "ok")
    }
    tkcreate(rCanv, "window", 0, 0, anchor = "nw", window = tempFrame)
}
# Create a group of list boxes with entry boxes and a radio button on
# top to allow for user inputs.
writeCol4Matrix <- function(tempFrame, dataFile, colInfos, env){
    # For text files, row names are hard to guess. Check col value
    # here instead
    #if(ncol(dataFile) > length(colInfos)){
    #    dataFile <- dataFile[, 2:ncol(dataFile)]
    #}
    writeDataCol <- function(i, data){
        colFrame <- tkframe(tempFrame)
        dropCMD[[i]] <- function(){}
        body <- list(as.name("{"),
                     substitute(eval(dropColumn(j, env)), list(j = i)))
        body(dropCMD[[i]]) <- as.call(body)
        var <- tclVar()
        dropCheck[[i]] <- tkcheckbutton(colFrame, text = "Drop",
                                   variable = var, command = dropCMD[[i]])
        tkpack(dropCheck[[i]], side = "top", fill = "x", expand = TRUE)
        nameEntry[[i]] <- tkentry(colFrame, width = 0)
        # Also updates the value of colInfos
        temp <- colInfos[[i]]
        if(!is.null(colnames(data))){
            writeList(nameEntry[[i]], colnames(data))
            colName(temp) <- colnames(data)
        }else{
            writeList(nameEntry[[i]], paste("V", i, sep = ""))
            colName(temp) <- paste("V", i, sep = "")
        }
        colInfos[[i]] <<- temp
        nameCMD[[i]] <- function(){}
        body <- list(as.name("{"), substitute(eval(setColName(j,
                                   nameEntry[[j]], env)), list(j = i)))
        body(nameCMD[[i]]) <- as.call(body)
            tkbind(nameEntry[[i]], "<KeyRelease>", nameCMD[[i]])
        tkpack(nameEntry[[i]], side = "top", fill = "x", expand = TRUE)
        typeEntry[[i]] <- tkentry(colFrame, width = 0)
        writeList(typeEntry[[i]], colType(colInfos[[i]]))
        typeCMD[[i]] <- function(){}
        body <- list(as.name("{"), substitute(eval(setColType(j,
                                      typeEntry[[j]], env)), list(j = i)))
        body(typeCMD[[i]]) <- as.call(body)
        tkbind(typeEntry[[i]], "<KeyRelease>", typeCMD[[i]])
        tkpack(typeEntry[[i]], side = "top", fill = "x", expand = TRUE)
        colList[[i]] <- tklistbox(colFrame, width = 0,
                                  height = 0, background = "white")
        writeList(colList[[i]], data)
#        tkinsert(colList[[i]], "end", data)
        tkpack(colList[[i]], side = "top", fill = "x", expand = TRUE)
        tkpack(colFrame, side = "left", fill = "both", expand = TRUE)
    }
    typeEntry <- list()
    dropCheck <- list()
    nameEntry <- list()
    # Lists to keep the command associated with the radio buttons of
    # entry boxex
    dropCMD <- list()
    nameCMD <- list()
    typeCMD <- list()
    colList <- list()
    if(is.null(ncol(dataFile))){
        writeDataCol(1, dataFile)
    }else{
        for(i in 1:ncol(dataFile)){
            writeDataCol(i, dataFile[,i])
        }
    }
    # Sets values for colInfo object
    assignColInfo(colInfos, env)
}

# Set the value of slot 'drop' of a colInfo object
dropColumn <- function(index, env){
    colInfos <- getColInfo(env)
    temp <- colInfos[[index]]
    if(dropOrNot(colInfos[[index]])){
        temp <- colInfos[[index]]
        dropOrNot(temp) <- FALSE
    }else{
        dropOrNot(temp) <- TRUE
    }
    colInfos[[index]] <- temp
    assignColInfo(colInfos, env)
}
# Set the value of slot (column) 'name' of a colInfo object
setColName <- function(index, entryBox, env){
    colInfos <- getColInfo(env)
    entry <- as.character(tkget(entryBox))
    temp <- colInfos[[index]]
    colName(temp) <- entry
    colInfos[[index]] <- temp
    assignColInfo(colInfos, env)
}
# Set the value of slot 'type' of a colInfo object
setColType <- function(index, entryBox, env){
    colInfos <- getColInfo(env)
    entry <- as.character(tkget(entryBox))
    temp <- colInfos[[index]]
    colType(temp) <- entry
    colInfos[[index]] <- temp
    assignColInfo(colInfos, env)
}
# Gets the word representation of delimiters
whatDeli <- function(delimiter){
    switch(delimiter,
           "\t" = return("tab"),
           ";" = return("semi"),
           " " = return("space"),
           "," = return("comma"),
           "\n" = return("newline"),
           return("other"))
}
# This function generates a widget using widgetTools to collect all
# the arguments for read.table that are not yet collected by importWizard
getMoreArgs <- function(){
    args <- formals(read.table)

    args <- args[setdiff(names(args),
                         c("file", "header", "sep", "skip","quote",
                           "row.names", "col.names"))]

    # Argument fill has to be defined using the value of
    # blank.lines.skip.
    args[["fill"]] <- !args[["blank.lines.skip"]]
    return(argsWidget(args))
}
# This function provides the interface for uers to decide whether to
# save the imported data in the global environment
getName4Data <- function(filename, objType = "object"){
    # Gets ride of the separaters
    temp <- gsub(paste("^.*", .Platform$file.sep,
                                  "(.*)", sep = ""), "\\1", filename)
    # Gets ride of the extensions
    temp <- strsplit(temp, "\\.")[[1]][1]
    var <- tclVar(temp)
    # Destroy the window
    end <- function(){
        tkgrab.release(top)
        tkdestroy(top)
    }
    # Save the data
    save <- function(){
        temp <<- tclvalue(var)
        if(temp == ""){
            tkmessageBox(title = "I/O Error",
                     message = "No name entered\nPlease try again",
                     icon = "error",
                     type = "ok")
        }else{
            end()
        }
    }
    # Do not save the data
    noSave <- function(){
        temp <<- NULL
        end()
    }
    ## Set up the interface
    top <- tktoplevel()

    tktitle(top) <- "BioC Data Import Wizard"
    tkpack(tklabel(top, text = paste("Would you like to save the", objType)),
                   side = "top", pady = 5, padx = 5)

    nameFrame <- tkframe(top)
    inst <- tklabel(nameFrame, text = "Save as: ")
    tkpack(inst, side = "left")
    nameEntry <- tkentry(nameFrame, width = 10, textvariable = var)
    tkpack(nameEntry, side = "left")
    tkpack(nameFrame, side = "top", pady = 5, padx = 5)
    butFrame <- tkframe(top)
    noSaveBut <- tkbutton(butFrame, text = "Don't Save", width = 10,
                       command = noSave)
    saveBut <- tkbutton(butFrame, text = "Save", width = 10,
                        command = save)
    tkpack(noSaveBut, saveBut, side = "left")
    tkpack(butFrame, side = "top", pady = 5, padx = 5)

    tkgrab.set(top)
    tkwait.window(top)

    return(temp)
}

# This function provides the interface for the inputs for making the
# connection to a database.
#
# Copyright 2002, J. Zhang, all rights reserved
#

dbArgsWidget <- function(){

    # Sets the working environment
    PWEnv <- new.env(hash = TRUE, parent = emptyenv())
    # Defines the widget components
    label1 <- label(wName = "label1", wValue = "Database: ", wWidth = 15,
                    wEnv = PWEnv)
    db <- entryBox(wName = "db", wWidth = 20, wEnv = PWEnv)
    label2 <- label(wName = "label2", wValue = "User name: ", wWidth = 15,
                    wEnv = PWEnv)
    un <- entryBox(wName = "un", wWidth = 20, wEnv = PWEnv)
    label3 <- label(wName = "label3", wValue = "Password: ", wWidth = 15,
                    wEnv = PWEnv)
    pw <- entryBox(wName = "pw", wWidth = 20, wEnv = PWEnv)
    label4 <- label(wName = "label4", wValue = "Host: ", wWidth = 15,
                    wEnv = PWEnv)
    hs <- entryBox(wName = "hs", wValue = "localhost", wWidth = 20,
                   wEnv = PWEnv)
    label5 <- label(wName = "label5", wValue = "Table name: ", wWidth = 15,
                    wEnv = PWEnv)
    tn <- entryBox(wName = "tn", wWidth = 20, wEnv = PWEnv)
    # Makes a list with the layout defined
    pWidgets <- list(dbName = list(label1 = label1, db = db),
                     tableName = list(lable5 = label5, tn = tn),
                     userName = list(label2 = label2, un = un),
                     password = list(label3 = label3, pw = pw),
                     host = list(label4 = label4, hs = hs))
    # Constructs the interface
    widget <- widget(wTitle = "BioC DB Inputs Widget", pWidgets,
                     funs = list(), preFun = function() {},
                     postFun = function() {}, env = PWEnv)

    # Returns the input values
    if(wValue(pWidgets(widget)[["dbName"]][["db"]]) == ""){
       stop("Database name can not be an empty string!")
    }
    inputs <- list(dbname = wValue(pWidgets(widget)[["dbName"]][["db"]]),
                   host = wValue(pWidgets(widget)[["host"]][["hs"]]))
    if(wValue(pWidgets(widget)[["userName"]][["un"]]) != ""){
        inputs[["user"]] <- wValue(pWidgets(widget)[["userName"]][["un"]])
    }
    if(wValue(pWidgets(widget)[["password"]][["pw"]]) != ""){
        inputs[["password"]] <- wValue(pWidgets(widget)[["password"]][["pw"]])
    }
    if(wValue(pWidgets(widget)[["tableName"]][["tn"]]) != ""){
        inputs[["tableName"]] <- wValue(pWidgets(widget)[["tableName"]][["tn"]])
    }

    return(inputs)
}

# This function returns a list containing the values for widgets on a
# widget created by function widgetRender. It takes a list defining
# the widget and returns a named list containing the values for each
# of the widgets.
#
# Copyright J. Zhang 2002, all rights reserved.
#

getWvalues <- function (W){
    wList <- WwList(W)
    lenW <- length(wList)
    if( is.null(wList) ) return(NULL)
    rList <- vector("list", length = lenW)
    names(rList) <- names(wList)
    for(i in 1:lenW)
        rList[[i]] <- WValue(wList[[i]])
    return(rList)
}

# This function creates a widget with a top frame that will be filled
# with a widget passed as one of the arguments and bottom frame with
# buttons.
#
# Copyright 2002, J. Zhang. All right reserved.
#
dataViewer <- function(data, caption = "", save = TRUE){
    on.exit(exit())
    exit <- function() tkdestroy(base)

    base <- tktoplevel()
    tktitle(base) <- "BioC tkWidgets"

    if(caption != ""){
        label <- tklabel(base, text = caption)
        tkpack(label)
    }

    boxFrame <- tkframe(base)

    # Insert data into the canvas
    innerFrame <- makeViewer(boxFrame,
                             vScroll = TRUE, side = "top",
                             hScroll = TRUE, what = "canvas")

    dataFrame <- tkframe(innerFrame)
    for(i in 1:ncol(data)){
        tempFrame <- tkframe(dataFrame)
        if(!is.null(colnames(data))){
            tempName <- tkbutton(tempFrame, text = colnames(data)[i],
                                 width = 0)
            tkpack(tempName, expand = TRUE, fill = "x")
        }
        tempList <- tklistbox(tempFrame, width = 0,
                              height = 0, background = "white")
        writeList(tempList, as.vector(data[,i]))
        tkpack(tempList, side = "left", expand = TRUE, fill = "both")
        tkpack(tempFrame, side = "left", expand = TRUE, fill = "both")
    }

    tkcreate(innerFrame, "window", 0, 0, anchor = "nw", window = dataFrame)

    tkpack(boxFrame, side = "top", expand = TRUE, fill = "both")

    botFrame <- tkframe(base)
    if(save){
        save <- function(){
            name <- tclvalue(tkgetSaveFile())
            write.table(data, name, quote = FALSE, sep = "\t",
                        row.names = FALSE, col.names = FALSE)
            exit()
        }
        saveBut <- tkbutton(botFrame, text = "Save", width = 8,
                            command = save)
        tkpack(saveBut, side = "left")
    }
    exitBut <- tkbutton(botFrame, text = "Exit", width = 8, command = exit)
    tkpack(exitBut, side = "left")
    tkpack(botFrame, side = "top")

    tkwait.window(base)
}

\name{objViewer}
\alias{objViewer}
\title{Show the Content of an R Object in a Widget}
\description{
  This function takes an \R object and shows the content in a list box on
  a widget.
}
\usage{
objViewer(toView, width = 40, height = 10)
}

\arguments{
  \item{toView}{\R object whose content is to be viewed}
  \item{width, height}{positive values specifying the width and height
    of the widget.}
}
\details{
  The function makes no check of the \R object passed and will show
  whatever the object will be shown when the name is type at an \R
  prompt.  Formatting is required before passing the \R object to the function.
}
\value{
  This function does not return any value
}
\author{Jianhua Zhang}
\seealso{\code{\link{listSelect}}}

\examples{
# Since user interference is required, the example code only runs
# interactively
if(interactive())
   objViewer("Just to show that the content gets posted")
}
\keyword{interface}

\name{args2XML}
\alias{args2XML}

\title{Converting the formal arguments to a function and converts into
  an XML format} 
\description{
  This function reads the formal arguments to a given function and
  converts the content into an XML format
}
\usage{
args2XML(fun, xml.name = "", full.names = NULL, priority = NULL)
}

\arguments{
  \item{fun}{\code{fun} name of the function of interests}
  \item{xml.name}{\code{xml.name} a character string for the name of the
    xml file holding the content of the formal arguments to the function}
  \item{full.names}{\code{full.names} a vector of character string with
    full description of each of the formal arguments to the
    function. The order of apperance of each description much correspond
    to the oreder of their appeerance in the formal argument list}
  \item{priority}{\code{priority} a vector of integers or character
    strings indicating the priority of the arguments.}
}
\details{
  Priority values are currently used to determine whether the argument
  will appear on a widget that has entry boxes for modifying the values
  of the arguments. Users of args2XML may not have any concern of the
  priority values
}
\value{
  No value will be returned.
}

\author{Jianhua Zhang}

\seealso{\code{\link{fileWizard}}}

\examples{
fullNames <- c("Full path names", "Pattern to match",
"Visiable file names", "Include path")
args2XML(list.files, "temp.xml", fullNames, c(1, 2, 2, 2)) 
readLines("temp.xml")
unlink("temp.xml")
}
\keyword{misc}

\name{fileBrowser}
\alias{fileBrowser}
\title{Simple Interface to View and Pick Files}
\description{
  This function provides the widget for users to go up and down a path and
  view the files.  When files are selected and the \code{"End"} button
  is pressed, the function returns a vector of character strings with
  the full paths of the selected files.
}
\usage{
fileBrowser(path="", testFun = function(x) TRUE, prefix = NULL,
	    suffix = NULL, textToShow = "Select file(s)",
	    nSelect = -1)
}
\arguments{
  \item{path}{character string for the full path to be view. Defaults
    to the current working directory if no path is provided.}
  \item{testFun}{function that checks to see if a given file name
    satisfies predefined requirements. The default is no checking.}
  \item{prefix}{character string for a prefix used to screen out file
    names that do not have that prefix as part of their names.}
  \item{suffix}{character string for a suffix used to screen out file
    names that do not have that suffix as part of their names.}
  \item{textToShow}{character string to be shown on the widget to given
    instructions to users.}
  \item{nSelect}{integer indicating the number of files that should be
    selected.  No limitation if \code{nSelect = -1} as per default.}
}
\details{
  When a path is viewed, files will be displayed as they are and
  directories will be displayed with a system file separator appended
  (e.g. \code{"/"} for Unix systems).
%
  Single click on a file name will make the file selectable when the
  select button is pressed.  Multiple selection is possible by dragging
  with mouse button 1 pressed.
%
  Double click on a directory name will go into that directory and
  display its files.  When a file/directory is selected and the "End" button
  pressed, the full path for the selected files selected will be
  returned.

  The widget is modal and has to be closed by pressing the "End" button
  before doing any other operations. Functions, prefix, and suffix can
  be specified.	 Examples of validity functions are
  \code{\link{hasPrefix}} and \code{\link{hasSuffix}}.

  The following is a list of the buttons and their associated behavior:
  \describe{
    \item{\code{Up}}{Moves the directory whose content is to be
      displayed in the box for file names one level up along the
      directory tree.  No action if already on top of the tree.}

    \item{\code{Select \>\> }}{When a file or files in the box for file
      names in a directory have been highlighted by clicking or dragging
      mouse button 1 and this button is pushed, the highlighted file(s)
      will be displayed in the box for selected file(s) on the right.}

    \item{\code{\<\< Remove}}{When a file or files in the box for
      selected files have been highlighted by clicking or dragging this
      button is pushed, the highlighted file(s) will be removed from the box.}

    \item{\code{Clear}}{Clears everything in the box for selected files
      when pushed.}

    \item{\code{end}}{Returns a vector containing all the names in the box for
      selected files or \code{NULL} if the box is empty.  The full path
      will be appended to the file names.}
  }
}
\value{
  A vector of character strings containing the full path of each file
  selected.
}
\author{Jianhua (John) Zhang}

\seealso{\code{\link{pickFiles}},
  \code{\link{hasPrefix}}, \code{\link{hasSuffix}}} 

\examples{
## The example here is only run interactively since it requires user
## interference which may cause problems if not available:
if(interactive()) {

  # Call the function to view the current directory
  flist <- fileBrowser()
  flist

  # To call the function with a path do
  # fileBrowser(path = "yourPath")
}
}
\keyword{interface}

\name{setArgsList}
\alias{setArgsList}
\alias{whatDeli}
\alias{getMoreArgs}
\alias{assignArgs}
\alias{getArgs}
\alias{assignShowNum}
\alias{getShowNum}
\alias{assignCState}
\alias{getCState}
\alias{assignColInfo}
\alias{getColInfo}
\alias{setColInfos}
\alias{changeState}
\alias{setNewState}
\alias{addArgs}
\alias{dropArgs}
\alias{setSkip}
\alias{moreArgs}
\alias{dropColumn}
\alias{setColName}
\alias{setColType}
\alias{assignLineData}
\alias{getLineData}
\title{Functions to support importWizard}
\description{
  The functions are to support importWizard and may not have much
  practical use otherwise.
}
\usage{
setArgsList(filename, env, isFile = TRUE, init = TRUE)
whatDeli(delimiter)
getMoreArgs()
assignArgs(value, env)
getArgs(env)
assignShowNum(value, env)
getShowNum(env)
assignCState(value, env)
getCState(env)
assignColInfo(value, env)
getColInfo(env)
setColInfos(types, env)
changeState(canvas, backBut, nextBut, env, forward = TRUE, endBut, viewBut)
setNewState(env, backBut, nextBut, forward = TRUE, endBut, viewBut)
addArgs(env)
dropArgs(env)
setSkip(widget, env, state = "state1")
moreArgs(env)
dropColumn(index, env)
setColName(index, entryBox, env)
setColType(index, entryBox, env)
assignLineData(lineData, env)
getLineData(env)
}

\arguments{
  \item{filename}{\code{filename} a character string for the full name
    of a file}
  \item{env}{\code{env} an R environment object for storing information}
  \item{delimiter}{\code{delimiter} a character string for the delimiter
    whose letter representation is sought}
  \item{value}{\code{value} a character or numerical value to be
    assigned to a variable}
  \item{backBut}{\code{backBut} a tkwin object for the button that
    shifts back to the previous state}
  \item{nextBut}{\code{nextBut} a tkwin object for the button that
    shifts to the next state}
  \item{forward}{\code{forward} a boolean indicating the direction of
    state change}
  \item{widget}{\code{widget} a tcltl widget}
  \item{state}{\code{state} a character string for the state of
    importing process}
  \item{index}{\code{index} an integer for the index of the list for
    column information}
  \item{entryBox}{\code{entryBox}} a tcltk entry box.
  \item{canvas}{\code{canvas} a tcltk canvas}
  \item{types}{\code{types} a vecter of string indicating the types of
    data columns}
  \item{lineData}{\code{lineData} a vector of character strings read in
    using \code{\link{readLines}}}
  \item{endBut}{\code{endBut} a tkwin object for the button that ends
    the process when pressed}
  \item{viewBut}{\code{viewBut} a tkwin object for the button that
    refresh the window when pressed}
  \item{init}{\code{init} a boolean that is TRUE when the widget is
    first set up and FALSE otherwise}
  \item{isFile}{\code{isFile} a boolean that is TRUE if \code{fileName}
    is a file}
}
\details{
  \code{\link{setArgsList}} calls function \code{\link{guess.sep}} to
  figure out the the header, sep, and data type of a file and sets the
  values for argument list and colInfo.

  \code{\link{whatDeli}} gets the word representation of delimiters
  (e.g. tab for "\\t").

  \code{\link{getMoreArgs}} generates a widget using widgetTools to
  collect some of the arguments for read.table.

  \code{\link{assignArgs}} updates "argsList" stored in a predefined
  environment. 

  \code{\link{getArgs}} Gets "argsList" from a predefined environment.
  
  \code{\link{assignShowNum}} Updates the value for "showNum" (number of
  rows to show in the interface.
  
  \code{\link{getShowNum}} Gets the value for "showNum" (number of
  rows to show in the interface. 
  
  \code{link{assignCState}} Updates the value of "currentState" that is
  stored in a predefined environment.
  
  \code{\link{getCState}} Gets the vlaue of "currentState" that is
  stored in a predefined environment.
  
  \code{\link{assignColInfo}} Updates the values of "colInfos" (column
  information) that is stroed in a predefined environment.
  
  \code{\link{getColInfo}} Gets the values of "colInfos" (column
  information) that is stroed in a predefined environment.
  
  \code{\link{setColInfos}} Creates colInfo objects and sets the value
  of 'colInfos' list.

  \code{\link{changeState}} changes the state and thus the interface of
  a widget.

  \code{\link{setNewState}} sets the state of a importing process.

  \code{\link{addArgs}} adds a new state to the argument list for
  states.

  \code{\link{dropArgs}} removes a state from the argument list for
  states.

  \code{\link{setSkip}} Sets the value for the number of lines to skip
  when readling a data file.

  \code{\link{moreArgs}} Gets some of the arguments for importing data
  using \code{\link{read.table}}.

  \code{\link{dropColumn}} Sets the index values for data columns that
  are going to be droped when read using \code{\link{read.table}}.

  \code{\link{setColName}} Sets the column names for a data file by
  getting column names from correct entry boxes.

  \code{\link{setColType}} Sets the column type for a data file by
  getting column type information from correct entry boxes.
}
\value{
  \code{\link{whatDeli}} returns a character string.

  \code{\link{getMoreArgs}} returns a list of arguments.

  \code{\link{getArgs}} returns a list of the arguments for read.table.

  \code{\link{getShowNum}} returns an integer for the number of rows to
  show.

  \code{\link{getCState}} returns a character string for the current
  state.

  \code{\link{getColInfo}} returns a colInfo object contains column
  information.
}

\author{Jianhua Zhang}

\seealso{\code{\link{importWizard}}}
\examples{
  # No example is given as functions require the set up of the working
  # environment. 
}
\keyword{misc}

\name{listSelect}
\alias{listSelect}
\alias{writeSelBox}
\alias{writeBut}
\alias{writeLabel}
\title{Utilities Creating a Widget With Selection Boxes}
\description{
  These functions create a widget with selection boxes allowing users to
  view and make selections of items shown on the interface.
}
\usage{
listSelect(aList, topLbl = "Select Elements From The Following List",
           typeFun = stdType, valueFun = stdView)
writeSelBox(baseW, aList, typeFun = NULL, valueFun = NULL)
   writeBut(baseW, butList, butWidth = 6)
writeLabel(baseW, typeFun, valueFun)
}

\arguments{
  \item{aList}{list with names and object pairs (e. g. \code{a = "AAA"}).}
  \item{topLbl}{character string for the text to be shown as a title.}
  \item{typeFun}{function that takes an \R object as an arguement and
    returns a description of the object.}
  \item{valueFun}{function that takes an \R object as an argument
    and shows the content of the object.  The function should get the
    representation of the object and calls \code{\link{objViewer}} to have
    the representation rendered in a widget.}
  \item{baseW}{a window widget to which the selection boxes will be put.}
  \item{butList}{a list with names and function pairs that define the
    name and behavior of buttons to be put on the widget to be
    generated}
  \item{butWidth}{numerical value specifying the width of buttons to
    be created.}
}
\details{
  Both \code{typeFun} and \code{valueFun} have to take an argument (the
  \R object to be shown).  It works well for the \code{valueFun}
  function to call \code{\link{objViewer}()} with whatever to be shown
  passed to \code{objViewer} as an argument.
}
\value{
   \code{listSelect()} returns a list with the names of the \R objects in the
   original list associated with \code{TRUE} (selected) or \code{FALSE}
   (deselected).
}
\author{Jianhua Zhang}
\seealso{\code{\link{objViewer}}}

\examples{
aList <- list(a = "AAA", b = c(123, 456, 789),
              c = as.data.frame(matrix(1:10, ncol = 2)),
              d = stdType)
# Since user interference is required, the example code does not run
# automatically
if(interactive())
  listSelect(aList)
}
\keyword{interface}

\name{pickObjs}
\alias{pickObjs}
\alias{noAuto}

\title{Determine What to Be Sent to a Widget}
\description{
  This function takes a vector of object names and determines what will
  be sent to (e.g. the \code{\link{objectBrowser}}) widget for display
  based on the default and user input requirements.
}
\usage{
pickObjs(objNames, fun = noAuto)
noAuto(x)
}

\arguments{
  \item{objNames}{\code{objNames} character vector with object names to
    be processed} 
  \item{fun}{\code{fun} function checking the object names for satisfaction of
    certain requirement} 
  \item{x}{\code{x} a character string for the name of an object}
}
\details{
  Packages and environments are always displayed.
}
\value{
  Character vector of object names that satisfy the requirements.
}

\author{Jianhua (John) Zhang}

\seealso{\code{\link{objectBrowser}}}

\examples{
# Returns names of package and environment objects in the search path.
pickObjs(search())
}
\keyword{manip}

\name{tkphenoData}
\alias{tkphenoData}
\title{Simple interface to enter AnnotatedDataFrame}
\description{
This widget provides an interface to create
\code{\link[Biobase:class.AnnotatedDataFrame]{AnnotatedDataFrame-class}}
instances. 
}
\usage{
tkphenoData(sampleNames)
}
\arguments{
  \item{sampleNames}{sampleNames for which we will enter phenotypic data.}
}
\details{
  The function returns a list of character matrices intended to be used
  as the \code{pData} and \code{varLabels} slots of an instance of
  \code{\link[Biobase:class.AnnotatedDataFrame]{AnnotatedDataFrame-class}}.
}
\value{
  A list of two matrices
  \item{pData}{a character matrix containing phenotypic data.}
  \item{varLabels }{a character vector with covariate description.}
}
\author{Majnu John} 
\seealso{\code{\link[Biobase:class.AnnotatedDataFrame]{AnnotatedDataFrame-class}}}
\keyword{interface}

\name{appendSepDir}
\alias{appendSepDir}

\title{List File and Directories for a Given Path}
\description{
  Takes a path and returns a vector of string with the
  names of files and directories for the path. The directory names will
  have a system dependent path separator (e. g. / for Unix) appended.
}
\usage{
appendSepDir(path)
}
\arguments{
  \item{path}{\code{path} character string specifying the path whose
    contents are to be listed}
}
\value{
  A character vector containing file and directory names.
}
\author{Jianhua (John) Zhang}

\seealso{\code{\link{fileBrowser}}, \code{\link{pickFiles}}}

\examples{
# File names and directory names are not differentiated
list.files()

# Put a separater at the end of directory names
appendSepDir(getwd())
}
\keyword{manip}

\name{hasChar}
\alias{hasChar}
\alias{hasPrefix}
\alias{hasSuffix}

\title{String Prefix and Suffix Checking}
\description{
  These functions return a \emph{function} for determining if a
  given prefix, suffix, or set of characters passed to this function
  exists in a character string passed to the returned function.
}
\usage{
hasChar(toCheck, what = "")
hasPrefix(aPrefix)
hasSuffix(aSuffix)
}
\arguments{
  \item{aPrefix}{character string to be used as the prefix to be checked for}
  \item{aSuffix}{character string to be used as the suffix to be checked for}
  \item{toCheck}{\code{toCheck} a character string to be used to check
    to see if it exists in a character string passed to the returned
    function}
  \item{what}{\code{what} a character string defining whether toCheck
    will be used as a prefix (what = "prefix"), suffix (what =
    "suffix"), or a set of characters (what = "") to check the character
    string passed to the returned function} 
}
\details{
  The prefix (or suffix) is passed to \code{hasPrefix} (or
  \code{hasSuffix}) and then the returned function can be used to check
  for the existence of that prefix (suffix) in a string passed to that
  function.

  hasChar is a more general function that determines the existence of
  prefix, sufix, or a set of a characters in a character string passed
  to the returned function.
}
\value{
  A \bold{function} which itself returns a logical (of length 1)
  indicating if the prefix/suffix is found (\code{\link{TRUE}}) or not.
}

\author{Jianhua (John) Zhang}

\seealso{\code{\link{pickFiles}}}

\examples{
# Function for checking for a prefix "xxx" :
chkPfun <- hasChar("xxx", what = "prefix")
# Function for checking for a suffix ".tex" :
chkSfun <- hasChar(".tex", what = "suffix")

chkPfun("xxx.tex")
chkPfun(".xxx")
chkSfun("xxx.tex")
chkSfun("yyyyy")
chkSfun("yxxx.text")
}
\keyword{manip}

\name{pickFiles}
\alias{pickFiles}

\title{Pick Elements From Vector of Strings}
\description{
 Takes a vector of strings and then checks to see if the
  predefined conditions are met for each element.  Elements that meet the
  conditions will be included in the vector returned and the others not.
}
\usage{
pickFiles(fileNames, fun = function(x) TRUE,
          prefix = NULL, suffix = NULL, exclude = .Platform$file.sep)
}
\arguments{
  \item{fileNames}{vector of strings that will be checked.}
  \item{fun}{function to be used to check the strings.  Default is no checking.}
  \item{prefix}{character used to check to see if strings in the vector
    have the prefix.}
  \item{suffix}{character used to check to see if strings in the vector
    have the suffix.}
  \item{exclude}{character string with which strings in the vector
    will be excluded form the checking.  The default is to exclude all
    the directory names and always return them.}
}
\details{
  The function fun will be used only when both prefix and suffix are
  NULL. If a prefix is not NULL, that prefix will be checked. A suffix
  is going to be checked when prefix is NULL.
}
\value{
  Character vector of file names satisfying the conditions.
}

\author{Jianhua Zhang}

\seealso{\code{\link{fileBrowser}}, \code{\link{hasPrefix}}, \code{\link{hasSuffix}} }

\examples{
# Return every thing from the current directory
pickFiles(list.files())

# Create a temp file
file.create("myFile")

# Returns subdirectory names and file names with a prefix of "my"
pickFiles(list.files(), prefix = "my")

# create another temp file
file.create("temp.tex")

# Return subdirectory names and file names with a suffix of ".tex"
pickFiles(list.files(), suffix = ".tex")

# clearn up
unlink("myFile")
unlink("temp.tex")
}
\keyword{manip}

\name{importWizard}
\alias{importWizard}
\alias{initImportWizard}
\alias{getTopCan}
\alias{getAFrame}
\alias{finish}
\alias{getState1Frame}
\alias{setState1BFrame}
\alias{setState1TFrame}
\alias{showData4State1}
\alias{setState1MFrame}
\alias{getState2Frame}
\alias{setState2MFrame}
\alias{setSepRadios}
\alias{setQuoteList}
\alias{setQuote}
\alias{setState2BFrame}
\alias{showData4State2}
\alias{getState3Frame}
\alias{setState3TFrame}
\alias{setState3BFrame}
\alias{getName4Data}
\alias{writeCol4Matrix}
\alias{popStartLine}
\alias{readFileByLines}

\title{A widget for importing data to R}
\description{
  Functions constructs a widget that allows users to inport data
  file to R. The imported data will be returned as an R data frame
  together with the argument list used to import the data using read.table
}
\usage{
importWizard(filename = "", maxRow = 400)
initImportWizard(env)
getTopCan(base, env)
getAFrame(base, env)
finish(env)
getState1Frame(base, env)
setState1BFrame(frame, env)
setState1TFrame(frame, viewer, delims, env, startList)
showData4State1(widget, env)
setState1MFrame(frame, env, dataViewer)
getState2Frame(base, env, state = "state2", reset = FALSE)
setState2MFrame(frame,env)
setSepRadios(frame, env, state = "state2")
setQuoteList(frame, env)
setQuote(listBox, env, state = "state2")
setState2BFrame(frame, env)
showData4State2(canvas, env, state = "state2")
getState3Frame(base, env)
setState3TFrame(frame, env)
setState3BFrame(frame, env)
getName4Data(filename, objType)
writeCol4Matrix(tempFrame, dataFile, colInfos, env)
popStartLine(startList, env)
readFileByLines(filename)
}

\arguments{
  \item{filename}{\code{filename} a character string for the name of the
    file to be imported. The default is an empty string and users have to
    click a browse button to get the file name through
    \code{\link{fileBrowser}}}  
  \item{maxRow}{\code{maxRow} an integer for the maximum number of rows
    of the data file to be imported to be shown on the widget. The
    default is 200 rows}
  \item{env}{\code{env} an R environment object for storing the required
    information}
  \item{base}{\code{base} a tcltk window to hold a canvas on the top and
    frames in the bottom}
  \item{frame}{\code{frame} a tcktl frame}
  \item{viewer}{\code{viewer} a tkwin object for a widget}
  \item{delims}{\code{delims} a character string for a file separater}
  \item{widget}{\code{widget} a tcltk widget}
  \item{state}{\code{state} a character string for the state of
    importing process}
  \item{listBox}{\code{listBox} a tcltk list box}
  \item{canvas}{\code{canvas} a tcltk canvas}
  \item{tempFrame}{\code{tempFrame} a tcltk frame that will be used to
    hold widget elements}
  \item{dataFile}{\code{dataFile} a data matrix holding data to be
    displayed}
  \item{colInfos}{\code{colInfos} an object of class colInfo with a
    name, type, and drop slot}
  \item{reset}{\code{reset} a boolean that is TRUE when the window needs
    to be reset}
  \item{dataViewer}{\code{dataViewer} a tkwin object for a list box}
  \item{objType}{\code{objType} a character string indicating the data
    type of an object to be saved. Defaulted to "object"}
  \item{startList}{\code{startList} a tk text box object}
}
\details{
  \code{\link{importWizard}} mimics the interface of MS Excel and
  collects arguments for the function \code{\link{read.table}}. Due to
  performace concern, a maximum number of rows (maxRow) set by 
  users will be displayed. Overly long data set may cause slow response
  of the system.

  \code{\link{initImportWizard}} initializes the interface for
  importWizard by creating a widget with an empty top canvas and bottom
  frame filled with four buttons.

  \code{\link{getTopCan}} Creates a canvas that is going to be filled by
  a frame created by other functions depending on the state of the
  importing process.

  \code{\link{getAFrame}} Gets a frame for the canvas created by
  \code{\link{initImportWizard}} based on the current state of importing
  process.

  \code{\link{finish}} Finishes the importing process and returns a data
  frame read from a file using \code{\link{read.table}}.

  \code{\link{getState1Frame}} Returns a tcltk frame containing a list
  box to show a data file read by \code{\link{readLines}} and widgets
  for user imports.

  \code{\link{setState1BFrame}} Fills the bottom frame of the frame
  created by \code{\link{getState1Frame}} with a list box.

  \code{\link{setState1TFrame}} Fills the top frame of the frame
  created by \code{\link{getState1Frame}} with a list box.

  \code{\link{showData4State1}} Populates a tcltk list or text widget
  with data read using readLines.

  \code{\link{setState1MFrame}} Fills the mid frame of the frame
  created by \code{\link{getState1Frame}}.

  \code{\link{getState2Frame}} Returns a tcltk frame containing a canvas
  to show a data file read by \code{\link{read.table}} and widgets
  for user imports.

  \code{\link{setState2MFrame}} Fills the mid frame of the frame
  created by \code{\link{getState2Frame}}.

  \code{\link{setSepRadios}} Renders radio buttons for options of file
  separators in the frame created by \code{\link{setState2MFrame}}.

  \code{\link{setQuoteList}} Renders the selection list for the quote
  used by a data file in the frame created by
  \code{\link{setState2MFrame}}.

  \code{\link{setQuote}} Sets the value when a user has selected the
  quote used by a data file.

  \code{\link{setState2BFrame}} Fills the bottom frame of the frame
  created by \code{\link{getState2Frame}} with a canvas.

  \code{\link{showData4State2}} Populates the canvas created by
  \code{\link{setState2BFrame}} using data read by
  \code{\link{read.table}}.
  
  \code{\link{getState3Frame}} Returns a tcltk frame containing a canvas
  to show a data file read by \code{\link{read.table}} and widgets
  for user imports.

  \code{\link{setState3TFrame}} Fills the top frame of the frame
  created by \code{\link{getState3Frame}}.

  \code{\link{setState3BFrame}} Fills the bottom frame of the frame
  created by \code{\link{getState3Frame}}.

  \code{\link{getName4Data}} Takes user input for a file name using a
  widget.

  \code{\link{writeCol4Matrix}} Creates a tcltk frame with list boxes as
  columns displaying data of a data matrix.
}
\value{

  \code{\link{getTopCan}} returns a tcltk canvas.

  \code{\link{getAFrame}} returns a tcltk frame.

  \code{\link{finish}} returns a data.frame.

  \code{\link{getState1Frame}} returns a tcltk frame with several
  widgets.

  \code{\link{setState1BFrame}} returns the tkwin object of list box.

  \code{\link{getState2Frame}} returns a tcltk frame with several
  widgets.

  \code{\link{getState3Frame}} returns a tcltk frame with several
  widgets.
  
  \code{\link{getName4Data}} returns a character string for the name of
  a file to be saved.
}

\author{Jianhua Zhang}

\seealso{\code{\link{fileBrowser}}, \code{\link{argsWidget}}}

\examples{
  if(interactive()){
      importWizard()
  }
}
\keyword{interface}

\name{pickItems}
\alias{pickItems}

\title{Function that builds a widget to allow users to select items from
available sources} 
\description{
  Given a vector of characters, this function creates a widget
  containing list box to allow users to visually select elements from
  the vector.
}
\usage{
pickItems(items, title1 = "Items to pick", title2 = "Picked items")
}

\arguments{
  \item{items}{\code{items} a vector for the available source elements
    to be selected}
  \item{title1}{\code{title1} a character string for the title of the
    list box that shows the list of items to be selected from}
  \item{title2}{\code{title2} a character string for the title of the
    list box that shows the items that have been selected}
}
\details{
  This function is to provide visual support to other functions and thus
  may not have much use otherwise.
}
\value{
  This function returns a vector of select items.
}
\references{R tcltk}
\author{Jianhua Zhang}

\seealso{\code{\link{dataViewer}}}
\examples{
options <- paste("Option", 1:10, sep = "")
if(interactive()){
    pickItems(options)
}
}
\keyword{interface}

\name{pExplorer}
\alias{pExplorer}
\alias{getPkgContents}
\alias{getFileContents}
\alias{getExclude}
\alias{getRPkgs}
\alias{hasDesc}
\alias{procRda}
\alias{procHelp}
\alias{procPDF}
\alias{procHTML}
\title{A widget to explore R packages}
\description{
  This widget allows users to explore R packages in the R library and
  try the example code.
}
\usage{
pExplorer(pkgName = "", pkgPath = "", exclude = getExclude(), getFocus =
TRUE)
getPkgContents(pkgName, exclude = getExclude())
getFileContents(path, fileName)
getExclude()
getRPkgs(pkgPath)
hasDesc(pkgPath)
procRda(fileName)
procHelp(fileName)
procPDF(fileName)
procHTML(fileName)
}
\arguments{
  \item{pkgPath}{\code{pkgPath} a character string for the path where R
    packages are loacted}
  \item{path}{\code{path} a character string for the path of a given file}
  \item{pkgName}{\code{pkgName} a character string for the name
    (including path) of an R package to be explored}
  \item{fileName}{\code{fileName} a character string for the name
    (including path) of a file of interest}
  \item{exclude}{\code{exclude} a vector of character strings containing
    the directory or file names that will not be available for
    explorering. Package names have to have a system file separator
    appanded to the end (e. g. "/" under Unix)}
   \item{getFocus}{\code{getFocus} a boolean indicating whether a widget
    should grab the focus}
}
\details{
  With or without a package name, the widget will have all the installed
  R package names in a dropdown list for user to select. As the default,
  the first element from \code{\link{list.files}} will be selected and
  the contents displayed if no package name is given.

  \code{\link{getPkgContents}} gets the contents of a given R package
  and \code{\link{getFileContents}} gets the contents of a givan file.

  \code{\link{getRPkgs}}, \code{\link{hasDesc}}, \code{\link{procRda}},
  \code{\link{procHelp}}, \code{\link{procPDF}}, and
    \code{\link{procHTML}} are functions called by
    \code{\link{pExplorer}} to process different file or directory types.  
}
\value{
  The widget returns invisiable()
}
\references{Documentation on R packages }
\author{Jianhua Zhang}

\seealso{\code{\link{eExplorer}}}
\examples{
    require("tkWidgets") || stop("tkWidgets not available")
    getPkgContents(.libPaths(), "tkWidgets")
    getFileContents(file.path(path.package("tkWidgets"), "help"),
        list.files(file.path(path.package("tkWidgets"), "help"))[1])
    if(interactive()){
        pExplorer()
    }
}
\keyword{interface}

\name{colInfo-class}
\docType{class}
\alias{colInfo-class}
\alias{colInfo}
\alias{colName<-}
\alias{colName}
\alias{colType}
\alias{colType<-}
\alias{dropOrNot}
\alias{dropOrNot<-}
\alias{colName<-,colInfo-method}
\alias{colName,colInfo-method}
\alias{colType,colInfo-method}
\alias{colType<-,colInfo-method}
\alias{dropOrNot,colInfo-method}
\alias{dropOrNot<-,colInfo-method}
\title{Class "colInfo" presents column information for a data frame}
\description{This class is for keeping information about a data frame to
be processed. The class is mainly for use by \code{\link{importWizard}}}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("colInfo", ...)}
}
\section{Slots}{
  \describe{
    \item{\code{colName}:}{Object of class \code{"character"} - a
      character string for the name of the column}
    \item{\code{colType}:}{Object of class \code{"character"} - a
      character string for the data type of the column. Can only be
      "character" or "numeric"}
    \item{\code{dropOrNot}:}{Object of class \code{"logical"} - a
      boolean indicationg whether the column will be droped}
  }
}
\section{Methods}{
  \describe{
    \item{colName}{\code{signature(object = "character")}: The get
      method for slot "colName"}
    \item{colName<-}{\code{signature(object = "character")}: The set
      method for slot "colName"}
    \item{colType}{\code{signature(object = "character")}: The get
      method for slot "colType"}
    \item{colType<-}{\code{signature(object = "character")}: The set
      method for slot "colName"}
    \item{dropOrNot}{\code{signature(object = "logical")}: The get
      method for slot "dropOrNot"}
    \item{dropOrNot}{\code{signature(object = "logical")}: The set
      method for slot "dropOrNot"}
  }
}
\author{Jianhua Zhang}

\seealso{
  \code{\link{importWizard}}
}
\examples{
  newInfo <- new("colInfo", colName = "aaaa", colType = "character",
dropOrNot = FALSE)  
}
\keyword{classes}

\name{getWvalues}
\alias{getWvalues}

\title{Obtaining values of widgets on a given widget}
\description{
   This function returns a list containing the values for widgets on a
   widget created by function widgetRender. It takes a list defining the
   widget and returns a named list containing the values for each of the
   widgets.
}
\usage{
getWvalues(W)
}

\arguments{
  \item{W}{\code{W} a list of lists defining the widgets that are used
    to make a widget}
}
\details{
  For a widget containing 3 widgets each with some associated
  functionalities, the list is defined as this:

  pW1 <- list(Name="AAA", Value="bbb",
            toText=function(x) paste(x,collapse= ","), fromText=NULL,
            canEdit=TRUE,
            buttonFun = fileBrowser, buttonText = "Browse")

  pW2 <- list(Name="BBB", Value="x,y,z",
            toText=function(x) paste(x, collapse=","), fromText=NULL,
            canEdit=TRUE, buttonFun = ls, buttonText = "List")

  pW3 <- list(Name="CCC", Value="ccc",
            toText=function(x) paste(x, collapse = ","), fromText=NULL,
            canEdit=TRUE, buttonFun=NULL,  buttonText=NULL)

  widget1 <- list(wList = list(a = pW1, b = pW2, c = pW3),
                preFun  = function() "Hi",
                postFun = function() "Bye")

  widget1 will be used to create a widget with 3 entry boxes. When users
  modify the values through the widget created, new values will be kept
  in the list and widget1 will be returned up exist. getWvalues is
  useful to capture the values for each widgets on the widget.
}
\value{
  This function returns a list of:

  \item{comp1 }{Description of `comp1'}
  \item{comp2 }{Description of `comp2'}

}

\author{Jianhua Zhang}

\seealso{\code{\link{widgetRender}}}

\examples{
# Define the widgets
  pW1 <- list(Name="AAA", Value="bbb",
            toText=function(x) paste(x,collapse= ","), fromText=NULL,
            canEdit=TRUE,
            buttonFun = fileBrowser, buttonText = "Browse")

  pW2 <- list(Name="BBB", Value="x,y,z",
            toText=function(x) paste(x, collapse=","), fromText=NULL,
            canEdit=TRUE, buttonFun = ls, buttonText = "List")

  pW3 <- list(Name="CCC", Value="ccc",
            toText=function(x) paste(x, collapse = ","), fromText=NULL,
            canEdit=TRUE, buttonFun=NULL,  buttonText=NULL)

  widget1 <- list(wList = list(a = pW1, b = pW2, c = pW3),
                preFun  = function() "Hi",
                postFun = function() "Bye")

  if(interactive()){
      tt <- widgetRender(widget1, "try")
      getWvalues(tt)
  }else{
      getWvalues(widget1)
  }
}
\keyword{misc}

\name{tkMIAME}
\alias{tkMIAME}
\title{Simple Interface to enter experimental design information}
\description{This function provides a widget for users to enter
  experimental design MIAME information.
}
\usage{
tkMIAME()
}
\details{
This widget provides an interface to enter experimental information following
the MIAME (Minimum Information About a Microarray Experiment) standard.

A draft of the latest document (v. 1.1) is
\url{http://www.mged.org/Workgroups/MIAME/miame_1.1.html}

Brazma et al. divide the MIAME into 6 sections
1. Experimental design, 2. Array design, 3. Samples, 4. Hybridizations,
5. Measurements, and 6. Normalization controls
This widget is for the first section.
We ask for the user to enter: experimenter name,
laboratory, contact information, a single-sentence experiment title, an
abstract describing the experiment, URLs. This slot could also include a
formal statistical description of the experimental design (e.g. using
factors). Some of this info is already stored in
\code{\link[Biobase:class.AnnotatedDataFrame]{AnnotatedDataFrame}} or
elsewhere. 

The function returns a list that is intended for the creation of an
object of class \code{\link[Biobase:class.MIAME]{MIAME}}. However, we
return a list so that the function can work independently of the Biobase
package. 
}

\value{
  A list containing entries:

   \item{ExperimentName}{character string}
   \item{LabName}{character string}
   \item{ContactInfo}{character string}
   \item{ExperimentTitle}{character string}
   \item{Description}{character string}
   \item{URL}{character string}
  
}
\references{``Minimum information about a microarray experiment
  (MIAME)-toward standards for microarray data'', A. Brazma, et al.,
  Nature Genetics, vol. 29 (December 2001), pp. 365-371,
  \url{http://www.mged.org/Workgroups/MIAME/miame_1.1.html}
}

\author{Majnu John}
\seealso{\code{\link[Biobase:class.MIAME]{MIAME}}}
\keyword{interface}

\name{dataViewer}
\alias{dataViewer}
\title{Function to view a data object passed}
\description{
  This function creates a widget to allow users to view the content of a
  data frame passed and decide whether to save the data or not.
}
\usage{
dataViewer(data, caption = "", save = TRUE)
}

\arguments{
  \item{data}{\code{data} a data frame (or alike) to be viewed}
  \item{caption}{\code{caption} a character string for the title of the
    widget}
  \item{save}{\code{save} a boolean to indicate whether to have the
    option to allow users to save the data}
}
\details{
  Taking a data frame as one of the arguments, this function builds a
  widget that allows users to view the content of the data and save the
  data as a file.
}
\value{
  This function does not return any value
}
\references{R tcltk}
\author{Jianhua Zhang}

\seealso{\code{\link{importWizard}}}
\examples{
# Create matrix
data <- matrix(1:20, ncol = 4)
if(interactive()){
    # View data using dataViewer
    dataViewer(data, "test", TRUE)
}
}
\keyword{interface}

\name{tkSampleNames}
\alias{tkSampleNames}
\title{Simple interface to associate sample names with files}
\description{
This widget provides an interface to enter names to be associated with
files containing array expression information related to a particular
sample.}
\usage{
tkSampleNames(\dots, filenames = character(0))
}
\arguments{
  \item{\dots}{ the filenames to be associated with a sample name,
    supplied individually and/or as a  character vector}
  \item{filenames}{a character vector of filenames to be associated
    with a sample name.}
}
\details{
  \code{\link[Biobase:class.AnnotatedDataFrame]{AnnotatedDataFrame-class}}
  objects will use sample names 
  as row names for its pData. The colnames of the expression matrices in
  \code{\link[Biobase:class.ExpressionSet]{ExpressionSet-class}} use
  this as well. Many times, each 
  of these columns are obtained from a file. Rather than use the,
  sometimes ugly, filename we can use the sample names that this
  interface associates with each file. 

  The function returns a character matrix intended to be used to create
  sample names in AnnotatedDataFrame and ExpressionSet. However, the
  function can be used independently of the Biobase package.
}
\value{
  A character matrix with the first column the filenames the second
  column the sample names to associate.
}
\author{Majnu John}
\seealso{\code{\link[Biobase:class.AnnotatedDataFrame]{AnnotatedDataFrame-class}}}
\keyword{interface}

\name{guess.sep}
\alias{guess.sep}
\alias{guess.header}
\alias{find.type}
\alias{charOrNum}
\alias{getRowNames}

\title{Automatically determines whether a data file has a header and
  what delimiter is used to separate data columns}
\description{
  This function reads a few lines from a data text file and determines
  whether a header exists, what the delimiter, and what data type each
  column is for a given file.
}
\usage{
guess.sep(file.name, numLine = 5, seps = "", isFile = TRUE)
guess.header(twoLines, sep)
find.type(file.name, sep, header = FALSE, numLine = 5, isFile = TRUE)
charOrNum(vect)
getRowNames(file.name, sep, header, skip)
}

\arguments{
  \item{file.name}{\code{file.name} a character string for the name of
    the file of interests}
  \item{numLine}{\code{n} an integer or character indicating the total number
    of lines to be read from the file for making the determination}
  \item{seps}{\code{seps} a vector of characters of potential delimiters
    to be used to make the determination. Default delimiters include " ",
    ",", ";", and "\\t". Anything inaddition to the default will have to
    be included in seps}
  \item{twoLines}{\code{twoLines} a vector of character string including
    the first two lines of a file that will be used to determine whether
    the file has a header}
  \item{sep}{\code{sep} a character for the delimiter used to separate
    columns in a file}
  \item{vect}{\code{vect} a vector of character or numeric string}
  \item{header}{\code{header} a boolean indicating whether a file has
    headers}
  \item{isFile}{\code{isFile} a boolean that is TRUE when
    \code{file.name} is a file or FALSE an object}
  \item{skip}{\code{skip} an integer for the number of lines to be
    skiped using \code{\link{read.table}}}
}
\details{
  guess.sep calls \code{\link{guess.sep}} and \code{\link{find.type}} to
  determine the header, delimiter, and column data type of a file.

  \code{\link{charOrNum}} determines which elements of a vector are
  numeric or character.
}
\value{
  This function returns a list containing
  \item{header}{TRUE if there is a header and FALSE otherwise}
  \item{separater}{A character string indicating the delimiter used}
  \item{type}{A vector of character strings that are either character or
    numeric} 
}
\author{Jianhua Zhang}

\seealso{\code{\link{fileWizard}}}

\examples{
# Create a temp file
tempData <- matrix(1:20, ncol = 4)
write.table(tempData, file = "tempData", quote = FALSE, sep =
"\t", row.names = FALSE, col.names = TRUE)

guess.sep("tempData")

unlink("tempData")
}
\keyword{misc}

\name{eExplorer}
\alias{eExplorer}
\alias{getExCode}
\alias{getHelpFile}
\title{A widget that allows users to explore the example code and help
  files of a given R package}
\description{
  Given a valid package name as a character string,
  \code{\link{eExplorer}} collects all the example code from the "R-ex"
  directory from the R library for that package and then displays the
  names of the code examples in a list box. When a name in the list box
  is clicked, the corresponding code will be displayed and users are
  allowed to execute the code or view the help file for the function the
  example code is for.
}
\usage{
eExplorer(pkgName, font = "arial 13", getFocus = TRUE)
getExCode(pkgName)
getHelpFile(pkgName, fileName)
}
\arguments{
  \item{pkgName}{\code{pkgName} a character string for the name of an R
    package of interest. The R package needs to be installed}
  \item{font}{\code{font} a character string for the font to be used by
    the widget to display the text. The default is "arial 13"}
  \item{fileName}{\code{fileName} a character string for the name of a
    file in "R-ex" with the ".R" extension removed. The file contains a
    chunk of example code and may have a corrsponding help file in the
    "help" directory}
   \item{getFocus}{\code{getFocus} a boolean indicating whether a widget
    should grab the focus}
}
\details{
  \code{\link{getExCode}} and \code{\link{getHelpFile}} are called by
  \code{\link{eExplorer}} to get the code examples or help help files
  contained by a given package.
}
\value{
  \code{\link{eExplorer}} does not return anything useful.
}
\references{Writing R Extension for information on "R-ex" and "help"
  directories} 
\author{Jianhua Zhang}

\seealso{\code{\link{vExplorer}}}
\examples{
  if(interactive()){
      require("Biobase") || stop("Does not run without Biobase")
      eExplorer("Biobase")
  }
}
\keyword{interface}

\name{getLightTW}
\alias{getLightTW}

\title{Function to create a light weight widget showing a text string}
\description{
  Given a text string and coordinations, this function creates a light
  weight tcltk widget with showing the text string passed.
}
\usage{
getLightTW(x, y, text)
}

\arguments{
  \item{x}{\code{x} an interger for the horizontal position for the
    widget to appear}
  \item{y}{\code{y} an integer for the vertical position for the widget
    to appear}
  \item{text}{\code{text} a character string to be show in the widget}
}
\details{
  When the function is invoked, a box containing the text will appear at
  the position specified by x, and y. Click the widget makes it disappear.
}
\value{
  This function does not return any value
}
\author{Jianhua Zhang}

\examples{
if(interactive()){
    getLightTW(200, 200, "Click Me!")
}
}
\keyword{interface}

\name{importPhenoData}
\alias{importPhenoData}
\alias{createPData}
\alias{writePDRowNames}
\alias{writePhenoTable}
\alias{makePhenoData}
\alias{convert2PData}
\alias{getOBJWidget}
\alias{objExists}
\alias{getSNCNums}
\alias{getCovarDesc}
\title{Functions to input data for an AnnotatedDataFrame object}
\description{
  This functions allow users to read data from an existing file or an R
  data.frame object and use the data frame to construct an
  AnnotatedDataFrame object. 
}
\usage{
importPhenoData(fileName, sampleNames = NULL, from = NULL)
createPData(pdata, varList)
writePDRowNames(pdata, sampleNames)
writePhenoTable(base, textWidget, pdata)
makePhenoData(pdata)
convert2PData(phenoList)
getOBJWidget(type = NULL)
objExists(name, type = NULL)
getSNCNums(sampleNames)
getCovarDesc(varList)
}
\arguments{
  \item{fileName}{a character string for the name of a file that is going to be
    used to build an AnnotatedDataFrame object.}
  \item{sampleNames}{a vector of character strings for the names of samples. The
    length of \code{sampleNames} should be the same as the number of rows of an
    existing file or data.frame if an AnnotatedDataFrame object is to be created
    based on a file or data.frame.}
  \item{pdata}{a data.frame for the experimental data.}
  \item{base}{an RTcl object for the base window a widget resides.}
  \item{textWidget}{an RTcl object for a text box widget.}
  \item{phenoList}{a list of lists for tclVar() objects.}
  \item{type}{a character string for the class of a object e.g. data.frame, AnnotatedDataFrame.}
  \item{name}{a character string for the name of an object.}
  \item{varList}{a list of characters with names being covariate names and values
    being short descriptions of covariate names.}
  \item{from}{a character string indicating how an AnnotatedDataFrame object will
    be created. "file" - create from an existing file, "object" - create from an
    existing data frame object, "edit" - create by editing an existing
    AnnotatedDataFrame object, and "new" create a new AnnotatedDataFrame object
    from scratch. NULL or any other values for \code{from} will invoke a widget
    that allows users to select one of the four means from an interface.}
}
\details{
  When import a data.frame or AnnotatedDataFrame object, the object to be
  imported should have been stored in .GlobelEnv. All the objects of
  data.frame or AnnotatedDataFrame will be made available through
  a browser.

  The main widget if \code{importPhenoData} that calls other
  functions/widgets to have the job done.

  Package Biobase is required for importPhenoData but the requirement id
  not forced as it is the only time the package is used. Users have to
  make sure that Biobase is available.
}
\value{
  An AnnotatedDataFrame object.
}
\references{AnnotatedDataFrame class in Biobase}
\author{Jianhua Zhang}
\note{This function is intended for use by function read.phenoData of Biobase}
\examples{
if(interactive()){
    importPhenoData()
}
}
\seealso{\code{\link[Biobase:class.AnnotatedDataFrame]{AnnotatedDataFrame-class}}} 
\keyword{interface}

\name{DPExplorer}
\alias{DPExplorer}
\alias{getTopLevel}
\alias{loadDataPkg}

\title{Functions constuct a widget to explore BioC's data packages}
\description{
  These functions construct a widget that allow users to visually
  explore a data package of Bioconductor and read selected elements to R
}
\usage{
DPExplorer(pkgName = "", title = "BioC Data Package Explorer", getFocus
= TRUE)
getTopLevel(title)
loadDataPkg(pkgName)
}

\arguments{
  \item{pkgName}{\code{pkgName} a character string for the name of a
    Bioconductor's data package that has already been loaded}
  \item{title}{\code{title} a character string for the title of the
    widget}
  \item{getFocus}{\code{getFocus} a boolean indicating whether a widget
    should grab the focus}
}
\details{
  If \code{pkgName} is not provided when \code{\link{DPExplorer}} is
  called, an entry box is available for users to put a \code{pkgName} in
  later. In either cases, the data package specified by \code{pkgName}
  should have been loaded.

  \code{\link{getTopLevel}} creates a top level window for the widget.

  \code{\link{loadDataPkg}} filters out valid environment objects from a
  data package.
}
\value{
  If only one key is selected, \code{\link{DPExplorer}} returns a vector
  of one to more elements. If more than one key is selected,
  \code{\link{loadDataPkg}} returns a list of vectors.

  \code{\link{getTopLevel}} returns a tkwin object for the top level
  window.

  \code{\link{loadDataPkg}} returns a vector of character strings for
  available data environments.
}
\references{Documents for a Bioconductor data package}
\author{Jianhua Zhang}

\examples{
if(interactive() && require("hgu95av2", character.only = TRUE)){
    DPExplorer("hgu95av2")
}
}
\keyword{interface}

\name{WName}
\title{Accessors for Primitive Widget Objects}
\alias{WName}
\alias{WValue}
\alias{WValue<-}
\alias{WtoText}
\alias{WfromText}
\alias{WcanEdit}
\alias{WbuttonText}
\alias{WbuttonFun}
\alias{WwList}
\alias{WwList<-}
\alias{WwList<-}
\alias{WLValue}
\alias{WLValue<-}
\alias{WRButtons}
\alias{WpreFun}
\alias{WpostFun}
\alias{WEnd}
\alias{WValue<-}
\description{
  Currently primitive widget objects (\code{pwidget}s) are implemented
  as \code{\link{list}}s, but this will change.  Users should only rely
  on these accessors functions, not the implementation.
}
\usage{
WName(x)
WValue(x)
WValue(x) <-  value
WtoText(x)
WfromText(x)
WcanEdit(x)
WbuttonText(x)
WbuttonFun(x)
WwList(x)
WwList(x) <- value
WLValue(x, index)
WLValue(x, index) <- value
WRButtons(x)
WpreFun(x)
WpostFun(x)
WEnd(x)
}
\arguments{
  \item{x}{list of lists with a Name, Value, toText, fromText,
    canEdit, buttonText, buttonFun, preFun, postFun element.}
  \item{index}{integer or character string as an index or name for
    the list in the first list of a list of lists for a widget.}
  \item{value}{An \R data type that is going to be used to update the value.}
}
\details{
  \code{WName(x)} returns the \code{Name} element of \code{x}.
  \code{WValue(x)} returns the \code{Value} element of \code{x}.
  \code{WValue(x) <- value} will change the \code{Value} element of
  \code{x} to \code{value}.

  \code{WtoText(x)} returns the \code{toText} element of \code{x}.
  \code{WfromText(x)} returns the \code{fromText} element of \code{x}.
  \code{WcanEdit(x)} returns the \code{canEdit} element of \code{x}.

  \code{WbuttonText(x)} returns the \code{buttonText} element of \code{x}.
  \code{WbuttonFun(x)} returns the \code{buttonFun} element of \code{x}.
  \code{WwList(x)} returns the \code{wList} element of \code{x}.
  \code{WwList <- value} will update the \code{wList} element of a
  Widget list with \code{value}.

%% FIXME: the following is not well understandable...
  \code{WLValue(x, index)} returns a list indicated by the
  index in the wList of a widget list.
  \code{WLValue(x, index) <- value} will update indicated
  by the index in the wList of a widget list with the value.

  \code{WpreFun(x)} returns the preFun element of \code{x}.
  \code{WpostFun(x)} returns  the post element of \code{x}.
  \code{WEnd(x)} returns  the end element of \code{x}.
}
\value{
  A character string or \R function represented by the element
  of the list whose value is to be retrieved.
}
\author{Jianhua (John) Zhang}
\seealso{\code{\link{widgetRender}} for references etc.
}
\examples{
# Create the list of lists
pW1 <- list(Name="AAA", Value="bbb",
            toText = function(x) paste(x,collapse = ","),
            fromText = NULL, canEdit = TRUE,
            buttonFun = ls, buttonText = "Browse")

widget1 <- list(wList = list(a = pW1),
                preFun = function() "Hi",
                postFun = function() "Bye")

# Call the functions
WName(pW1)
WValue(pW1)
WValue(pW1) <- "lll"
WtoText(pW1)
WfromText(pW1)
WcanEdit(pW1)
WbuttonText(pW1)
WbuttonFun(pW1)
WwList(widget1)
WwList(widget1) <- list(Name = "New list", Value = "New value")
WLValue(widget1, 1)
WLValue(widget1, 1) <- "New value"
WpreFun(widget1)
WpostFun(widget1)
WEnd(widget1)
}
\keyword{manip}

\name{dbArgsWidget}
\alias{dbArgsWidget}

\title{Function to build a widget for inputing database arguments}
\description{
  This functions creates a interactive widget to allow users to input
  arguments for database connection for Unix.
}
\usage{
dbArgsWidget()
}

\details{
  Database arguments include database name, user name, password, host
  name, and table name.
}
\value{
  The function returns a list containing the following elements:
  \item{dbname}{a charater string for the name of the database}
  \item{host}{a character string for the name or IP address of the host
    machine}
  \item{user}{a character string for the name of the user}
  \item{password}{a character string for the password}
  \item{tablename}{a character string for the name of the database table}
}
\references{Rdbi}
\author{Jianhua Zhang}

\seealso{\code{\link{argsWidget}}}
\examples{
if(interactive()){
    test <- dbArgsWidget()
}
}
\keyword{interface}

\name{vExplorer}
\alias{vExplorer}
\alias{viewVignette}

\title{An interface to interact with vignette code chunks}
\description{
  This function provides a widget for viewing, editing, and executing
  code chunks of vignettes.
}
\usage{
vExplorer(title = "BioC Vignettes Explorer", pkgName = "", font =
ifelse(.Platform$OS.type == "unix", "arial 14", "arial 11"))
viewVignette(title, packName, vigPath, font = "arial 11")
}

\arguments{
  \item{title}{character string for the name to be
    displayed as the title of the widget to interact with code chunks.}
  \item{pkgName}{vector (of length 1 for \code{pkgName}) of
    character strings for names of Bioconductor packages the code chunks
    of whose vignettes will be explored.}
  \item{packName}{same as pkgName}
  \item{vigPath}{character string for the full qualified name of a
    vignette to be explored.}
  \item{font}{a character string for the name and size of the font to be
    used for text rendered on the widgets (e. g. "arial 11")}
}
\details{
  By default, \code{packNames = ""}, all the installed packages will be
  examined and those that have vignettes will be listed to allow users
  to choose from.
}
\value{
  This function does not return any useful value.
}
\references{\url{http://www.bioconductor.org}}
\author{Jianhua Zhang}
\note{This function is part of the Bioconductor project at Dana-Faber
  Cancer Institute to provide Bioinformatics functionalities through \R.
}
\examples{
if(interactive()){
    require("DynDoc", character.only = TRUE)
    require("tools", character.only = TRUE)
    require("widgetTools", character.only = TRUE)
    vExplorer()
    path <- path.package("widgetTools")
    vigList <- pkgVignettes("widgetTools")
    viewVignette("BioC VignetteBrowser", "widgetTools", vigList$docs)
}
}
\keyword{interface}

\name{widgetRender}
\alias{widgetRender}

\title{Render a Tk Widget from Given Specifications}
\description{
  This function takes a list that specifies the appearance and behavior
  of a Tk widget and renders the widget accordingly.
}
\usage{
widgetRender(iWidget, tkTitle)
}

\arguments{
  \item{iWidget}{list of lists that specifies the appearance and
    behavior of the widget to be rendered.}
  \item{tkTitle}{character string for the text to appear in the
    title bar of the widget to be rendered.}
}
\details{
  The widget to be rendered normally consists of frames with three
  widgets arranged in a row. The first widget is normally a label for
  the name of the second widget. The second widget can be any type of
  widgets. The third widget is a button widget that defines some
  behavior to be associated with the second widget. For example, a
  button that will cause something to be displayed in the second widget
  when pressed. The third widget can be missing if no such association
  is required.

  The widget to be rendered also has two buttons at the bottom part of
  the widgets. The followings are the name and behavior of the buttons:

  \describe{
    \item{\bold{Cancel} -}{The unmodified list passed to the function at
      the time of invocation will be returned when pressed.}

    \item{\bold{End} -}{A modified version of the \code{iWidget}
      argument will be returned when pressed.  The returned list has the
      same number of elements as the original one but with the values
      modified based on the entries in corresponding widgets items.}
    }
}
\value{
  A \code{\link{list}} of lists with the original values of the passed
  modified or unmodified depending on whether the cancel or end button
  pressed.
}
\references{
  Peter Dalgaard (2001)
  A Primer on the R-Tcl/Tk Package;
  R News \bold{1} (3), 27--31
  \url{http://CRAN.R-project.org/doc/Rnews/}
}
\author{Jianhua (John) Zhang}

\seealso{\code{\link{fileBrowser}},
  \code{\link{objectBrowser}}.
}

\examples{
# Create the list to be passed
pW1 <- list(Name="AAA", Value="bbb",
            toText=function(x) paste(x,collapse= ","), fromText=NULL,
            canEdit=TRUE,
            buttonFun = fileBrowser, buttonText = "Browse")

pW2 <- list(Name="BBB", Value="x,y,z",
            toText=function(x) paste(x, collapse=","), fromText=NULL,
            canEdit=TRUE, buttonFun = ls, buttonText = "List")

pW3 <- list(Name="CCC", Value="ccc",
            toText=function(x) paste(x, collapse = ","), fromText=NULL,
            canEdit=TRUE, buttonFun=NULL,  buttonText=NULL)

widget1 <- list(wList = list(a = pW1, b = pW2, c = pW3),
                preFun  = function() "Hi",
                postFun = function() "Bye")

# Call the function
if(interactive()){
    x <- widgetRender(widget1, "Test Widget")
    str(x)
}
}
\keyword{interface}

\name{objectBrowser}
\alias{objectBrowser}

\title{View the Objects in the Workspace}
\description{
  This widget allows uers to view and select objects from the
  workspace. When the \code{End} button is pressed, the selected objects
  will be returned as a list. 
}
\usage{
objectBrowser(env = .GlobalEnv,fun = noAuto, textToShow = "Select object(s)", nSelect = -1)  
}
\arguments{
  \item{fun}{function to test whether certain conditions are met by
    the objects.  Only objects that meet the conditions will be displayed.}
  \item{textToShow}{character with the message to be shown on the
    widget as an instruction.}
  \item{nSelect}{integer indicating the number of objects to select.
    No limitation if \code{nSelect = -1} as per default.}
  \item{env}{\code{env} a default environment object to start object Browser}
}
\details{
  This function will return a list of lists with a "name" and "obj" pair
  for each object selected. The "name" will be the name of the object
  and "obj" will be the value of the object. If the object is a package, a
  description of the contents of the package will be the value. If the
  selected object is a function, a text string of the original code will
  be the value. A function can be passed to impose a filtering mechanisms
  on the objects to be displayed. See function isCharacter for an
  example of writing a filtering function for objectBrowser.

  The buttons and their expected behavior are
  \describe{
    \item{\code{Up}}{Moves one level up along the search list and
      displays the content in the box for object names on the left of the
      widget.}

    \item{\code{Select \>\>}}{When objects in the box for object names
      have been highlighted by clicking or clicking/dragging, this
      button will display the highlighted object names in the box
      for selected objects on the right.}

    \item{\code{Reset}}{Moves back to \code{\link{.GlobalEnv}} which
      is the default starting point of the system.}

    \item{\code{\<\< Remove}}{When object names in the box for selected
      objects have been highlighted by clicking or clicking/dragging and
      this button is pressed, the highlighted object names will be removed
      from the display.}

    \item{\code{Clear}}{Removes all the object names from the box for
      selected objects.}

    \item{\code{Cancel}}{Exits the widget and returns \code{NULL} when
      pressed.}

    \item{\code{End}}{Returns a \code{list} of lists with names of the
      objects in the box for selected objects and their corresponding values
      or \code{NULL} if nothing exists in the box.}
  }
}
\value{
  A \code{\link{list}} of lists with a name and value pair for each object.
}
\author{Jianhua (John) Zhang}

\examples{
## The example here is only run interactively since it requires user
## interference which may cause problems if not available:
if(interactive()) {

# Call the function with the isCharacter function.
r <- objectBrowser()
str(r) # show what we've got
}
}
\keyword{interface}

\name{values.Widget}
\alias{values.Widget}
\alias{print.Widget}
\alias{print.pWidget}
\title{Deal with Names and Values of Widget Created by widgetRender()}
\description{
  Functions in this group print or list the names or/and values of the
  widget elements on a widget created by \code{\link{widgetRender}()}.
}
\usage{
values.Widget(x)
}

\arguments{
  \item{x}{A list (print.pWidget) or list of lists(print.Widget,
    values.Widget) that representing a widget element (list) on a widget
    or a widget (list of lists) generated by using the function widgetRender.}
}
\details{
  print.pWidget takes a list defining a widget element on a widget
  generated by using the function widgetREnder. An example of a valid
  list will be:

  pW1 <- list(Name="AAA", Value="bbb", toText=function(x)
  paste(x,collapse = ","), fromText=NULL, canEdit=TRUE, buttonFun =
  fileBrowser, buttonText = "Browse")

  print.Widget and values.Widget take a list of lists defining all the
  widget elements on a widget generated using the function
  widgetRender. An example of a valid list will be:

  pW1 <- list(Name="AAA", Value="bbb", toText=function(x)
  paste(x,collapse = ","), fromText=NULL, canEdit=TRUE, buttonFun =
  fileBrowser, buttonText = "Browse")

  pW2 <- list(Name="BBB", Value="x,y,z", toText=function(x) paste(x,
  sep=","), fromText=NULL, canEdit=TRUE, buttonFun = ls,  buttonText = "List")

  pW3 <- list(Name="CCC", Value="ccc", toText=function(x) paste(x,
  collapse = ","), fromText=NULL, canEdit=TRUE, buttonFun=NULL,
  buttonText=NULL)

  widget1 <- list(wList = list(a = pW1, b = pW2, c = pW3), preFun =
  function() "Hi", postFun = function() "Bye")

}
\value{
  \item{returnList}{values.Widget returns a list of lists each with the
    name and value of an entry box on the widget created.}
}

\author{Jianhua (John) Zhang}

\seealso{\code{\link{widgetRender}}}

\examples{
# Create the lists and list of lists
  pW1 <- list(Name="AAA", Value="bbb",
              toText=function(x) paste(x,collapse = ","),
              fromText=NULL, canEdit=TRUE, buttonFun = fileBrowser,
              buttonText = "Browse")

  pW2 <- list(Name="BBB", Value="x,y,z", toText=function(x) paste(x, sep=","),
            fromText=NULL, canEdit=TRUE, buttonFun = ls,
           buttonText = "List")

  pW3 <- list(Name="CCC", Value="ccc",
              toText=function(x) paste(x, collapse = ","),
              fromText=NULL, canEdit=TRUE, buttonFun=NULL,
              buttonText=NULL)

  widget1 <- list(wList = list(a = pW1, b = pW2, c = pW3),
                  preFun = function() "Hi",
                  postFun = function() "Bye")

# Define the classes
class(pW1) <- c("pWidget", "textbox")
class(widget1) <- "Widget"

# Call the funcitons
print.pWidget(pW1)
print.Widget(widget1)
values.Widget(widget1)
}
\keyword{manip}

\name{stdType}
\alias{stdType}
\alias{stdView}
\title{Provide Default Behavior for listSelect Helper Functions}
\description{
  The function \code{\link{listSelect}} takes two functions which define
  how the type information and content of \R objects will be shown on
  the widget created by \code{listSelect}.
  Functions \code{stdType()} and \code{stdView()} provide the default
  behavior.
}
\usage{
stdType(toCheck)
stdView(toView)
}
\arguments{
  \item{toCheck, toView}{arbitrary \R object.}
}
\details{
  These functions can be viewed as exmaples of defining functions for
  the \code{typeFun} and \code{valueFun} arguments of the
  \code{\link{listSelect}} function.
}
\value{
  %% FIXME:
  \code{stdType()} returns a character string describing the type of the
  \R object.

  \code{stdView()}
}
\author{Jianhua Zhang}

\seealso{\code{\link{listSelect}}}

\examples{
stdType(123)
stdType("What am I")

str(mydf <- data.frame(x = 2:8, ch = letters[1:7]))
stdType(mydf)# "list"
stdType(stdType)

if(interactive()) {## stdView() needs UI:
  stdView(1:10)
  stdView(mydf)
 }
}
\keyword{misc}

\name{fileWizard}
\alias{fileWizard}

\title{A function that import a text file into R}
\description{
  Given a file name, this function imports the text file into R.
}
\usage{
fileWizard(filename = "", fun = read.table, file = "file",
basic = c("header", "sep"), getFocus = TRUE)
}

\arguments{
  \item{filename}{A character string for the name of the text file to be
    imported}
  \item{fun}{An R function that is going to be used to read the
    file. Default to    \code{\link{read.table}}}
  \item{file}{A character string for the name of the argument to fun
    that defines the name of the file to be read}
  \item{basic}{A vector of character strings for names of the arguments
    to fun that will have separate entry boxes on the widget to be
    produced. Default to "header" and "sep"}
  \item{getFocus}{\code{getFocus} a boolean indicating whether a widget
    should grab the focus}
}
\details{
  This function is only partially finished and will be improved soon. It
  currently allows uesrs to view a given file and change the settings
  for header and sep arguments of read.table. A file will be read in
  based on the values of the two arguments and return.
}
\value{
  This function returns a data frame for the file read in.
}
\references{R News Vol. 1/3, September 2001}
\author{Jianhua Zhang}

\seealso{\code{\link{fileBrowser}}}

\examples{
if(interactive()) {
  # Only the interface is displyed as no real file is given
  fileWizard()  
}
}
\keyword{interface}

\name{argsWidget}
\alias{argsWidget}
\alias{getPWidget}
\alias{formatArg}
\alias{getSymbol}
\alias{funcs2Char}
\alias{getTrueNullNa}
\title{Functions to construct a widget that takes inputs from users}
\description{
   Given a argument list, the functions construct a widget to allow
   users to entry or select values for arguments defined by the names of
   the argument list.
}
\usage{
argsWidget(argsList, defaultNames, inst = "")
getPWidget(argsList, PWEnv, inst = "")
formatArg(toFormat)
getSymbol(args)
funcs2Char(args,funcs)
getTrueNullNa(toFormat)
}

\arguments{
  \item{argsList}{\code{argsList} a list of arguments with or without
    default values. The list can be derived from
    e.g. \code{\link{formals}}}
  \item{PWEnv}{\code{PWEnv} an R environment used object to store data for
    the argument list}
  \item{toFormat}{\code{toFormat} element to be formated by
    \code{\link{formatArg}}}
  \item{args}{\code{args} arguments to be formated}
  \item{funcs}{\code{funcs} a list containing the arguments that are
    functions}
  \item{defaultNames}{\code{defaultNames} a vector of character strings
    of length 2 for two default buttons to be rendered. The first one is
    to end the process and the second to abort the process}
  \item{inst}{\code{inst} a character string for a short instuction that
    will appear on the top of a widget}
}
\details{
  \code{\link{argsWidget}} builds a widget with widget elements to allow
  users to input values for the arguments.

  \code{\link{getPWidget}} instatiates primary widgets that will be used
  to construct the widget for argements.

  \code{\link{formatArg}} formats the value for a given argument so that
  the calue can be displayed by a tcltk widget.

  \code{\link{getSymbol}} filters out functions from the argument list.

  \code{\link{funcs2Char}} converts functions to character
  representations of the functions.

  \code{\link{getTrueNullNa}} converts string "true", "false", "null",
  and "na" to R primitives for these items.
}
\value{
  \code{\link{argsWidget}} returns a list with user input values for
  elements of the argument list passed.

  \code{\link{getPWidget}} returns a list of primary widgets.

  \code{\link{formatArg}} returns a list containing the formated values.

  \code{\link{getSymbol}} returns a list containing arguments that are
  functions.

  \code{\link{funcs2Char}} returns a list containing character
  representations of functions.

   \code{\link{getTrueNullNa}} returns an R object.
}
\references{R tcltk}
\author{Jianhua Zhang}

\examples{
  if(interactive()){
      argsWidget(list("Entry with default" = "default",
                      "Entry without default" = ""))
  }
}
\keyword{interface}

\name{objNameToList}
\alias{objNameToList}

\title{Convert Object Names to List of Lists with (name, object) Pairs}
\description{
  This function supports \code{\link{objectBrowser}} by converting a
  vector of selected object names to a list of lists with object names
  and the corresponding objects. 
}
\usage{
objNameToList(objNames, env)
}
\arguments{
  \item{objNames}{character vector giving the names of objects.}
  \item{env}{an R environment where R objects are stored}
}
\details{
  Each list in the list that is going to be returned contains a name for
  the object and the real value of the object. If the object name is a
  package name, the contents of the package will be the value associated
  with the package name.
}
\value{
  A list of lists each with a \code{name} and an \code{obj} component.
}

\author{Jianhua (John) Zhang}

\seealso{\code{\link{objectBrowser}}}

\examples{
# Create two R objects
obj1 <- c("aaa", "bbb", "ccc")
env1 <- new.env(parent = baseenv())

# Get a list containing the two objects
nl <- objNameToList(c("obj1", "env1"), parent.frame())
str(nl)

}
\keyword{manip}
